# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Full fledged AHRS with 9 degrees of freedom
  class BrickIMUV2 < Device
    DEVICE_IDENTIFIER = 18 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IMU Brick 2.0' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_acceleration_period. The parameters are the acceleration
    # for the x, y and z axis.
    CALLBACK_ACCELERATION = 32

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_magnetic_field_period. The parameters are the magnetic
    # field for the x, y and z axis.
    CALLBACK_MAGNETIC_FIELD = 33

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_angular_velocity_period. The parameters are the angular
    # velocity for the x, y and z axis.
    CALLBACK_ANGULAR_VELOCITY = 34

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_temperature_period. The parameter is the temperature.
    CALLBACK_TEMPERATURE = 35

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_linear_acceleration_period. The parameters are the
    # linear acceleration for the x, y and z axis.
    CALLBACK_LINEAR_ACCELERATION = 36

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_gravity_vector_period. The parameters gravity vector
    # for the x, y and z axis.
    CALLBACK_GRAVITY_VECTOR = 37

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_orientation_period. The parameters are the orientation
    # (heading (yaw), roll, pitch) of the IMU Brick in Euler angles. See
    # BrickIMUV2#get_orientation for details.
    CALLBACK_ORIENTATION = 38

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_quaternion_period. The parameters are the orientation
    # (w, x, y, z) of the IMU Brick in quaternions. See BrickIMUV2#get_quaternion
    # for details.
    CALLBACK_QUATERNION = 39

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_all_data_period. The parameters are as for
    # BrickIMUV2#get_all_data.
    CALLBACK_ALL_DATA = 40

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD = 2 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY = 3 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 4 # :nodoc:
    FUNCTION_GET_ORIENTATION = 5 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION = 6 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR = 7 # :nodoc:
    FUNCTION_GET_QUATERNION = 8 # :nodoc:
    FUNCTION_GET_ALL_DATA = 9 # :nodoc:
    FUNCTION_LEDS_ON = 10 # :nodoc:
    FUNCTION_LEDS_OFF = 11 # :nodoc:
    FUNCTION_ARE_LEDS_ON = 12 # :nodoc:
    FUNCTION_SAVE_CALIBRATION = 13 # :nodoc:
    FUNCTION_SET_ACCELERATION_PERIOD = 14 # :nodoc:
    FUNCTION_GET_ACCELERATION_PERIOD = 15 # :nodoc:
    FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 16 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 17 # :nodoc:
    FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 18 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 19 # :nodoc:
    FUNCTION_SET_TEMPERATURE_PERIOD = 20 # :nodoc:
    FUNCTION_GET_TEMPERATURE_PERIOD = 21 # :nodoc:
    FUNCTION_SET_ORIENTATION_PERIOD = 22 # :nodoc:
    FUNCTION_GET_ORIENTATION_PERIOD = 23 # :nodoc:
    FUNCTION_SET_LINEAR_ACCELERATION_PERIOD = 24 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION_PERIOD = 25 # :nodoc:
    FUNCTION_SET_GRAVITY_VECTOR_PERIOD = 26 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR_PERIOD = 27 # :nodoc:
    FUNCTION_SET_QUATERNION_PERIOD = 28 # :nodoc:
    FUNCTION_GET_QUATERNION_PERIOD = 29 # :nodoc:
    FUNCTION_SET_ALL_DATA_PERIOD = 30 # :nodoc:
    FUNCTION_GET_ALL_DATA_PERIOD = 31 # :nodoc:
    FUNCTION_SET_SENSOR_CONFIGURATION = 41 # :nodoc:
    FUNCTION_GET_SENSOR_CONFIGURATION = 42 # :nodoc:
    FUNCTION_SET_SENSOR_FUSION_MODE = 43 # :nodoc:
    FUNCTION_GET_SENSOR_FUSION_MODE = 44 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 231 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 232 # :nodoc:
    FUNCTION_GET_SEND_TIMEOUT_COUNT = 233 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE = 234 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE = 235 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 237 # :nodoc:
    FUNCTION_ENABLE_STATUS_LED = 238 # :nodoc:
    FUNCTION_DISABLE_STATUS_LED = 239 # :nodoc:
    FUNCTION_IS_STATUS_LED_ENABLED = 240 # :nodoc:
    FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_BRICKLET_PLUGIN = 246 # :nodoc:
    FUNCTION_READ_BRICKLET_PLUGIN = 247 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    MAGNETOMETER_RATE_2HZ = 0 # :nodoc:
    MAGNETOMETER_RATE_6HZ = 1 # :nodoc:
    MAGNETOMETER_RATE_8HZ = 2 # :nodoc:
    MAGNETOMETER_RATE_10HZ = 3 # :nodoc:
    MAGNETOMETER_RATE_15HZ = 4 # :nodoc:
    MAGNETOMETER_RATE_20HZ = 5 # :nodoc:
    MAGNETOMETER_RATE_25HZ = 6 # :nodoc:
    MAGNETOMETER_RATE_30HZ = 7 # :nodoc:
    GYROSCOPE_RANGE_2000DPS = 0 # :nodoc:
    GYROSCOPE_RANGE_1000DPS = 1 # :nodoc:
    GYROSCOPE_RANGE_500DPS = 2 # :nodoc:
    GYROSCOPE_RANGE_250DPS = 3 # :nodoc:
    GYROSCOPE_RANGE_125DPS = 4 # :nodoc:
    GYROSCOPE_BANDWIDTH_523HZ = 0 # :nodoc:
    GYROSCOPE_BANDWIDTH_230HZ = 1 # :nodoc:
    GYROSCOPE_BANDWIDTH_116HZ = 2 # :nodoc:
    GYROSCOPE_BANDWIDTH_47HZ = 3 # :nodoc:
    GYROSCOPE_BANDWIDTH_23HZ = 4 # :nodoc:
    GYROSCOPE_BANDWIDTH_12HZ = 5 # :nodoc:
    GYROSCOPE_BANDWIDTH_64HZ = 6 # :nodoc:
    GYROSCOPE_BANDWIDTH_32HZ = 7 # :nodoc:
    ACCELEROMETER_RANGE_2G = 0 # :nodoc:
    ACCELEROMETER_RANGE_4G = 1 # :nodoc:
    ACCELEROMETER_RANGE_8G = 2 # :nodoc:
    ACCELEROMETER_RANGE_16G = 3 # :nodoc:
    ACCELEROMETER_BANDWIDTH_7_81HZ = 0 # :nodoc:
    ACCELEROMETER_BANDWIDTH_15_63HZ = 1 # :nodoc:
    ACCELEROMETER_BANDWIDTH_31_25HZ = 2 # :nodoc:
    ACCELEROMETER_BANDWIDTH_62_5HZ = 3 # :nodoc:
    ACCELEROMETER_BANDWIDTH_125HZ = 4 # :nodoc:
    ACCELEROMETER_BANDWIDTH_250HZ = 5 # :nodoc:
    ACCELEROMETER_BANDWIDTH_500HZ = 6 # :nodoc:
    ACCELEROMETER_BANDWIDTH_1000HZ = 7 # :nodoc:
    SENSOR_FUSION_OFF = 0 # :nodoc:
    SENSOR_FUSION_ON = 1 # :nodoc:
    SENSOR_FUSION_ON_WITHOUT_MAGNETOMETER = 2 # :nodoc:
    SENSOR_FUSION_ON_WITHOUT_FAST_MAGNETOMETER_CALIBRATION = 3 # :nodoc:
    COMMUNICATION_METHOD_NONE = 0 # :nodoc:
    COMMUNICATION_METHOD_USB = 1 # :nodoc:
    COMMUNICATION_METHOD_SPI_STACK = 2 # :nodoc:
    COMMUNICATION_METHOD_CHIBI = 3 # :nodoc:
    COMMUNICATION_METHOD_RS485 = 4 # :nodoc:
    COMMUNICATION_METHOD_WIFI = 5 # :nodoc:
    COMMUNICATION_METHOD_ETHERNET = 6 # :nodoc:
    COMMUNICATION_METHOD_WIFI_V2 = 7 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 3]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_QUATERNION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LEDS_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LEDS_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_ARE_LEDS_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SAVE_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_LINEAR_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GRAVITY_VECTOR_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_FUSION_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_FUSION_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SEND_TIMEOUT_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = [14, 's s s']
      @callback_formats[CALLBACK_MAGNETIC_FIELD] = [14, 's s s']
      @callback_formats[CALLBACK_ANGULAR_VELOCITY] = [14, 's s s']
      @callback_formats[CALLBACK_TEMPERATURE] = [9, 'c']
      @callback_formats[CALLBACK_LINEAR_ACCELERATION] = [14, 's s s']
      @callback_formats[CALLBACK_GRAVITY_VECTOR] = [14, 's s s']
      @callback_formats[CALLBACK_ORIENTATION] = [14, 's s s']
      @callback_formats[CALLBACK_QUATERNION] = [16, 's s s s']
      @callback_formats[CALLBACK_ALL_DATA] = [54, 's3 s3 s3 s3 s4 s3 s3 c C']

      @ipcon.add_device self
    end

    # Returns the calibrated acceleration from the accelerometer for the
    # x, y and z axis. The acceleration is in the range configured with
    # BrickIMUV2#set_sensor_configuration.
    # 
    # If you want to get the acceleration periodically, it is recommended
    # to use the CALLBACK_ACCELERATION callback and set the period with
    # BrickIMUV2#set_acceleration_period.
    def get_acceleration
      check_validity

      send_request FUNCTION_GET_ACCELERATION, [], '', 14, 's s s'
    end

    # Returns the calibrated magnetic field from the magnetometer for the
    # x, y and z axis.
    # 
    # If you want to get the magnetic field periodically, it is recommended
    # to use the CALLBACK_MAGNETIC_FIELD callback and set the period with
    # BrickIMUV2#set_magnetic_field_period.
    def get_magnetic_field
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD, [], '', 14, 's s s'
    end

    # Returns the calibrated angular velocity from the gyroscope for the
    # x, y and z axis. The angular velocity is in the range configured with
    # BrickIMUV2#set_sensor_configuration.
    # 
    # If you want to get the angular velocity periodically, it is recommended
    # to use the CALLBACK_ANGULAR_VELOCITY acallback nd set the period with
    # BrickIMUV2#set_angular_velocity_period.
    def get_angular_velocity
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY, [], '', 14, 's s s'
    end

    # Returns the temperature of the IMU Brick.
    # The temperature is measured in the core of the BNO055 IC, it is not the
    # ambient temperature
    def get_temperature
      check_validity

      send_request FUNCTION_GET_TEMPERATURE, [], '', 9, 'c'
    end

    # Returns the current orientation (heading, roll, pitch) of the IMU Brick as
    # independent Euler angles. Note that Euler angles always
    # experience a `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__.
    # We recommend that you use quaternions instead, if you need the absolute
    # orientation.
    # 
    # If you want to get the orientation periodically, it is recommended
    # to use the CALLBACK_ORIENTATION callback and set the period with
    # BrickIMUV2#set_orientation_period.
    def get_orientation
      check_validity

      send_request FUNCTION_GET_ORIENTATION, [], '', 14, 's s s'
    end

    # Returns the linear acceleration of the IMU Brick for the
    # x, y and z axis. The acceleration is in the range configured with
    # BrickIMUV2#set_sensor_configuration.
    # 
    # The linear acceleration is the acceleration in each of the three
    # axis of the IMU Brick with the influences of gravity removed.
    # 
    # It is also possible to get the gravity vector with the influence of linear
    # acceleration removed, see BrickIMUV2#get_gravity_vector.
    # 
    # If you want to get the linear acceleration periodically, it is recommended
    # to use the CALLBACK_LINEAR_ACCELERATION callback and set the period with
    # BrickIMUV2#set_linear_acceleration_period.
    def get_linear_acceleration
      check_validity

      send_request FUNCTION_GET_LINEAR_ACCELERATION, [], '', 14, 's s s'
    end

    # Returns the current gravity vector of the IMU Brick for the
    # x, y and z axis.
    # 
    # The gravity vector is the acceleration that occurs due to gravity.
    # Influences of additional linear acceleration are removed.
    # 
    # It is also possible to get the linear acceleration with the influence
    # of gravity removed, see BrickIMUV2#get_linear_acceleration.
    # 
    # If you want to get the gravity vector periodically, it is recommended
    # to use the CALLBACK_GRAVITY_VECTOR callback and set the period with
    # BrickIMUV2#set_gravity_vector_period.
    def get_gravity_vector
      check_validity

      send_request FUNCTION_GET_GRAVITY_VECTOR, [], '', 14, 's s s'
    end

    # Returns the current orientation (w, x, y, z) of the IMU Brick as
    # `quaternions <https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation>`__.
    # 
    # You have to divide the return values by 16383 (14 bit) to get
    # the usual range of -1.0 to +1.0 for quaternions.
    # 
    # If you want to get the quaternions periodically, it is recommended
    # to use the CALLBACK_QUATERNION callback and set the period with
    # BrickIMUV2#set_quaternion_period.
    def get_quaternion
      check_validity

      send_request FUNCTION_GET_QUATERNION, [], '', 16, 's s s s'
    end

    # Return all of the available data of the IMU Brick.
    # 
    # * acceleration (see BrickIMUV2#get_acceleration)
    # * magnetic field (see BrickIMUV2#get_magnetic_field)
    # * angular velocity (see BrickIMUV2#get_angular_velocity)
    # * Euler angles (see BrickIMUV2#get_orientation)
    # * quaternion (see BrickIMUV2#get_quaternion)
    # * linear acceleration (see BrickIMUV2#get_linear_acceleration)
    # * gravity vector (see BrickIMUV2#get_gravity_vector)
    # * temperature (see BrickIMUV2#get_temperature)
    # * calibration status (see below)
    # 
    # The calibration status consists of four pairs of two bits. Each pair
    # of bits represents the status of the current calibration.
    # 
    # * bit 0-1: Magnetometer
    # * bit 2-3: Accelerometer
    # * bit 4-5: Gyroscope
    # * bit 6-7: System
    # 
    # A value of 0 means for "not calibrated" and a value of 3 means
    # "fully calibrated". In your program you should always be able to
    # ignore the calibration status, it is used by the calibration
    # window of the Brick Viewer and it can be ignored after the first
    # calibration. See the documentation in the calibration window for
    # more information regarding the calibration of the IMU Brick.
    # 
    # If you want to get the data periodically, it is recommended
    # to use the CALLBACK_ALL_DATA callback and set the period with
    # BrickIMUV2#set_all_data_period.
    def get_all_data
      check_validity

      send_request FUNCTION_GET_ALL_DATA, [], '', 54, 's3 s3 s3 s3 s4 s3 s3 c C'
    end

    # Turns the orientation and direction LEDs of the IMU Brick on.
    def leds_on
      check_validity

      send_request FUNCTION_LEDS_ON, [], '', 8, ''
    end

    # Turns the orientation and direction LEDs of the IMU Brick off.
    def leds_off
      check_validity

      send_request FUNCTION_LEDS_OFF, [], '', 8, ''
    end

    # Returns *true* if the orientation and direction LEDs of the IMU Brick
    # are on, *false* otherwise.
    def are_leds_on
      check_validity

      send_request FUNCTION_ARE_LEDS_ON, [], '', 9, '?'
    end

    # A call of this function saves the current calibration to be used
    # as a starting point for the next restart of continuous calibration
    # of the IMU Brick.
    # 
    # A return value of *true* means that the calibration could be used and
    # *false* means that it could not be used (this happens if the calibration
    # status is not "fully calibrated").
    # 
    # This function is used by the calibration window of the Brick Viewer, you
    # should not need to call it in your program.
    def save_calibration
      check_validity

      send_request FUNCTION_SAVE_CALIBRATION, [], '', 9, '?'
    end

    # Sets the period with which the CALLBACK_ACCELERATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_acceleration_period(period)
      check_validity

      send_request FUNCTION_SET_ACCELERATION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_acceleration_period.
    def get_acceleration_period
      check_validity

      send_request FUNCTION_GET_ACCELERATION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_MAGNETIC_FIELD callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_magnetic_field_period(period)
      check_validity

      send_request FUNCTION_SET_MAGNETIC_FIELD_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_magnetic_field_period.
    def get_magnetic_field_period
      check_validity

      send_request FUNCTION_GET_MAGNETIC_FIELD_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ANGULAR_VELOCITY callback is
    # triggered periodically. A value of 0 turns the callback off.
    def set_angular_velocity_period(period)
      check_validity

      send_request FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_angular_velocity_period.
    def get_angular_velocity_period
      check_validity

      send_request FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_temperature_period(period)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_temperature_period.
    def get_temperature_period
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ORIENTATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_orientation_period(period)
      check_validity

      send_request FUNCTION_SET_ORIENTATION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_orientation_period.
    def get_orientation_period
      check_validity

      send_request FUNCTION_GET_ORIENTATION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_LINEAR_ACCELERATION callback is
    # triggered periodically. A value of 0 turns the callback off.
    def set_linear_acceleration_period(period)
      check_validity

      send_request FUNCTION_SET_LINEAR_ACCELERATION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_linear_acceleration_period.
    def get_linear_acceleration_period
      check_validity

      send_request FUNCTION_GET_LINEAR_ACCELERATION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_GRAVITY_VECTOR callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_gravity_vector_period(period)
      check_validity

      send_request FUNCTION_SET_GRAVITY_VECTOR_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_gravity_vector_period.
    def get_gravity_vector_period
      check_validity

      send_request FUNCTION_GET_GRAVITY_VECTOR_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_QUATERNION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_quaternion_period(period)
      check_validity

      send_request FUNCTION_SET_QUATERNION_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_quaternion_period.
    def get_quaternion_period
      check_validity

      send_request FUNCTION_GET_QUATERNION_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ALL_DATA callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_all_data_period(period)
      check_validity

      send_request FUNCTION_SET_ALL_DATA_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickIMUV2#set_all_data_period.
    def get_all_data_period
      check_validity

      send_request FUNCTION_GET_ALL_DATA_PERIOD, [], '', 12, 'L'
    end

    # Sets the available sensor configuration for the Magnetometer, Gyroscope and
    # Accelerometer. The Accelerometer Range is user selectable in all fusion modes,
    # all other configurations are auto-controlled in fusion mode.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_sensor_configuration(magnetometer_rate, gyroscope_range, gyroscope_bandwidth, accelerometer_range, accelerometer_bandwidth)
      check_validity

      send_request FUNCTION_SET_SENSOR_CONFIGURATION, [magnetometer_rate, gyroscope_range, gyroscope_bandwidth, accelerometer_range, accelerometer_bandwidth], 'C C C C C', 8, ''
    end

    # Returns the sensor configuration as set by BrickIMUV2#set_sensor_configuration.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_sensor_configuration
      check_validity

      send_request FUNCTION_GET_SENSOR_CONFIGURATION, [], '', 13, 'C C C C C'
    end

    # If the fusion mode is turned off, the functions BrickIMUV2#get_acceleration,
    # BrickIMUV2#get_magnetic_field and BrickIMUV2#get_angular_velocity return uncalibrated
    # and uncompensated sensor data. All other sensor data getters return no data.
    # 
    # Since firmware version 2.0.6 you can also use a fusion mode without magnetometer.
    # In this mode the calculated orientation is relative (with magnetometer it is
    # absolute with respect to the earth). However, the calculation can't be influenced
    # by spurious magnetic fields.
    # 
    # Since firmware version 2.0.13 you can also use a fusion mode without fast
    # magnetometer calibration. This mode is the same as the normal fusion mode,
    # but the fast magnetometer calibration is turned off. So to find the orientation
    # the first time will likely take longer, but small magnetic influences might
    # not affect the automatic calibration as much.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_sensor_fusion_mode(mode)
      check_validity

      send_request FUNCTION_SET_SENSOR_FUSION_MODE, [mode], 'C', 8, ''
    end

    # Returns the sensor fusion mode as set by BrickIMUV2#set_sensor_fusion_mode.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_sensor_fusion_mode
      check_validity

      send_request FUNCTION_GET_SENSOR_FUSION_MODE, [], '', 9, 'C'
    end

    # The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    # enabled, the Brick will try to adapt the baudrate for the communication
    # between Bricks and Bricklets according to the amount of data that is transferred.
    # 
    # The baudrate will be increased exponentially if lots of data is sent/received and
    # decreased linearly if little data is sent/received.
    # 
    # This lowers the baudrate in applications where little data is transferred (e.g.
    # a weather station) and increases the robustness. If there is lots of data to transfer
    # (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    # 
    # In cases where some data has to transferred as fast as possible every few seconds
    # (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    # the dynamic baudrate off to get the highest possible performance.
    # 
    # The maximum value of the baudrate can be set per port with the function
    # BrickIMUV2#set_spitfp_baudrate. If the dynamic baudrate is disabled, the baudrate
    # as set by BrickIMUV2#set_spitfp_baudrate will be used statically.
    # 
    # .. versionadded:: 2.0.10$nbsp;(Firmware)
    def set_spitfp_baudrate_config(enable_dynamic_baudrate, minimum_dynamic_baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, [enable_dynamic_baudrate, minimum_dynamic_baudrate], '? L', 8, ''
    end

    # Returns the baudrate config, see BrickIMUV2#set_spitfp_baudrate_config.
    # 
    # .. versionadded:: 2.0.10$nbsp;(Firmware)
    def get_spitfp_baudrate_config
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, [], '', 13, '? L'
    end

    # Returns the timeout count for the different communication methods.
    # 
    # The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
    # 
    # This function is mostly used for debugging during development, in normal operation
    # the counters should nearly always stay at 0.
    # 
    # .. versionadded:: 2.0.7$nbsp;(Firmware)
    def get_send_timeout_count(communication_method)
      check_validity

      send_request FUNCTION_GET_SEND_TIMEOUT_COUNT, [communication_method], 'C', 12, 'L'
    end

    # Sets the baudrate for a specific Bricklet port.
    # 
    # If you want to increase the throughput of Bricklets you can increase
    # the baudrate. If you get a high error count because of high
    # interference (see BrickIMUV2#get_spitfp_error_count) you can decrease the
    # baudrate.
    # 
    # If the dynamic baudrate feature is enabled, the baudrate set by this
    # function corresponds to the maximum baudrate (see BrickIMUV2#set_spitfp_baudrate_config).
    # 
    # Regulatory testing is done with the default baudrate. If CE compatibility
    # or similar is necessary in you applications we recommend to not change
    # the baudrate.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_spitfp_baudrate(bricklet_port, baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE, [bricklet_port, baudrate], 'k L', 8, ''
    end

    # Returns the baudrate for a given Bricklet port, see BrickIMUV2#set_spitfp_baudrate.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_spitfp_baudrate(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE, [bricklet_port], 'k', 12, 'L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Brick side. All
    # Bricklets have a similar function that returns the errors on the Bricklet side.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_spitfp_error_count(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [bricklet_port], 'k', 24, 'L L L L'
    end

    # Enables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    def enable_status_led
      check_validity

      send_request FUNCTION_ENABLE_STATUS_LED, [], '', 8, ''
    end

    # Disables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    def disable_status_led
      check_validity

      send_request FUNCTION_DISABLE_STATUS_LED, [], '', 8, ''
    end

    # Returns *true* if the status LED is enabled, *false* otherwise.
    def is_status_led_enabled
      check_validity

      send_request FUNCTION_IS_STATUS_LED_ENABLED, [], '', 9, '?'
    end

    # Returns the firmware and protocol version and the name of the Bricklet for a
    # given port.
    # 
    # This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
    # plugins.
    def get_protocol1_bricklet_name(port)
      check_validity

      send_request FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, [port], 'k', 52, 'C C3 Z40'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has an
    # accuracy of ±15%. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Brick. Calling this function
    # on a Brick inside of a stack will reset the whole stack.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes 32 bytes of firmware to the bricklet attached at the given port.
    # The bytes are written to the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_bricklet_plugin(port, offset, chunk)
      check_validity

      send_request FUNCTION_WRITE_BRICKLET_PLUGIN, [port, offset, chunk], 'k C C32', 8, ''
    end

    # Reads 32 bytes of firmware from the bricklet attached at the given port.
    # The bytes are read starting at the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def read_bricklet_plugin(port, offset)
      check_validity

      send_request FUNCTION_READ_BRICKLET_PLUGIN, [port, offset], 'k C', 40, 'C32'
    end

    # Returns the UID, the UID where the Brick is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position is the position in the stack from '0' (bottom) to '8' (top).
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
