# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Basis to build stacks and has 4 Bricklet ports
  class BrickMaster < Device
    DEVICE_IDENTIFIER = 13 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Master Brick' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickMaster#set_stack_current_callback_period. The parameter is the current
    # of the sensor.
    # 
    # The CALLBACK_STACK_CURRENT callback is only triggered if the current has changed
    # since the last triggering.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_STACK_CURRENT = 59

    # This callback is triggered periodically with the period that is set by
    # BrickMaster#set_stack_voltage_callback_period. The parameter is the voltage
    # of the sensor.
    # 
    # The CALLBACK_STACK_VOLTAGE callback is only triggered if the voltage has changed
    # since the last triggering.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_STACK_VOLTAGE = 60

    # This callback is triggered periodically with the period that is set by
    # BrickMaster#set_usb_voltage_callback_period. The parameter is the USB
    # voltage.
    # 
    # The CALLBACK_USB_VOLTAGE callback is only triggered if the USB voltage has changed
    # since the last triggering.
    # 
    # Does not work with hardware version 2.1.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_USB_VOLTAGE = 61

    # This callback is triggered when the threshold as set by
    # BrickMaster#set_stack_current_callback_threshold is reached.
    # The parameter is the stack current.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickMaster#set_debounce_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_STACK_CURRENT_REACHED = 62

    # This callback is triggered when the threshold as set by
    # BrickMaster#set_stack_voltage_callback_threshold is reached.
    # The parameter is the stack voltage.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickMaster#set_debounce_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_STACK_VOLTAGE_REACHED = 63

    # This callback is triggered when the threshold as set by
    # BrickMaster#set_usb_voltage_callback_threshold is reached.
    # The parameter is the voltage of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickMaster#set_debounce_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    CALLBACK_USB_VOLTAGE_REACHED = 64

    FUNCTION_GET_STACK_VOLTAGE = 1 # :nodoc:
    FUNCTION_GET_STACK_CURRENT = 2 # :nodoc:
    FUNCTION_SET_EXTENSION_TYPE = 3 # :nodoc:
    FUNCTION_GET_EXTENSION_TYPE = 4 # :nodoc:
    FUNCTION_IS_CHIBI_PRESENT = 5 # :nodoc:
    FUNCTION_SET_CHIBI_ADDRESS = 6 # :nodoc:
    FUNCTION_GET_CHIBI_ADDRESS = 7 # :nodoc:
    FUNCTION_SET_CHIBI_MASTER_ADDRESS = 8 # :nodoc:
    FUNCTION_GET_CHIBI_MASTER_ADDRESS = 9 # :nodoc:
    FUNCTION_SET_CHIBI_SLAVE_ADDRESS = 10 # :nodoc:
    FUNCTION_GET_CHIBI_SLAVE_ADDRESS = 11 # :nodoc:
    FUNCTION_GET_CHIBI_SIGNAL_STRENGTH = 12 # :nodoc:
    FUNCTION_GET_CHIBI_ERROR_LOG = 13 # :nodoc:
    FUNCTION_SET_CHIBI_FREQUENCY = 14 # :nodoc:
    FUNCTION_GET_CHIBI_FREQUENCY = 15 # :nodoc:
    FUNCTION_SET_CHIBI_CHANNEL = 16 # :nodoc:
    FUNCTION_GET_CHIBI_CHANNEL = 17 # :nodoc:
    FUNCTION_IS_RS485_PRESENT = 18 # :nodoc:
    FUNCTION_SET_RS485_ADDRESS = 19 # :nodoc:
    FUNCTION_GET_RS485_ADDRESS = 20 # :nodoc:
    FUNCTION_SET_RS485_SLAVE_ADDRESS = 21 # :nodoc:
    FUNCTION_GET_RS485_SLAVE_ADDRESS = 22 # :nodoc:
    FUNCTION_GET_RS485_ERROR_LOG = 23 # :nodoc:
    FUNCTION_SET_RS485_CONFIGURATION = 24 # :nodoc:
    FUNCTION_GET_RS485_CONFIGURATION = 25 # :nodoc:
    FUNCTION_IS_WIFI_PRESENT = 26 # :nodoc:
    FUNCTION_SET_WIFI_CONFIGURATION = 27 # :nodoc:
    FUNCTION_GET_WIFI_CONFIGURATION = 28 # :nodoc:
    FUNCTION_SET_WIFI_ENCRYPTION = 29 # :nodoc:
    FUNCTION_GET_WIFI_ENCRYPTION = 30 # :nodoc:
    FUNCTION_GET_WIFI_STATUS = 31 # :nodoc:
    FUNCTION_REFRESH_WIFI_STATUS = 32 # :nodoc:
    FUNCTION_SET_WIFI_CERTIFICATE = 33 # :nodoc:
    FUNCTION_GET_WIFI_CERTIFICATE = 34 # :nodoc:
    FUNCTION_SET_WIFI_POWER_MODE = 35 # :nodoc:
    FUNCTION_GET_WIFI_POWER_MODE = 36 # :nodoc:
    FUNCTION_GET_WIFI_BUFFER_INFO = 37 # :nodoc:
    FUNCTION_SET_WIFI_REGULATORY_DOMAIN = 38 # :nodoc:
    FUNCTION_GET_WIFI_REGULATORY_DOMAIN = 39 # :nodoc:
    FUNCTION_GET_USB_VOLTAGE = 40 # :nodoc:
    FUNCTION_SET_LONG_WIFI_KEY = 41 # :nodoc:
    FUNCTION_GET_LONG_WIFI_KEY = 42 # :nodoc:
    FUNCTION_SET_WIFI_HOSTNAME = 43 # :nodoc:
    FUNCTION_GET_WIFI_HOSTNAME = 44 # :nodoc:
    FUNCTION_SET_STACK_CURRENT_CALLBACK_PERIOD = 45 # :nodoc:
    FUNCTION_GET_STACK_CURRENT_CALLBACK_PERIOD = 46 # :nodoc:
    FUNCTION_SET_STACK_VOLTAGE_CALLBACK_PERIOD = 47 # :nodoc:
    FUNCTION_GET_STACK_VOLTAGE_CALLBACK_PERIOD = 48 # :nodoc:
    FUNCTION_SET_USB_VOLTAGE_CALLBACK_PERIOD = 49 # :nodoc:
    FUNCTION_GET_USB_VOLTAGE_CALLBACK_PERIOD = 50 # :nodoc:
    FUNCTION_SET_STACK_CURRENT_CALLBACK_THRESHOLD = 51 # :nodoc:
    FUNCTION_GET_STACK_CURRENT_CALLBACK_THRESHOLD = 52 # :nodoc:
    FUNCTION_SET_STACK_VOLTAGE_CALLBACK_THRESHOLD = 53 # :nodoc:
    FUNCTION_GET_STACK_VOLTAGE_CALLBACK_THRESHOLD = 54 # :nodoc:
    FUNCTION_SET_USB_VOLTAGE_CALLBACK_THRESHOLD = 55 # :nodoc:
    FUNCTION_GET_USB_VOLTAGE_CALLBACK_THRESHOLD = 56 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 57 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 58 # :nodoc:
    FUNCTION_IS_ETHERNET_PRESENT = 65 # :nodoc:
    FUNCTION_SET_ETHERNET_CONFIGURATION = 66 # :nodoc:
    FUNCTION_GET_ETHERNET_CONFIGURATION = 67 # :nodoc:
    FUNCTION_GET_ETHERNET_STATUS = 68 # :nodoc:
    FUNCTION_SET_ETHERNET_HOSTNAME = 69 # :nodoc:
    FUNCTION_SET_ETHERNET_MAC_ADDRESS = 70 # :nodoc:
    FUNCTION_SET_ETHERNET_WEBSOCKET_CONFIGURATION = 71 # :nodoc:
    FUNCTION_GET_ETHERNET_WEBSOCKET_CONFIGURATION = 72 # :nodoc:
    FUNCTION_SET_ETHERNET_AUTHENTICATION_SECRET = 73 # :nodoc:
    FUNCTION_GET_ETHERNET_AUTHENTICATION_SECRET = 74 # :nodoc:
    FUNCTION_SET_WIFI_AUTHENTICATION_SECRET = 75 # :nodoc:
    FUNCTION_GET_WIFI_AUTHENTICATION_SECRET = 76 # :nodoc:
    FUNCTION_GET_CONNECTION_TYPE = 77 # :nodoc:
    FUNCTION_IS_WIFI2_PRESENT = 78 # :nodoc:
    FUNCTION_START_WIFI2_BOOTLOADER = 79 # :nodoc:
    FUNCTION_WRITE_WIFI2_SERIAL_PORT = 80 # :nodoc:
    FUNCTION_READ_WIFI2_SERIAL_PORT = 81 # :nodoc:
    FUNCTION_SET_WIFI2_AUTHENTICATION_SECRET = 82 # :nodoc:
    FUNCTION_GET_WIFI2_AUTHENTICATION_SECRET = 83 # :nodoc:
    FUNCTION_SET_WIFI2_CONFIGURATION = 84 # :nodoc:
    FUNCTION_GET_WIFI2_CONFIGURATION = 85 # :nodoc:
    FUNCTION_GET_WIFI2_STATUS = 86 # :nodoc:
    FUNCTION_SET_WIFI2_CLIENT_CONFIGURATION = 87 # :nodoc:
    FUNCTION_GET_WIFI2_CLIENT_CONFIGURATION = 88 # :nodoc:
    FUNCTION_SET_WIFI2_CLIENT_HOSTNAME = 89 # :nodoc:
    FUNCTION_GET_WIFI2_CLIENT_HOSTNAME = 90 # :nodoc:
    FUNCTION_SET_WIFI2_CLIENT_PASSWORD = 91 # :nodoc:
    FUNCTION_GET_WIFI2_CLIENT_PASSWORD = 92 # :nodoc:
    FUNCTION_SET_WIFI2_AP_CONFIGURATION = 93 # :nodoc:
    FUNCTION_GET_WIFI2_AP_CONFIGURATION = 94 # :nodoc:
    FUNCTION_SET_WIFI2_AP_PASSWORD = 95 # :nodoc:
    FUNCTION_GET_WIFI2_AP_PASSWORD = 96 # :nodoc:
    FUNCTION_SAVE_WIFI2_CONFIGURATION = 97 # :nodoc:
    FUNCTION_GET_WIFI2_FIRMWARE_VERSION = 98 # :nodoc:
    FUNCTION_ENABLE_WIFI2_STATUS_LED = 99 # :nodoc:
    FUNCTION_DISABLE_WIFI2_STATUS_LED = 100 # :nodoc:
    FUNCTION_IS_WIFI2_STATUS_LED_ENABLED = 101 # :nodoc:
    FUNCTION_SET_WIFI2_MESH_CONFIGURATION = 102 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_CONFIGURATION = 103 # :nodoc:
    FUNCTION_SET_WIFI2_MESH_ROUTER_SSID = 104 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_ROUTER_SSID = 105 # :nodoc:
    FUNCTION_SET_WIFI2_MESH_ROUTER_PASSWORD = 106 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_ROUTER_PASSWORD = 107 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_COMMON_STATUS = 108 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_CLIENT_STATUS = 109 # :nodoc:
    FUNCTION_GET_WIFI2_MESH_AP_STATUS = 110 # :nodoc:
    FUNCTION_SET_BRICKLET_XMC_FLASH_CONFIG = 111 # :nodoc:
    FUNCTION_SET_BRICKLET_XMC_FLASH_DATA = 112 # :nodoc:
    FUNCTION_SET_BRICKLETS_ENABLED = 113 # :nodoc:
    FUNCTION_GET_BRICKLETS_ENABLED = 114 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 231 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 232 # :nodoc:
    FUNCTION_GET_SEND_TIMEOUT_COUNT = 233 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE = 234 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE = 235 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 237 # :nodoc:
    FUNCTION_ENABLE_STATUS_LED = 238 # :nodoc:
    FUNCTION_DISABLE_STATUS_LED = 239 # :nodoc:
    FUNCTION_IS_STATUS_LED_ENABLED = 240 # :nodoc:
    FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_BRICKLET_PLUGIN = 246 # :nodoc:
    FUNCTION_READ_BRICKLET_PLUGIN = 247 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    EXTENSION_TYPE_CHIBI = 1 # :nodoc:
    EXTENSION_TYPE_RS485 = 2 # :nodoc:
    EXTENSION_TYPE_WIFI = 3 # :nodoc:
    EXTENSION_TYPE_ETHERNET = 4 # :nodoc:
    EXTENSION_TYPE_WIFI2 = 5 # :nodoc:
    CHIBI_FREQUENCY_OQPSK_868_MHZ = 0 # :nodoc:
    CHIBI_FREQUENCY_OQPSK_915_MHZ = 1 # :nodoc:
    CHIBI_FREQUENCY_OQPSK_780_MHZ = 2 # :nodoc:
    CHIBI_FREQUENCY_BPSK40_915_MHZ = 3 # :nodoc:
    RS485_PARITY_NONE = 'n' # :nodoc:
    RS485_PARITY_EVEN = 'e' # :nodoc:
    RS485_PARITY_ODD = 'o' # :nodoc:
    WIFI_CONNECTION_DHCP = 0 # :nodoc:
    WIFI_CONNECTION_STATIC_IP = 1 # :nodoc:
    WIFI_CONNECTION_ACCESS_POINT_DHCP = 2 # :nodoc:
    WIFI_CONNECTION_ACCESS_POINT_STATIC_IP = 3 # :nodoc:
    WIFI_CONNECTION_AD_HOC_DHCP = 4 # :nodoc:
    WIFI_CONNECTION_AD_HOC_STATIC_IP = 5 # :nodoc:
    WIFI_ENCRYPTION_WPA_WPA2 = 0 # :nodoc:
    WIFI_ENCRYPTION_WPA_ENTERPRISE = 1 # :nodoc:
    WIFI_ENCRYPTION_WEP = 2 # :nodoc:
    WIFI_ENCRYPTION_NO_ENCRYPTION = 3 # :nodoc:
    WIFI_EAP_OPTION_OUTER_AUTH_EAP_FAST = 0 # :nodoc:
    WIFI_EAP_OPTION_OUTER_AUTH_EAP_TLS = 1 # :nodoc:
    WIFI_EAP_OPTION_OUTER_AUTH_EAP_TTLS = 2 # :nodoc:
    WIFI_EAP_OPTION_OUTER_AUTH_EAP_PEAP = 3 # :nodoc:
    WIFI_EAP_OPTION_INNER_AUTH_EAP_MSCHAP = 0 # :nodoc:
    WIFI_EAP_OPTION_INNER_AUTH_EAP_GTC = 4 # :nodoc:
    WIFI_EAP_OPTION_CERT_TYPE_CA_CERT = 0 # :nodoc:
    WIFI_EAP_OPTION_CERT_TYPE_CLIENT_CERT = 8 # :nodoc:
    WIFI_EAP_OPTION_CERT_TYPE_PRIVATE_KEY = 16 # :nodoc:
    WIFI_STATE_DISASSOCIATED = 0 # :nodoc:
    WIFI_STATE_ASSOCIATED = 1 # :nodoc:
    WIFI_STATE_ASSOCIATING = 2 # :nodoc:
    WIFI_STATE_ERROR = 3 # :nodoc:
    WIFI_STATE_NOT_INITIALIZED_YET = 255 # :nodoc:
    WIFI_POWER_MODE_FULL_SPEED = 0 # :nodoc:
    WIFI_POWER_MODE_LOW_POWER = 1 # :nodoc:
    WIFI_DOMAIN_CHANNEL_1TO11 = 0 # :nodoc:
    WIFI_DOMAIN_CHANNEL_1TO13 = 1 # :nodoc:
    WIFI_DOMAIN_CHANNEL_1TO14 = 2 # :nodoc:
    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    ETHERNET_CONNECTION_DHCP = 0 # :nodoc:
    ETHERNET_CONNECTION_STATIC_IP = 1 # :nodoc:
    CONNECTION_TYPE_NONE = 0 # :nodoc:
    CONNECTION_TYPE_USB = 1 # :nodoc:
    CONNECTION_TYPE_SPI_STACK = 2 # :nodoc:
    CONNECTION_TYPE_CHIBI = 3 # :nodoc:
    CONNECTION_TYPE_RS485 = 4 # :nodoc:
    CONNECTION_TYPE_WIFI = 5 # :nodoc:
    CONNECTION_TYPE_ETHERNET = 6 # :nodoc:
    CONNECTION_TYPE_WIFI2 = 7 # :nodoc:
    WIFI2_PHY_MODE_B = 0 # :nodoc:
    WIFI2_PHY_MODE_G = 1 # :nodoc:
    WIFI2_PHY_MODE_N = 2 # :nodoc:
    WIFI2_CLIENT_STATUS_IDLE = 0 # :nodoc:
    WIFI2_CLIENT_STATUS_CONNECTING = 1 # :nodoc:
    WIFI2_CLIENT_STATUS_WRONG_PASSWORD = 2 # :nodoc:
    WIFI2_CLIENT_STATUS_NO_AP_FOUND = 3 # :nodoc:
    WIFI2_CLIENT_STATUS_CONNECT_FAILED = 4 # :nodoc:
    WIFI2_CLIENT_STATUS_GOT_IP = 5 # :nodoc:
    WIFI2_CLIENT_STATUS_UNKNOWN = 255 # :nodoc:
    WIFI2_AP_ENCRYPTION_OPEN = 0 # :nodoc:
    WIFI2_AP_ENCRYPTION_WEP = 1 # :nodoc:
    WIFI2_AP_ENCRYPTION_WPA_PSK = 2 # :nodoc:
    WIFI2_AP_ENCRYPTION_WPA2_PSK = 3 # :nodoc:
    WIFI2_AP_ENCRYPTION_WPA_WPA2_PSK = 4 # :nodoc:
    WIFI2_MESH_STATUS_DISABLED = 0 # :nodoc:
    WIFI2_MESH_STATUS_WIFI_CONNECTING = 1 # :nodoc:
    WIFI2_MESH_STATUS_GOT_IP = 2 # :nodoc:
    WIFI2_MESH_STATUS_MESH_LOCAL = 3 # :nodoc:
    WIFI2_MESH_STATUS_MESH_ONLINE = 4 # :nodoc:
    WIFI2_MESH_STATUS_AP_AVAILABLE = 5 # :nodoc:
    WIFI2_MESH_STATUS_AP_SETUP = 6 # :nodoc:
    WIFI2_MESH_STATUS_LEAF_AVAILABLE = 7 # :nodoc:
    COMMUNICATION_METHOD_NONE = 0 # :nodoc:
    COMMUNICATION_METHOD_USB = 1 # :nodoc:
    COMMUNICATION_METHOD_SPI_STACK = 2 # :nodoc:
    COMMUNICATION_METHOD_CHIBI = 3 # :nodoc:
    COMMUNICATION_METHOD_RS485 = 4 # :nodoc:
    COMMUNICATION_METHOD_WIFI = 5 # :nodoc:
    COMMUNICATION_METHOD_ETHERNET = 6 # :nodoc:
    COMMUNICATION_METHOD_WIFI_V2 = 7 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 10]

      @response_expected[FUNCTION_GET_STACK_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_STACK_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_EXTENSION_TYPE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_EXTENSION_TYPE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_CHIBI_PRESENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIBI_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIBI_ADDRESS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIBI_MASTER_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIBI_MASTER_ADDRESS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIBI_SLAVE_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIBI_SLAVE_ADDRESS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIBI_SIGNAL_STRENGTH] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIBI_ERROR_LOG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIBI_FREQUENCY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIBI_FREQUENCY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIBI_CHANNEL] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIBI_CHANNEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_RS485_PRESENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RS485_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RS485_ADDRESS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RS485_SLAVE_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RS485_SLAVE_ADDRESS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_RS485_ERROR_LOG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RS485_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RS485_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_WIFI_PRESENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_ENCRYPTION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_ENCRYPTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_REFRESH_WIFI_STATUS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_WIFI_CERTIFICATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_CERTIFICATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_POWER_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_POWER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI_BUFFER_INFO] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_REGULATORY_DOMAIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_REGULATORY_DOMAIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_USB_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_LONG_WIFI_KEY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_LONG_WIFI_KEY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_HOSTNAME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_HOSTNAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STACK_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STACK_CURRENT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STACK_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STACK_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_USB_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_USB_VOLTAGE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STACK_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STACK_CURRENT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STACK_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STACK_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_USB_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_USB_VOLTAGE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_ETHERNET_PRESENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ETHERNET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ETHERNET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ETHERNET_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ETHERNET_HOSTNAME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_ETHERNET_MAC_ADDRESS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_ETHERNET_WEBSOCKET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ETHERNET_WEBSOCKET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ETHERNET_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ETHERNET_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CONNECTION_TYPE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_WIFI2_PRESENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_START_WIFI2_BOOTLOADER] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_WRITE_WIFI2_SERIAL_PORT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_READ_WIFI2_SERIAL_PORT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_AUTHENTICATION_SECRET] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI2_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_CLIENT_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_CLIENT_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_CLIENT_HOSTNAME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_CLIENT_HOSTNAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_CLIENT_PASSWORD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_CLIENT_PASSWORD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_AP_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_AP_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_AP_PASSWORD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_AP_PASSWORD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SAVE_WIFI2_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI2_FIRMWARE_VERSION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_WIFI2_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_WIFI2_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_WIFI2_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_MESH_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_MESH_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_MESH_ROUTER_SSID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_MESH_ROUTER_SSID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIFI2_MESH_ROUTER_PASSWORD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIFI2_MESH_ROUTER_PASSWORD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI2_MESH_COMMON_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI2_MESH_CLIENT_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_WIFI2_MESH_AP_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BRICKLET_XMC_FLASH_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BRICKLET_XMC_FLASH_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BRICKLETS_ENABLED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_BRICKLETS_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SEND_TIMEOUT_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_STACK_CURRENT] = [10, 'S']
      @callback_formats[CALLBACK_STACK_VOLTAGE] = [10, 'S']
      @callback_formats[CALLBACK_USB_VOLTAGE] = [10, 'S']
      @callback_formats[CALLBACK_STACK_CURRENT_REACHED] = [10, 'S']
      @callback_formats[CALLBACK_STACK_VOLTAGE_REACHED] = [10, 'S']
      @callback_formats[CALLBACK_USB_VOLTAGE_REACHED] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the stack voltage. The stack voltage is the
    # voltage that is supplied via the stack, i.e. it is given by a
    # Step-Down or Step-Up Power Supply.
    # 
    # .. note::
    #  It is not possible to measure voltages supplied per PoE or USB with this function.
    def get_stack_voltage
      check_validity

      send_request FUNCTION_GET_STACK_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the stack current. The stack current is the
    # current that is drawn via the stack, i.e. it is given by a
    # Step-Down or Step-Up Power Supply.
    # 
    # .. note::
    #  It is not possible to measure the current drawn via PoE or USB with this function.
    def get_stack_current
      check_validity

      send_request FUNCTION_GET_STACK_CURRENT, [], '', 10, 'S'
    end

    # Writes the extension type to the EEPROM of a specified extension.
    # The extension is either 0 or 1 (0 is the lower one, 1 is the upper one,
    # if only one extension is present use 0).
    # 
    # Possible extension types:
    # 
    #  "Type", "Description"
    # 
    #  "1",    "Chibi"
    #  "2",    "RS485"
    #  "3",    "WIFI"
    #  "4",    "Ethernet"
    #  "5",    "WIFI 2.0"
    # 
    # The extension type is already set when bought and it can be set with the
    # Brick Viewer, it is unlikely that you need this function.
    def set_extension_type(extension, exttype)
      check_validity

      send_request FUNCTION_SET_EXTENSION_TYPE, [extension, exttype], 'C L', 8, ''
    end

    # Returns the type for a given extension as set by BrickMaster#set_extension_type.
    def get_extension_type(extension)
      check_validity

      send_request FUNCTION_GET_EXTENSION_TYPE, [extension], 'C', 12, 'L'
    end

    # Returns *true* if the Master Brick is at position 0 in the stack and a Chibi
    # Extension is available.
    def is_chibi_present
      check_validity

      send_request FUNCTION_IS_CHIBI_PRESENT, [], '', 9, '?'
    end

    # Sets the address belonging to the Chibi Extension.
    # 
    # It is possible to set the address with the Brick Viewer and it will be
    # saved in the EEPROM of the Chibi Extension, it does not
    # have to be set on every startup.
    def set_chibi_address(address)
      check_validity

      send_request FUNCTION_SET_CHIBI_ADDRESS, [address], 'C', 8, ''
    end

    # Returns the address as set by BrickMaster#set_chibi_address.
    def get_chibi_address
      check_validity

      send_request FUNCTION_GET_CHIBI_ADDRESS, [], '', 9, 'C'
    end

    # Sets the address of the Chibi Master. This address is used if the
    # Chibi Extension is used as slave (i.e. it does not have a USB connection).
    # 
    # It is possible to set the address with the Brick Viewer and it will be
    # saved in the EEPROM of the Chibi Extension, it does not
    # have to be set on every startup.
    def set_chibi_master_address(address)
      check_validity

      send_request FUNCTION_SET_CHIBI_MASTER_ADDRESS, [address], 'C', 8, ''
    end

    # Returns the address as set by BrickMaster#set_chibi_master_address.
    def get_chibi_master_address
      check_validity

      send_request FUNCTION_GET_CHIBI_MASTER_ADDRESS, [], '', 9, 'C'
    end

    # Sets up to 254 slave addresses. 0 has a
    # special meaning, it is used as list terminator and not allowed as normal slave
    # address. The address numeration (via num parameter) has to be used
    # ascending from 0. For example: If you use the Chibi Extension in Master mode
    # (i.e. the stack has an USB connection) and you want to talk to three other
    # Chibi stacks with the slave addresses 17, 23, and 42, you should call with
    # ``(0, 17)``, ``(1, 23)``, ``(2, 42)`` and ``(3, 0)``. The last call with
    # ``(3, 0)`` is a list terminator and indicates that the Chibi slave address
    # list contains 3 addresses in this case.
    # 
    # It is possible to set the addresses with the Brick Viewer, that will take care
    # of correct address numeration and list termination.
    # 
    # The slave addresses will be saved in the EEPROM of the Chibi Extension, they
    # don't have to be set on every startup.
    def set_chibi_slave_address(num, address)
      check_validity

      send_request FUNCTION_SET_CHIBI_SLAVE_ADDRESS, [num, address], 'C C', 8, ''
    end

    # Returns the slave address for a given num as set by
    # BrickMaster#set_chibi_slave_address.
    def get_chibi_slave_address(num)
      check_validity

      send_request FUNCTION_GET_CHIBI_SLAVE_ADDRESS, [num], 'C', 9, 'C'
    end

    # Returns the signal strength in dBm. The signal strength updates every time a
    # packet is received.
    def get_chibi_signal_strength
      check_validity

      send_request FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, [], '', 9, 'C'
    end

    # Returns underrun, CRC error, no ACK and overflow error counts of the Chibi
    # communication. If these errors start rising, it is likely that either the
    # distance between two Chibi stacks is becoming too big or there are
    # interferences.
    def get_chibi_error_log
      check_validity

      send_request FUNCTION_GET_CHIBI_ERROR_LOG, [], '', 16, 'S S S S'
    end

    # Sets the Chibi frequency range for the Chibi Extension. Possible values are:
    # 
    #  "Type", "Description"
    # 
    #  "0",    "OQPSK 868MHz (Europe)"
    #  "1",    "OQPSK 915MHz (US)"
    #  "2",    "OQPSK 780MHz (China)"
    #  "3",    "BPSK40 915MHz"
    # 
    # It is possible to set the frequency with the Brick Viewer and it will be
    # saved in the EEPROM of the Chibi Extension, it does not
    # have to be set on every startup.
    def set_chibi_frequency(frequency)
      check_validity

      send_request FUNCTION_SET_CHIBI_FREQUENCY, [frequency], 'C', 8, ''
    end

    # Returns the frequency value as set by BrickMaster#set_chibi_frequency.
    def get_chibi_frequency
      check_validity

      send_request FUNCTION_GET_CHIBI_FREQUENCY, [], '', 9, 'C'
    end

    # Sets the channel used by the Chibi Extension. Possible channels are
    # different for different frequencies:
    # 
    #  "Frequency", "Possible Channels"
    # 
    #  "OQPSK 868MHz (Europe)", "0"
    #  "OQPSK 915MHz (US)",     "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
    #  "OQPSK 780MHz (China)",  "0, 1, 2, 3"
    #  "BPSK40 915MHz",         "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
    # 
    # It is possible to set the channel with the Brick Viewer and it will be
    # saved in the EEPROM of the Chibi Extension, it does not
    # have to be set on every startup.
    def set_chibi_channel(channel)
      check_validity

      send_request FUNCTION_SET_CHIBI_CHANNEL, [channel], 'C', 8, ''
    end

    # Returns the channel as set by BrickMaster#set_chibi_channel.
    def get_chibi_channel
      check_validity

      send_request FUNCTION_GET_CHIBI_CHANNEL, [], '', 9, 'C'
    end

    # Returns *true* if the Master Brick is at position 0 in the stack and a RS485
    # Extension is available.
    def is_rs485_present
      check_validity

      send_request FUNCTION_IS_RS485_PRESENT, [], '', 9, '?'
    end

    # Sets the address (0-255) belonging to the RS485 Extension.
    # 
    # Set to 0 if the RS485 Extension should be the RS485 Master (i.e.
    # connected to a PC via USB).
    # 
    # It is possible to set the address with the Brick Viewer and it will be
    # saved in the EEPROM of the RS485 Extension, it does not
    # have to be set on every startup.
    def set_rs485_address(address)
      check_validity

      send_request FUNCTION_SET_RS485_ADDRESS, [address], 'C', 8, ''
    end

    # Returns the address as set by BrickMaster#set_rs485_address.
    def get_rs485_address
      check_validity

      send_request FUNCTION_GET_RS485_ADDRESS, [], '', 9, 'C'
    end

    # Sets up to 255 slave addresses. Valid addresses are in range 1-255. 0 has a
    # special meaning, it is used as list terminator and not allowed as normal slave
    # address. The address numeration (via ``num`` parameter) has to be used
    # ascending from 0. For example: If you use the RS485 Extension in Master mode
    # (i.e. the stack has an USB connection) and you want to talk to three other
    # RS485 stacks with the addresses 17, 23, and 42, you should call with
    # ``(0, 17)``, ``(1, 23)``, ``(2, 42)`` and ``(3, 0)``. The last call with
    # ``(3, 0)`` is a list terminator and indicates that the RS485 slave address list
    # contains 3 addresses in this case.
    # 
    # It is possible to set the addresses with the Brick Viewer, that will take care
    # of correct address numeration and list termination.
    # 
    # The slave addresses will be saved in the EEPROM of the Chibi Extension, they
    # don't have to be set on every startup.
    def set_rs485_slave_address(num, address)
      check_validity

      send_request FUNCTION_SET_RS485_SLAVE_ADDRESS, [num, address], 'C C', 8, ''
    end

    # Returns the slave address for a given ``num`` as set by
    # BrickMaster#set_rs485_slave_address.
    def get_rs485_slave_address(num)
      check_validity

      send_request FUNCTION_GET_RS485_SLAVE_ADDRESS, [num], 'C', 9, 'C'
    end

    # Returns CRC error counts of the RS485 communication.
    # If this counter starts rising, it is likely that the distance
    # between the RS485 nodes is too big or there is some kind of
    # interference.
    def get_rs485_error_log
      check_validity

      send_request FUNCTION_GET_RS485_ERROR_LOG, [], '', 10, 'S'
    end

    # Sets the configuration of the RS485 Extension. The
    # Master Brick will try to match the given baud rate as exactly as possible.
    # The maximum recommended baud rate is 2000000 (2MBd).
    # Possible values for parity are 'n' (none), 'e' (even) and 'o' (odd).
    # 
    # If your RS485 is unstable (lost messages etc.), the first thing you should
    # try is to decrease the speed. On very large bus (e.g. 1km), you probably
    # should use a value in the range of 100000 (100kBd).
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    def set_rs485_configuration(speed, parity, stopbits)
      check_validity

      send_request FUNCTION_SET_RS485_CONFIGURATION, [speed, parity, stopbits], 'L k C', 8, ''
    end

    # Returns the configuration as set by BrickMaster#set_rs485_configuration.
    def get_rs485_configuration
      check_validity

      send_request FUNCTION_GET_RS485_CONFIGURATION, [], '', 14, 'L k C'
    end

    # Returns *true* if the Master Brick is at position 0 in the stack and a WIFI
    # Extension is available.
    def is_wifi_present
      check_validity

      send_request FUNCTION_IS_WIFI_PRESENT, [], '', 9, '?'
    end

    # Sets the configuration of the WIFI Extension. The ``ssid`` can have a max length
    # of 32 characters. Possible values for ``connection`` are:
    # 
    #  "Value", "Description"
    # 
    #  "0", "DHCP"
    #  "1", "Static IP"
    #  "2", "Access Point: DHCP"
    #  "3", "Access Point: Static IP"
    #  "4", "Ad Hoc: DHCP"
    #  "5", "Ad Hoc: Static IP"
    # 
    # If you set ``connection`` to one of the static IP options then you have to
    # supply ``ip``, ``subnet_mask`` and ``gateway`` as an array of size 4 (first
    # element of the array is the least significant byte of the address). If
    # ``connection`` is set to one of the DHCP options then ``ip``, ``subnet_mask``
    # and ``gateway`` are ignored, you can set them to 0.
    # 
    # The last parameter is the port that your program will connect to.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the WIFI configuration.
    def set_wifi_configuration(ssid, connection, ip, subnet_mask, gateway, port)
      check_validity

      send_request FUNCTION_SET_WIFI_CONFIGURATION, [ssid, connection, ip, subnet_mask, gateway, port], 'Z32 C C4 C4 C4 S', 8, ''
    end

    # Returns the configuration as set by BrickMaster#set_wifi_configuration.
    def get_wifi_configuration
      check_validity

      send_request FUNCTION_GET_WIFI_CONFIGURATION, [], '', 55, 'Z32 C C4 C4 C4 S'
    end

    # Sets the encryption of the WIFI Extension. The first parameter is the
    # type of the encryption. Possible values are:
    # 
    #  "Value", "Description"
    # 
    #  "0", "WPA/WPA2"
    #  "1", "WPA Enterprise (EAP-FAST, EAP-TLS, EAP-TTLS, PEAP)"
    #  "2", "WEP"
    #  "3", "No Encryption"
    # 
    # The ``key`` has a max length of 50 characters and is used if ``encryption``
    # is set to 0 or 2 (WPA/WPA2 or WEP). Otherwise the value is ignored.
    # 
    # For WPA/WPA2 the key has to be at least 8 characters long. If you want to set
    # a key with more than 50 characters, see BrickMaster#set_long_wifi_key.
    # 
    # For WEP the key has to be either 10 or 26 hexadecimal digits long. It is
    # possible to set the WEP ``key_index`` (1-4). If you don't know your
    # ``key_index``, it is likely 1.
    # 
    # If you choose WPA Enterprise as encryption, you have to set ``eap_options`` and
    # the length of the certificates (for other encryption types these parameters
    # are ignored). The certificates
    # themselves can be set with BrickMaster#set_wifi_certificate. ``eap_options`` consist
    # of the outer authentication (bits 1-2), inner authentication (bit 3) and
    # certificate type (bits 4-5):
    # 
    #  "Option", "Bits", "Description"
    # 
    #  "outer authentication", "1-2", "0=EAP-FAST, 1=EAP-TLS, 2=EAP-TTLS, 3=EAP-PEAP"
    #  "inner authentication", "3", "0=EAP-MSCHAP, 1=EAP-GTC"
    #  "certificate type", "4-5", "0=CA Certificate, 1=Client Certificate, 2=Private Key"
    # 
    # Example for EAP-TTLS + EAP-GTC + Private Key: ``option = 2 | (1 << 2) | (2 << 3)``.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the Wi-Fi encryption.
    def set_wifi_encryption(encryption, key, key_index, eap_options, ca_certificate_length, client_certificate_length, private_key_length)
      check_validity

      send_request FUNCTION_SET_WIFI_ENCRYPTION, [encryption, key, key_index, eap_options, ca_certificate_length, client_certificate_length, private_key_length], 'C Z50 C C S S S', 8, ''
    end

    # Returns the encryption as set by BrickMaster#set_wifi_encryption.
    # 
    # .. note::
    #  Since Master Brick Firmware version 2.4.4 the key is not returned anymore.
    def get_wifi_encryption
      check_validity

      send_request FUNCTION_GET_WIFI_ENCRYPTION, [], '', 67, 'C Z50 C C S S S'
    end

    # Returns the status of the WIFI Extension. The ``state`` is updated automatically,
    # all of the other parameters are updated on startup and every time
    # BrickMaster#refresh_wifi_status is called.
    # 
    # Possible states are:
    # 
    #  "State", "Description"
    # 
    #  "0", "Disassociated"
    #  "1", "Associated"
    #  "2", "Associating"
    #  "3", "Error"
    #  "255", "Not initialized yet"
    def get_wifi_status
      check_validity

      send_request FUNCTION_GET_WIFI_STATUS, [], '', 44, 'C6 C6 C s C4 C4 C4 L L C'
    end

    # Refreshes the Wi-Fi status (see BrickMaster#get_wifi_status). To read the status
    # of the Wi-Fi module, the Master Brick has to change from data mode to
    # command mode and back. This transaction and the readout itself is
    # unfortunately time consuming. This means, that it might take some ms
    # until the stack with attached WIFI Extension reacts again after this
    # function is called.
    def refresh_wifi_status
      check_validity

      send_request FUNCTION_REFRESH_WIFI_STATUS, [], '', 8, ''
    end

    # This function is used to set the certificate as well as password and username
    # for WPA Enterprise. To set the username use index 0xFFFF,
    # to set the password use index 0xFFFE. The max length of username and
    # password is 32.
    # 
    # The certificate is written in chunks of size 32 and the index is used as
    # the index of the chunk. ``data_length`` should nearly always be 32. Only
    # the last chunk can have a length that is not equal to 32.
    # 
    # The starting index of the CA Certificate is 0, of the Client Certificate
    # 10000 and for the Private Key 20000. Maximum sizes are 1312, 1312 and
    # 4320 byte respectively.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after uploading the certificate.
    # 
    # It is recommended to use the Brick Viewer to set the certificate, username
    # and password.
    def set_wifi_certificate(index, data, data_length)
      check_validity

      send_request FUNCTION_SET_WIFI_CERTIFICATE, [index, data, data_length], 'S C32 C', 8, ''
    end

    # Returns the certificate for a given index as set by BrickMaster#set_wifi_certificate.
    def get_wifi_certificate(index)
      check_validity

      send_request FUNCTION_GET_WIFI_CERTIFICATE, [index], 'S', 41, 'C32 C'
    end

    # Sets the power mode of the WIFI Extension. Possible modes are:
    # 
    #  "Mode", "Description"
    # 
    #  "0", "Full Speed (high power consumption, high throughput)"
    #  "1", "Low Power (low power consumption, low throughput)"
    def set_wifi_power_mode(mode)
      check_validity

      send_request FUNCTION_SET_WIFI_POWER_MODE, [mode], 'C', 8, ''
    end

    # Returns the power mode as set by BrickMaster#set_wifi_power_mode.
    def get_wifi_power_mode
      check_validity

      send_request FUNCTION_GET_WIFI_POWER_MODE, [], '', 9, 'C'
    end

    # Returns informations about the Wi-Fi receive buffer. The Wi-Fi
    # receive buffer has a max size of 1500 byte and if data is transfered
    # too fast, it might overflow.
    # 
    # The return values are the number of overflows, the low watermark
    # (i.e. the smallest number of bytes that were free in the buffer) and
    # the bytes that are currently used.
    # 
    # You should always try to keep the buffer empty, otherwise you will
    # have a permanent latency. A good rule of thumb is, that you can transfer
    # 1000 messages per second without problems.
    # 
    # Try to not send more then 50 messages at a time without any kind of
    # break between them.
    def get_wifi_buffer_info
      check_validity

      send_request FUNCTION_GET_WIFI_BUFFER_INFO, [], '', 16, 'L S S'
    end

    # Sets the regulatory domain of the WIFI Extension. Possible domains are:
    # 
    #  "Domain", "Description"
    # 
    #  "0", "FCC: Channel 1-11 (N/S America, Australia, New Zealand)"
    #  "1", "ETSI: Channel 1-13 (Europe, Middle East, Africa)"
    #  "2", "TELEC: Channel 1-14 (Japan)"
    def set_wifi_regulatory_domain(domain)
      check_validity

      send_request FUNCTION_SET_WIFI_REGULATORY_DOMAIN, [domain], 'C', 8, ''
    end

    # Returns the regulatory domain as set by BrickMaster#set_wifi_regulatory_domain.
    def get_wifi_regulatory_domain
      check_validity

      send_request FUNCTION_GET_WIFI_REGULATORY_DOMAIN, [], '', 9, 'C'
    end

    # Returns the USB voltage. Does not work with hardware version 2.1.
    def get_usb_voltage
      check_validity

      send_request FUNCTION_GET_USB_VOLTAGE, [], '', 10, 'S'
    end

    # Sets a long Wi-Fi key (up to 63 chars, at least 8 chars) for WPA encryption.
    # This key will be used
    # if the key in BrickMaster#set_wifi_encryption is set to "-". In the old protocol,
    # a payload of size 63 was not possible, so the maximum key length was 50 chars.
    # 
    # With the new protocol this is possible, since we didn't want to break API,
    # this function was added additionally.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Firmware)
    def set_long_wifi_key(key)
      check_validity

      send_request FUNCTION_SET_LONG_WIFI_KEY, [key], 'Z64', 8, ''
    end

    # Returns the encryption key as set by BrickMaster#set_long_wifi_key.
    # 
    # .. note::
    #  Since Master Brick firmware version 2.4.4 the key is not returned anymore.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Firmware)
    def get_long_wifi_key
      check_validity

      send_request FUNCTION_GET_LONG_WIFI_KEY, [], '', 72, 'Z64'
    end

    # Sets the hostname of the WIFI Extension. The hostname will be displayed
    # by access points as the hostname in the DHCP clients table.
    # 
    # Setting an empty String will restore the default hostname.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_wifi_hostname(hostname)
      check_validity

      send_request FUNCTION_SET_WIFI_HOSTNAME, [hostname], 'Z16', 8, ''
    end

    # Returns the hostname as set by BrickMaster#set_wifi_hostname.
    # 
    # An empty String means, that the default hostname is used.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_wifi_hostname
      check_validity

      send_request FUNCTION_GET_WIFI_HOSTNAME, [], '', 24, 'Z16'
    end

    # Sets the period with which the CALLBACK_STACK_CURRENT callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_STACK_CURRENT callback is only triggered if the current has changed
    # since the last triggering.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_stack_current_callback_period(period)
      check_validity

      send_request FUNCTION_SET_STACK_CURRENT_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickMaster#set_stack_current_callback_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_stack_current_callback_period
      check_validity

      send_request FUNCTION_GET_STACK_CURRENT_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_STACK_VOLTAGE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_STACK_VOLTAGE callback is only triggered if the voltage has changed
    # since the last triggering.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_stack_voltage_callback_period(period)
      check_validity

      send_request FUNCTION_SET_STACK_VOLTAGE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickMaster#set_stack_voltage_callback_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_stack_voltage_callback_period
      check_validity

      send_request FUNCTION_GET_STACK_VOLTAGE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_USB_VOLTAGE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_USB_VOLTAGE callback is only triggered if the voltage has changed
    # since the last triggering.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_usb_voltage_callback_period(period)
      check_validity

      send_request FUNCTION_SET_USB_VOLTAGE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickMaster#set_usb_voltage_callback_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_usb_voltage_callback_period
      check_validity

      send_request FUNCTION_GET_USB_VOLTAGE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_STACK_CURRENT_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the current is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the current is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_stack_current_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_STACK_CURRENT_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickMaster#set_stack_current_callback_threshold.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_stack_current_callback_threshold
      check_validity

      send_request FUNCTION_GET_STACK_CURRENT_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the thresholds for the CALLBACK_STACK_VOLTAGE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_stack_voltage_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_STACK_VOLTAGE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickMaster#set_stack_voltage_callback_threshold.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_stack_voltage_callback_threshold
      check_validity

      send_request FUNCTION_GET_STACK_VOLTAGE_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the thresholds for the CALLBACK_USB_VOLTAGE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_usb_voltage_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_USB_VOLTAGE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 8, ''
    end

    # Returns the threshold as set by BrickMaster#set_usb_voltage_callback_threshold.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_usb_voltage_callback_threshold
      check_validity

      send_request FUNCTION_GET_USB_VOLTAGE_CALLBACK_THRESHOLD, [], '', 13, 'k S S'
    end

    # Sets the period with which the threshold callbacks
    # 
    # * CALLBACK_STACK_CURRENT_REACHED,
    # * CALLBACK_STACK_VOLTAGE_REACHED,
    # * CALLBACK_USB_VOLTAGE_REACHED
    # 
    # are triggered, if the thresholds
    # 
    # * BrickMaster#set_stack_current_callback_threshold,
    # * BrickMaster#set_stack_voltage_callback_threshold,
    # * BrickMaster#set_usb_voltage_callback_threshold
    # 
    # keep being reached.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickMaster#set_debounce_period.
    # 
    # .. versionadded:: 2.0.5$nbsp;(Firmware)
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Returns *true* if the Master Brick is at position 0 in the stack and an Ethernet
    # Extension is available.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def is_ethernet_present
      check_validity

      send_request FUNCTION_IS_ETHERNET_PRESENT, [], '', 9, '?'
    end

    # Sets the configuration of the Ethernet Extension. Possible values for
    # ``connection`` are:
    # 
    #  "Value", "Description"
    # 
    #  "0", "DHCP"
    #  "1", "Static IP"
    # 
    # If you set ``connection`` to static IP options then you have to supply ``ip``,
    # ``subnet_mask`` and ``gateway`` as an array of size 4 (first element of the
    # array is the least significant byte of the address). If ``connection`` is set
    # to the DHCP options then ``ip``, ``subnet_mask`` and ``gateway`` are ignored,
    # you can set them to 0.
    # 
    # The last parameter is the port that your program will connect to.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the Ethernet configuration.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def set_ethernet_configuration(connection, ip, subnet_mask, gateway, port)
      check_validity

      send_request FUNCTION_SET_ETHERNET_CONFIGURATION, [connection, ip, subnet_mask, gateway, port], 'C C4 C4 C4 S', 8, ''
    end

    # Returns the configuration as set by BrickMaster#set_ethernet_configuration.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def get_ethernet_configuration
      check_validity

      send_request FUNCTION_GET_ETHERNET_CONFIGURATION, [], '', 23, 'C C4 C4 C4 S'
    end

    # Returns the status of the Ethernet Extension.
    # 
    # ``mac_address``, ``ip``, ``subnet_mask`` and ``gateway`` are given as an array.
    # The first element of the array is the least significant byte of the address.
    # 
    # ``rx_count`` and ``tx_count`` are the number of bytes that have been
    # received/send since last restart.
    # 
    # ``hostname`` is the currently used hostname.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def get_ethernet_status
      check_validity

      send_request FUNCTION_GET_ETHERNET_STATUS, [], '', 66, 'C6 C4 C4 C4 L L Z32'
    end

    # Sets the hostname of the Ethernet Extension. The hostname will be displayed
    # by access points as the hostname in the DHCP clients table.
    # 
    # Setting an empty String will restore the default hostname.
    # 
    # The current hostname can be discovered with BrickMaster#get_ethernet_status.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def set_ethernet_hostname(hostname)
      check_validity

      send_request FUNCTION_SET_ETHERNET_HOSTNAME, [hostname], 'Z32', 8, ''
    end

    # Sets the MAC address of the Ethernet Extension. The Ethernet Extension should
    # come configured with a valid MAC address, that is also written on a
    # sticker of the extension itself.
    # 
    # The MAC address can be read out again with BrickMaster#get_ethernet_status.
    # 
    # .. versionadded:: 2.1.0$nbsp;(Firmware)
    def set_ethernet_mac_address(mac_address)
      check_validity

      send_request FUNCTION_SET_ETHERNET_MAC_ADDRESS, [mac_address], 'C6', 8, ''
    end

    # Sets the Ethernet WebSocket configuration. The first parameter sets the number of socket
    # connections that are reserved for WebSockets. The range is 0-7. The connections
    # are shared with the plain sockets. Example: If you set the connections to 3,
    # there will be 3 WebSocket and 4 plain socket connections available.
    # 
    # The second parameter is the port for the WebSocket connections. The port can
    # not be the same as the port for the plain socket connections.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the Ethernet configuration.
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def set_ethernet_websocket_configuration(sockets, port)
      check_validity

      send_request FUNCTION_SET_ETHERNET_WEBSOCKET_CONFIGURATION, [sockets, port], 'C S', 8, ''
    end

    # Returns the configuration as set by BrickMaster#set_ethernet_configuration.
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def get_ethernet_websocket_configuration
      check_validity

      send_request FUNCTION_GET_ETHERNET_WEBSOCKET_CONFIGURATION, [], '', 11, 'C S'
    end

    # Sets the Ethernet authentication secret. The secret can be a string of up to 64
    # characters. An empty string disables the authentication.
    # 
    # See the :ref:`authentication tutorial <tutorial_authentication>` for more
    # information.
    # 
    # The secret is stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the Ethernet authentication secret.
    # 
    # The default value is an empty string (authentication disabled).
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def set_ethernet_authentication_secret(secret)
      check_validity

      send_request FUNCTION_SET_ETHERNET_AUTHENTICATION_SECRET, [secret], 'Z64', 8, ''
    end

    # Returns the authentication secret as set by
    # BrickMaster#set_ethernet_authentication_secret.
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def get_ethernet_authentication_secret
      check_validity

      send_request FUNCTION_GET_ETHERNET_AUTHENTICATION_SECRET, [], '', 72, 'Z64'
    end

    # Sets the WIFI authentication secret. The secret can be a string of up to 64
    # characters. An empty string disables the authentication.
    # 
    # See the :ref:`authentication tutorial <tutorial_authentication>` for more
    # information.
    # 
    # The secret is stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # It is recommended to use the Brick Viewer to set the WIFI authentication secret.
    # 
    # The default value is an empty string (authentication disabled).
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def set_wifi_authentication_secret(secret)
      check_validity

      send_request FUNCTION_SET_WIFI_AUTHENTICATION_SECRET, [secret], 'Z64', 8, ''
    end

    # Returns the authentication secret as set by
    # BrickMaster#set_wifi_authentication_secret.
    # 
    # .. versionadded:: 2.2.0$nbsp;(Firmware)
    def get_wifi_authentication_secret
      check_validity

      send_request FUNCTION_GET_WIFI_AUTHENTICATION_SECRET, [], '', 72, 'Z64'
    end

    # Returns the type of the connection over which this function was called.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_connection_type
      check_validity

      send_request FUNCTION_GET_CONNECTION_TYPE, [], '', 9, 'C'
    end

    # Returns *true* if the Master Brick is at position 0 in the stack and a WIFI
    # Extension 2.0 is available.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def is_wifi2_present
      check_validity

      send_request FUNCTION_IS_WIFI2_PRESENT, [], '', 9, '?'
    end

    # Starts the bootloader of the WIFI Extension 2.0. Returns 0 on success.
    # Afterwards the BrickMaster#write_wifi2_serial_port and BrickMaster#read_wifi2_serial_port
    # functions can be used to communicate with the bootloader to flash a new
    # firmware.
    # 
    # The bootloader should only be started over a USB connection. It cannot be
    # started over a WIFI2 connection, see the BrickMaster#get_connection_type function.
    # 
    # It is recommended to use the Brick Viewer to update the firmware of the WIFI
    # Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def start_wifi2_bootloader
      check_validity

      send_request FUNCTION_START_WIFI2_BOOTLOADER, [], '', 9, 'c'
    end

    # Writes up to 60 bytes (number of bytes to be written specified by ``length``)
    # to the serial port of the bootloader of the WIFI Extension 2.0. Returns 0 on
    # success.
    # 
    # Before this function can be used the bootloader has to be started using the
    # BrickMaster#start_wifi2_bootloader function.
    # 
    # It is recommended to use the Brick Viewer to update the firmware of the WIFI
    # Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def write_wifi2_serial_port(data, length)
      check_validity

      send_request FUNCTION_WRITE_WIFI2_SERIAL_PORT, [data, length], 'C60 C', 9, 'c'
    end

    # Reads up to 60 bytes (number of bytes to be read specified by ``length``)
    # from the serial port of the bootloader of the WIFI Extension 2.0.
    # Returns the number of actually read bytes.
    # 
    # Before this function can be used the bootloader has to be started using the
    # BrickMaster#start_wifi2_bootloader function.
    # 
    # It is recommended to use the Brick Viewer to update the firmware of the WIFI
    # Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def read_wifi2_serial_port(length)
      check_validity

      send_request FUNCTION_READ_WIFI2_SERIAL_PORT, [length], 'C', 69, 'C60 C'
    end

    # Sets the WIFI authentication secret. The secret can be a string of up to 64
    # characters. An empty string disables the authentication. The default value is
    # an empty string (authentication disabled).
    # 
    # See the :ref:`authentication tutorial <tutorial_authentication>` for more
    # information.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_authentication_secret(secret)
      check_validity

      send_request FUNCTION_SET_WIFI2_AUTHENTICATION_SECRET, [secret], 'Z64', 8, ''
    end

    # Returns the WIFI authentication secret as set by
    # BrickMaster#set_wifi2_authentication_secret.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_authentication_secret
      check_validity

      send_request FUNCTION_GET_WIFI2_AUTHENTICATION_SECRET, [], '', 72, 'Z64'
    end

    # Sets the general configuration of the WIFI Extension 2.0.
    # 
    # The ``port`` parameter sets the port number that your programm will connect
    # to.
    # 
    # The ``websocket_port`` parameter sets the WebSocket port number that your
    # JavaScript programm will connect to.
    # 
    # The ``website_port`` parameter sets the port number for the website of the
    # WIFI Extension 2.0.
    # 
    # The ``phy_mode`` parameter sets the specific wireless network mode to be used.
    # Possible values are B, G and N.
    # 
    # The ``sleep_mode`` parameter is currently unused.
    # 
    # The ``website`` parameter is used to enable or disable the web interface of
    # the WIFI Extension 2.0, which is available from firmware version 2.0.1. Note
    # that, for firmware version 2.0.3 and older, to disable the the web interface
    # the ``website_port`` parameter must be set to 1 and greater than 1 to enable
    # the web interface. For firmware version 2.0.4 and later, setting this parameter
    # to 1 will enable the web interface and setting it to 0 will disable the web
    # interface.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_configuration(port, websocket_port, website_port, phy_mode, sleep_mode, website)
      check_validity

      send_request FUNCTION_SET_WIFI2_CONFIGURATION, [port, websocket_port, website_port, phy_mode, sleep_mode, website], 'S S S C C C', 8, ''
    end

    # Returns the general configuration as set by BrickMaster#set_wifi2_configuration.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_configuration
      check_validity

      send_request FUNCTION_GET_WIFI2_CONFIGURATION, [], '', 17, 'S S S C C C'
    end

    # Returns the client and access point status of the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_status
      check_validity

      send_request FUNCTION_GET_WIFI2_STATUS, [], '', 65, '? C C4 C4 C4 C6 L L c ? C4 C4 C4 C6 L L C'
    end

    # Sets the client specific configuration of the WIFI Extension 2.0.
    # 
    # The ``enable`` parameter enables or disables the client part of the
    # WIFI Extension 2.0.
    # 
    # The ``ssid`` parameter sets the SSID (up to 32 characters) of the access point
    # to connect to.
    # 
    # If the ``ip`` parameter is set to all zero then ``subnet_mask`` and ``gateway``
    # parameters are also set to all zero and DHCP is used for IP address configuration.
    # Otherwise those three parameters can be used to configure a static IP address.
    # The default configuration is DHCP.
    # 
    # If the ``mac_address`` parameter is set to all zero then the factory MAC
    # address is used. Otherwise this parameter can be used to set a custom MAC
    # address.
    # 
    # If the ``bssid`` parameter is set to all zero then WIFI Extension 2.0 will
    # connect to any access point that matches the configured SSID. Otherwise this
    # parameter can be used to make the WIFI Extension 2.0 only connect to an
    # access point if SSID and BSSID match.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_client_configuration(enable, ssid, ip, subnet_mask, gateway, mac_address, bssid)
      check_validity

      send_request FUNCTION_SET_WIFI2_CLIENT_CONFIGURATION, [enable, ssid, ip, subnet_mask, gateway, mac_address, bssid], '? Z32 C4 C4 C4 C6 C6', 8, ''
    end

    # Returns the client configuration as set by BrickMaster#set_wifi2_client_configuration.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_client_configuration
      check_validity

      send_request FUNCTION_GET_WIFI2_CLIENT_CONFIGURATION, [], '', 65, '? Z32 C4 C4 C4 C6 C6'
    end

    # Sets the client hostname (up to 32 characters) of the WIFI Extension 2.0. The
    # hostname will be displayed by access points as the hostname in the DHCP clients
    # table.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_client_hostname(hostname)
      check_validity

      send_request FUNCTION_SET_WIFI2_CLIENT_HOSTNAME, [hostname], 'Z32', 8, ''
    end

    # Returns the client hostname as set by BrickMaster#set_wifi2_client_hostname.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_client_hostname
      check_validity

      send_request FUNCTION_GET_WIFI2_CLIENT_HOSTNAME, [], '', 40, 'Z32'
    end

    # Sets the client password (up to 63 chars) for WPA/WPA2 encryption.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_client_password(password)
      check_validity

      send_request FUNCTION_SET_WIFI2_CLIENT_PASSWORD, [password], 'Z64', 8, ''
    end

    # Returns the client password as set by BrickMaster#set_wifi2_client_password.
    # 
    # .. note::
    #  Since WIFI Extension 2.0 firmware version 2.1.3 the password is not
    #  returned anymore.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_client_password
      check_validity

      send_request FUNCTION_GET_WIFI2_CLIENT_PASSWORD, [], '', 72, 'Z64'
    end

    # Sets the access point specific configuration of the WIFI Extension 2.0.
    # 
    # The ``enable`` parameter enables or disables the access point part of the
    # WIFI Extension 2.0.
    # 
    # The ``ssid`` parameter sets the SSID (up to 32 characters) of the access point.
    # 
    # If the ``ip`` parameter is set to all zero then ``subnet_mask`` and ``gateway``
    # parameters are also set to all zero and DHCP is used for IP address configuration.
    # Otherwise those three parameters can be used to configure a static IP address.
    # The default configuration is DHCP.
    # 
    # The ``encryption`` parameter sets the encryption mode to be used. Possible
    # values are Open (no encryption), WEP or WPA/WPA2 PSK.
    # Use the BrickMaster#set_wifi2_ap_password function to set the encryption
    # password.
    # 
    # The ``hidden`` parameter makes the access point hide or show its SSID.
    # 
    # The ``channel`` parameter sets the channel (1 to 13) of the access point.
    # 
    # If the ``mac_address`` parameter is set to all zero then the factory MAC
    # address is used. Otherwise this parameter can be used to set a custom MAC
    # address.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_ap_configuration(enable, ssid, ip, subnet_mask, gateway, encryption, hidden, channel, mac_address)
      check_validity

      send_request FUNCTION_SET_WIFI2_AP_CONFIGURATION, [enable, ssid, ip, subnet_mask, gateway, encryption, hidden, channel, mac_address], '? Z32 C4 C4 C4 C ? C C6', 8, ''
    end

    # Returns the access point configuration as set by BrickMaster#set_wifi2_ap_configuration.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_ap_configuration
      check_validity

      send_request FUNCTION_GET_WIFI2_AP_CONFIGURATION, [], '', 62, '? Z32 C4 C4 C4 C ? C C6'
    end

    # Sets the access point password (at least 8 and up to 63 chars) for the configured encryption
    # mode, see BrickMaster#set_wifi2_ap_configuration.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def set_wifi2_ap_password(password)
      check_validity

      send_request FUNCTION_SET_WIFI2_AP_PASSWORD, [password], 'Z64', 8, ''
    end

    # Returns the access point password as set by BrickMaster#set_wifi2_ap_password.
    # 
    # .. note::
    #  Since WIFI Extension 2.0 firmware version 2.1.3 the password is not
    #  returned anymore.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_ap_password
      check_validity

      send_request FUNCTION_GET_WIFI2_AP_PASSWORD, [], '', 72, 'Z64'
    end

    # All configuration functions for the WIFI Extension 2.0 do not change the
    # values permanently. After configuration this function has to be called to
    # permanently store the values.
    # 
    # The values are stored in the EEPROM and only applied on startup. That means
    # you have to restart the Master Brick after configuration.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def save_wifi2_configuration
      check_validity

      send_request FUNCTION_SAVE_WIFI2_CONFIGURATION, [], '', 9, 'C'
    end

    # Returns the current version of the WIFI Extension 2.0 firmware.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def get_wifi2_firmware_version
      check_validity

      send_request FUNCTION_GET_WIFI2_FIRMWARE_VERSION, [], '', 11, 'C3'
    end

    # Turns the green status LED of the WIFI Extension 2.0 on.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def enable_wifi2_status_led
      check_validity

      send_request FUNCTION_ENABLE_WIFI2_STATUS_LED, [], '', 8, ''
    end

    # Turns the green status LED of the WIFI Extension 2.0 off.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def disable_wifi2_status_led
      check_validity

      send_request FUNCTION_DISABLE_WIFI2_STATUS_LED, [], '', 8, ''
    end

    # Returns *true* if the green status LED of the WIFI Extension 2.0 is turned on.
    # 
    # .. versionadded:: 2.4.0$nbsp;(Firmware)
    def is_wifi2_status_led_enabled
      check_validity

      send_request FUNCTION_IS_WIFI2_STATUS_LED_ENABLED, [], '', 9, '?'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Sets the mesh specific configuration of the WIFI Extension 2.0.
    # 
    # The ``enable`` parameter enables or disables the mesh part of the
    # WIFI Extension 2.0. The mesh part cannot be
    # enabled together with the client and access-point part.
    # 
    # If the ``root_ip`` parameter is set to all zero then ``root_subnet_mask``
    # and ``root_gateway`` parameters are also set to all zero and DHCP is used for
    # IP address configuration. Otherwise those three parameters can be used to
    # configure a static IP address. The default configuration is DHCP.
    # 
    # If the ``router_bssid`` parameter is set to all zero then the information is
    # taken from Wi-Fi scan when connecting the SSID as set by
    # BrickMaster#set_wifi2_mesh_router_ssid. This only works if the the SSID is not hidden.
    # In case the router has hidden SSID this parameter must be specified, otherwise
    # the node will not be able to reach the mesh router.
    # 
    # The ``group_id`` and the ``group_ssid_prefix`` parameters identifies a
    # particular mesh network and nodes configured with same ``group_id`` and the
    # ``group_ssid_prefix`` are considered to be in the same mesh network.
    # 
    # The ``gateway_ip`` and the ``gateway_port`` parameters specifies the location
    # of the brickd that supports mesh feature.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def set_wifi2_mesh_configuration(enable, root_ip, root_subnet_mask, root_gateway, router_bssid, group_id, group_ssid_prefix, gateway_ip, gateway_port)
      check_validity

      send_request FUNCTION_SET_WIFI2_MESH_CONFIGURATION, [enable, root_ip, root_subnet_mask, root_gateway, router_bssid, group_id, group_ssid_prefix, gateway_ip, gateway_port], '? C4 C4 C4 C6 C6 Z16 C4 S', 8, ''
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the mesh configuration as set by BrickMaster#set_wifi2_mesh_configuration.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_configuration
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_CONFIGURATION, [], '', 55, '? C4 C4 C4 C6 C6 Z16 C4 S'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Sets the mesh router SSID of the WIFI Extension 2.0.
    # It is used to specify the mesh router to connect to.
    # 
    # Note that even though in the argument of this function a 32 characters long SSID
    # is allowed, in practice valid SSID should have a maximum of 31 characters. This
    # is due to a bug in the mesh library that we use in the firmware of the extension.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def set_wifi2_mesh_router_ssid(ssid)
      check_validity

      send_request FUNCTION_SET_WIFI2_MESH_ROUTER_SSID, [ssid], 'Z32', 8, ''
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the mesh router SSID as set by BrickMaster#set_wifi2_mesh_router_ssid.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_router_ssid
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_ROUTER_SSID, [], '', 40, 'Z32'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Sets the mesh router password (up to 64 characters) for WPA/WPA2 encryption.
    # The password will be used to connect to the mesh router.
    # 
    # To apply configuration changes to the WIFI Extension 2.0 the
    # BrickMaster#save_wifi2_configuration function has to be called and the Master Brick
    # has to be restarted afterwards.
    # 
    # It is recommended to use the Brick Viewer to configure the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def set_wifi2_mesh_router_password(password)
      check_validity

      send_request FUNCTION_SET_WIFI2_MESH_ROUTER_PASSWORD, [password], 'Z64', 8, ''
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the mesh router password as set by BrickMaster#set_wifi2_mesh_router_password.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_router_password
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_ROUTER_PASSWORD, [], '', 72, 'Z64'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the common mesh status of the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_common_status
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_COMMON_STATUS, [], '', 21, 'C ? ? S L L'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the mesh client status of the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_client_status
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_CLIENT_STATUS, [], '', 58, 'Z32 C4 C4 C4 C6'
    end

    # Requires WIFI Extension 2.0 firmware 2.1.0.
    # 
    # Returns the mesh AP status of the WIFI Extension 2.0.
    # 
    # .. versionadded:: 2.4.2$nbsp;(Firmware)
    def get_wifi2_mesh_ap_status
      check_validity

      send_request FUNCTION_GET_WIFI2_MESH_AP_STATUS, [], '', 58, 'Z32 C4 C4 C4 C6'
    end

    # This function is for internal use to flash the initial
    # bootstrapper and bootloader to the Bricklets.
    # 
    # If you need to flash a boostrapper/bootloader (for exmaple
    # because you made your own Bricklet from scratch) please
    # take a look at our open source flash and test tool at
    # `https://github.com/Tinkerforge/flash-test <https://github.com/Tinkerforge/flash-test>`__
    # 
    # Don't use this function directly.
    # 
    # .. versionadded:: 2.5.0$nbsp;(Firmware)
    def set_bricklet_xmc_flash_config(config, parameter1, parameter2, data)
      check_validity

      send_request FUNCTION_SET_BRICKLET_XMC_FLASH_CONFIG, [config, parameter1, parameter2, data], 'L L L C52', 72, 'L C60'
    end

    # This function is for internal use to flash the initial
    # bootstrapper and bootloader to the Bricklets.
    # 
    # If you need to flash a boostrapper/bootloader (for exmaple
    # because you made your own Bricklet from scratch) please
    # take a look at our open source flash and test tool at
    # `https://github.com/Tinkerforge/flash-test <https://github.com/Tinkerforge/flash-test>`__
    # 
    # Don't use this function directly.
    # 
    # .. versionadded:: 2.5.0$nbsp;(Firmware)
    def set_bricklet_xmc_flash_data(data)
      check_validity

      send_request FUNCTION_SET_BRICKLET_XMC_FLASH_DATA, [data], 'C64', 12, 'L'
    end

    # This function is only available in Master Brick hardware version >= 3.0.
    # 
    # Enables/disables all four Bricklets if set to true/false.
    # 
    # If you disable the Bricklets the power supply to the Bricklets will be disconnected.
    # The Bricklets will lose all configurations if disabled.
    # 
    # .. versionadded:: 2.5.0$nbsp;(Firmware)
    def set_bricklets_enabled(bricklets_enabled)
      check_validity

      send_request FUNCTION_SET_BRICKLETS_ENABLED, [bricklets_enabled], '?', 8, ''
    end

    # Returns *true* if the Bricklets are enabled, *false* otherwise.
    # 
    # .. versionadded:: 2.5.0$nbsp;(Firmware)
    def get_bricklets_enabled
      check_validity

      send_request FUNCTION_GET_BRICKLETS_ENABLED, [], '', 9, '?'
    end

    # The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    # enabled, the Brick will try to adapt the baudrate for the communication
    # between Bricks and Bricklets according to the amount of data that is transferred.
    # 
    # The baudrate will be increased exponentially if lots of data is sent/received and
    # decreased linearly if little data is sent/received.
    # 
    # This lowers the baudrate in applications where little data is transferred (e.g.
    # a weather station) and increases the robustness. If there is lots of data to transfer
    # (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    # 
    # In cases where some data has to transferred as fast as possible every few seconds
    # (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    # the dynamic baudrate off to get the highest possible performance.
    # 
    # The maximum value of the baudrate can be set per port with the function
    # BrickMaster#set_spitfp_baudrate. If the dynamic baudrate is disabled, the baudrate
    # as set by BrickMaster#set_spitfp_baudrate will be used statically.
    # 
    # .. versionadded:: 2.4.6$nbsp;(Firmware)
    def set_spitfp_baudrate_config(enable_dynamic_baudrate, minimum_dynamic_baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, [enable_dynamic_baudrate, minimum_dynamic_baudrate], '? L', 8, ''
    end

    # Returns the baudrate config, see BrickMaster#set_spitfp_baudrate_config.
    # 
    # .. versionadded:: 2.4.6$nbsp;(Firmware)
    def get_spitfp_baudrate_config
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, [], '', 13, '? L'
    end

    # Returns the timeout count for the different communication methods.
    # 
    # The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
    # 
    # This function is mostly used for debugging during development, in normal operation
    # the counters should nearly always stay at 0.
    # 
    # .. versionadded:: 2.4.3$nbsp;(Firmware)
    def get_send_timeout_count(communication_method)
      check_validity

      send_request FUNCTION_GET_SEND_TIMEOUT_COUNT, [communication_method], 'C', 12, 'L'
    end

    # Sets the baudrate for a specific Bricklet port.
    # 
    # If you want to increase the throughput of Bricklets you can increase
    # the baudrate. If you get a high error count because of high
    # interference (see BrickMaster#get_spitfp_error_count) you can decrease the
    # baudrate.
    # 
    # If the dynamic baudrate feature is enabled, the baudrate set by this
    # function corresponds to the maximum baudrate (see BrickMaster#set_spitfp_baudrate_config).
    # 
    # Regulatory testing is done with the default baudrate. If CE compatibility
    # or similar is necessary in you applications we recommend to not change
    # the baudrate.
    # 
    # .. versionadded:: 2.4.3$nbsp;(Firmware)
    def set_spitfp_baudrate(bricklet_port, baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE, [bricklet_port, baudrate], 'k L', 8, ''
    end

    # Returns the baudrate for a given Bricklet port, see BrickMaster#set_spitfp_baudrate.
    # 
    # .. versionadded:: 2.4.3$nbsp;(Firmware)
    def get_spitfp_baudrate(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE, [bricklet_port], 'k', 12, 'L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Brick side. All
    # Bricklets have a similar function that returns the errors on the Bricklet side.
    # 
    # .. versionadded:: 2.4.3$nbsp;(Firmware)
    def get_spitfp_error_count(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [bricklet_port], 'k', 24, 'L L L L'
    end

    # Enables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.2$nbsp;(Firmware)
    def enable_status_led
      check_validity

      send_request FUNCTION_ENABLE_STATUS_LED, [], '', 8, ''
    end

    # Disables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.2$nbsp;(Firmware)
    def disable_status_led
      check_validity

      send_request FUNCTION_DISABLE_STATUS_LED, [], '', 8, ''
    end

    # Returns *true* if the status LED is enabled, *false* otherwise.
    # 
    # .. versionadded:: 2.3.2$nbsp;(Firmware)
    def is_status_led_enabled
      check_validity

      send_request FUNCTION_IS_STATUS_LED_ENABLED, [], '', 9, '?'
    end

    # Returns the firmware and protocol version and the name of the Bricklet for a
    # given port.
    # 
    # This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
    # plugins.
    def get_protocol1_bricklet_name(port)
      check_validity

      send_request FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, [port], 'k', 52, 'C C3 Z40'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has an
    # accuracy of ±15%. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Brick. Calling this function
    # on a Brick inside of a stack will reset the whole stack.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes 32 bytes of firmware to the bricklet attached at the given port.
    # The bytes are written to the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_bricklet_plugin(port, offset, chunk)
      check_validity

      send_request FUNCTION_WRITE_BRICKLET_PLUGIN, [port, offset, chunk], 'k C C32', 8, ''
    end

    # Reads 32 bytes of firmware from the bricklet attached at the given port.
    # The bytes are read starting at the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def read_bricklet_plugin(port, offset)
      check_validity

      send_request FUNCTION_READ_BRICKLET_PLUGIN, [port, offset], 'k C', 40, 'C32'
    end

    # Returns the UID, the UID where the Brick is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position is the position in the stack from '0' (bottom) to '8' (top).
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
