# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Drives one bipolar stepper motor with up to 38V and 2.5A per phase
  class BrickStepper < Device
    DEVICE_IDENTIFIER = 15 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Stepper Brick' # :nodoc:

    # This callback is triggered when the input voltage drops below the value set by
    # BrickStepper#set_minimum_voltage. The parameter is the current voltage.
    CALLBACK_UNDER_VOLTAGE = 31

    # This callback is triggered when a position set by BrickStepper#set_steps or
    # BrickStepper#set_target_position is reached.
    # 
    # .. note::
    #  Since we can't get any feedback from the stepper motor, this only works if the
    #  acceleration (see BrickStepper#set_speed_ramping) is set smaller or equal to the
    #  maximum acceleration of the motor. Otherwise the motor will lag behind the
    #  control value and the callback will be triggered too early.
    CALLBACK_POSITION_REACHED = 32

    # This callback is triggered periodically with the period that is set by
    # BrickStepper#set_all_data_period. The parameters are: the current velocity,
    # the current position, the remaining steps, the stack voltage, the external
    # voltage and the current consumption of the stepper motor.
    CALLBACK_ALL_DATA = 40

    # This callback is triggered whenever the Stepper Brick enters a new state.
    # It returns the new state as well as the previous state.
    CALLBACK_NEW_STATE = 41

    FUNCTION_SET_MAX_VELOCITY = 1 # :nodoc:
    FUNCTION_GET_MAX_VELOCITY = 2 # :nodoc:
    FUNCTION_GET_CURRENT_VELOCITY = 3 # :nodoc:
    FUNCTION_SET_SPEED_RAMPING = 4 # :nodoc:
    FUNCTION_GET_SPEED_RAMPING = 5 # :nodoc:
    FUNCTION_FULL_BRAKE = 6 # :nodoc:
    FUNCTION_SET_CURRENT_POSITION = 7 # :nodoc:
    FUNCTION_GET_CURRENT_POSITION = 8 # :nodoc:
    FUNCTION_SET_TARGET_POSITION = 9 # :nodoc:
    FUNCTION_GET_TARGET_POSITION = 10 # :nodoc:
    FUNCTION_SET_STEPS = 11 # :nodoc:
    FUNCTION_GET_STEPS = 12 # :nodoc:
    FUNCTION_GET_REMAINING_STEPS = 13 # :nodoc:
    FUNCTION_SET_STEP_MODE = 14 # :nodoc:
    FUNCTION_GET_STEP_MODE = 15 # :nodoc:
    FUNCTION_DRIVE_FORWARD = 16 # :nodoc:
    FUNCTION_DRIVE_BACKWARD = 17 # :nodoc:
    FUNCTION_STOP = 18 # :nodoc:
    FUNCTION_GET_STACK_INPUT_VOLTAGE = 19 # :nodoc:
    FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 20 # :nodoc:
    FUNCTION_GET_CURRENT_CONSUMPTION = 21 # :nodoc:
    FUNCTION_SET_MOTOR_CURRENT = 22 # :nodoc:
    FUNCTION_GET_MOTOR_CURRENT = 23 # :nodoc:
    FUNCTION_ENABLE = 24 # :nodoc:
    FUNCTION_DISABLE = 25 # :nodoc:
    FUNCTION_IS_ENABLED = 26 # :nodoc:
    FUNCTION_SET_DECAY = 27 # :nodoc:
    FUNCTION_GET_DECAY = 28 # :nodoc:
    FUNCTION_SET_MINIMUM_VOLTAGE = 29 # :nodoc:
    FUNCTION_GET_MINIMUM_VOLTAGE = 30 # :nodoc:
    FUNCTION_SET_SYNC_RECT = 33 # :nodoc:
    FUNCTION_IS_SYNC_RECT = 34 # :nodoc:
    FUNCTION_SET_TIME_BASE = 35 # :nodoc:
    FUNCTION_GET_TIME_BASE = 36 # :nodoc:
    FUNCTION_GET_ALL_DATA = 37 # :nodoc:
    FUNCTION_SET_ALL_DATA_PERIOD = 38 # :nodoc:
    FUNCTION_GET_ALL_DATA_PERIOD = 39 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 231 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 232 # :nodoc:
    FUNCTION_GET_SEND_TIMEOUT_COUNT = 233 # :nodoc:
    FUNCTION_SET_SPITFP_BAUDRATE = 234 # :nodoc:
    FUNCTION_GET_SPITFP_BAUDRATE = 235 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 237 # :nodoc:
    FUNCTION_ENABLE_STATUS_LED = 238 # :nodoc:
    FUNCTION_DISABLE_STATUS_LED = 239 # :nodoc:
    FUNCTION_IS_STATUS_LED_ENABLED = 240 # :nodoc:
    FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_BRICKLET_PLUGIN = 246 # :nodoc:
    FUNCTION_READ_BRICKLET_PLUGIN = 247 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    STEP_MODE_FULL_STEP = 1 # :nodoc:
    STEP_MODE_HALF_STEP = 2 # :nodoc:
    STEP_MODE_QUARTER_STEP = 4 # :nodoc:
    STEP_MODE_EIGHTH_STEP = 8 # :nodoc:
    STATE_STOP = 1 # :nodoc:
    STATE_ACCELERATION = 2 # :nodoc:
    STATE_RUN = 3 # :nodoc:
    STATE_DEACCELERATION = 4 # :nodoc:
    STATE_DIRECTION_CHANGE_TO_FORWARD = 5 # :nodoc:
    STATE_DIRECTION_CHANGE_TO_BACKWARD = 6 # :nodoc:
    COMMUNICATION_METHOD_NONE = 0 # :nodoc:
    COMMUNICATION_METHOD_USB = 1 # :nodoc:
    COMMUNICATION_METHOD_SPI_STACK = 2 # :nodoc:
    COMMUNICATION_METHOD_CHIBI = 3 # :nodoc:
    COMMUNICATION_METHOD_RS485 = 4 # :nodoc:
    COMMUNICATION_METHOD_WIFI = 5 # :nodoc:
    COMMUNICATION_METHOD_ETHERNET = 6 # :nodoc:
    COMMUNICATION_METHOD_WIFI_V2 = 7 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 4]

      @response_expected[FUNCTION_SET_MAX_VELOCITY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MAX_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPEED_RAMPING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPEED_RAMPING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_FULL_BRAKE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_CURRENT_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CURRENT_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TARGET_POSITION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TARGET_POSITION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STEPS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STEPS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REMAINING_STEPS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STEP_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STEP_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_DRIVE_FORWARD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DRIVE_BACKWARD] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_STOP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STACK_INPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CONSUMPTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTOR_CURRENT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOTOR_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DECAY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DECAY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MINIMUM_VOLTAGE] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MINIMUM_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SYNC_RECT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_SYNC_RECT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TIME_BASE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TIME_BASE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SEND_TIMEOUT_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_BAUDRATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_BRICKLET_PLUGIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_UNDER_VOLTAGE] = [10, 'S']
      @callback_formats[CALLBACK_POSITION_REACHED] = [12, 'l']
      @callback_formats[CALLBACK_ALL_DATA] = [24, 'S l l S S S']
      @callback_formats[CALLBACK_NEW_STATE] = [10, 'C C']

      @ipcon.add_device self
    end

    # Sets the maximum velocity of the stepper motor.
    # This function does *not* start the motor, it merely sets the maximum
    # velocity the stepper motor is accelerated to. To get the motor running use
    # either BrickStepper#set_target_position, BrickStepper#set_steps, BrickStepper#drive_forward or
    # BrickStepper#drive_backward.
    def set_max_velocity(velocity)
      check_validity

      send_request FUNCTION_SET_MAX_VELOCITY, [velocity], 'S', 8, ''
    end

    # Returns the velocity as set by BrickStepper#set_max_velocity.
    def get_max_velocity
      check_validity

      send_request FUNCTION_GET_MAX_VELOCITY, [], '', 10, 'S'
    end

    # Returns the *current* velocity of the stepper motor.
    def get_current_velocity
      check_validity

      send_request FUNCTION_GET_CURRENT_VELOCITY, [], '', 10, 'S'
    end

    # Sets the acceleration and deacceleration of the stepper motor.
    # An acceleration of 1000 means, that
    # every second the velocity is increased by 1000 *steps/s*.
    # 
    # For example: If the current velocity is 0 and you want to accelerate to a
    # velocity of 8000 *steps/s* in 10 seconds, you should set an acceleration
    # of 800 *steps/s²*.
    # 
    # An acceleration/deacceleration of 0 means instantaneous
    # acceleration/deacceleration (not recommended)
    def set_speed_ramping(acceleration, deacceleration)
      check_validity

      send_request FUNCTION_SET_SPEED_RAMPING, [acceleration, deacceleration], 'S S', 8, ''
    end

    # Returns the acceleration and deacceleration as set by
    # BrickStepper#set_speed_ramping.
    def get_speed_ramping
      check_validity

      send_request FUNCTION_GET_SPEED_RAMPING, [], '', 12, 'S S'
    end

    # Executes an active full brake.
    # 
    # .. warning::
    #  This function is for emergency purposes,
    #  where an immediate brake is necessary. Depending on the current velocity and
    #  the strength of the motor, a full brake can be quite violent.
    # 
    # Call BrickStepper#stop if you just want to stop the motor.
    def full_brake
      check_validity

      send_request FUNCTION_FULL_BRAKE, [], '', 8, ''
    end

    # Sets the current steps of the internal step counter. This can be used to
    # set the current position to 0 when some kind of starting position
    # is reached (e.g. when a CNC machine reaches a corner).
    def set_current_position(position)
      check_validity

      send_request FUNCTION_SET_CURRENT_POSITION, [position], 'l', 8, ''
    end

    # Returns the current position of the stepper motor in steps. On startup
    # the position is 0. The steps are counted with all possible driving
    # functions (BrickStepper#set_target_position, BrickStepper#set_steps, BrickStepper#drive_forward or
    # BrickStepper#drive_backward). It also is possible to reset the steps to 0 or
    # set them to any other desired value with BrickStepper#set_current_position.
    def get_current_position
      check_validity

      send_request FUNCTION_GET_CURRENT_POSITION, [], '', 12, 'l'
    end

    # Sets the target position of the stepper motor in steps. For example,
    # if the current position of the motor is 500 and BrickStepper#set_target_position is
    # called with 1000, the stepper motor will drive 500 steps forward. It will
    # use the velocity, acceleration and deacceleration as set by
    # BrickStepper#set_max_velocity and BrickStepper#set_speed_ramping.
    # 
    # A call of BrickStepper#set_target_position with the parameter *x* is equivalent to
    # a call of BrickStepper#set_steps with the parameter
    # (*x* - BrickStepper#get_current_position).
    def set_target_position(position)
      check_validity

      send_request FUNCTION_SET_TARGET_POSITION, [position], 'l', 8, ''
    end

    # Returns the last target position as set by BrickStepper#set_target_position.
    def get_target_position
      check_validity

      send_request FUNCTION_GET_TARGET_POSITION, [], '', 12, 'l'
    end

    # Sets the number of steps the stepper motor should run. Positive values
    # will drive the motor forward and negative values backward.
    # The velocity, acceleration and deacceleration as set by
    # BrickStepper#set_max_velocity and BrickStepper#set_speed_ramping will be used.
    def set_steps(steps)
      check_validity

      send_request FUNCTION_SET_STEPS, [steps], 'l', 8, ''
    end

    # Returns the last steps as set by BrickStepper#set_steps.
    def get_steps
      check_validity

      send_request FUNCTION_GET_STEPS, [], '', 12, 'l'
    end

    # Returns the remaining steps of the last call of BrickStepper#set_steps.
    # For example, if BrickStepper#set_steps is called with 2000 and
    # BrickStepper#get_remaining_steps is called after the motor has run for 500 steps,
    # it will return 1500.
    def get_remaining_steps
      check_validity

      send_request FUNCTION_GET_REMAINING_STEPS, [], '', 12, 'l'
    end

    # Sets the step mode of the stepper motor. Possible values are:
    # 
    # * Full Step = 1
    # * Half Step = 2
    # * Quarter Step = 4
    # * Eighth Step = 8
    # 
    # A higher value will increase the resolution and
    # decrease the torque of the stepper motor.
    def set_step_mode(mode)
      check_validity

      send_request FUNCTION_SET_STEP_MODE, [mode], 'C', 8, ''
    end

    # Returns the step mode as set by BrickStepper#set_step_mode.
    def get_step_mode
      check_validity

      send_request FUNCTION_GET_STEP_MODE, [], '', 9, 'C'
    end

    # Drives the stepper motor forward until BrickStepper#drive_backward or
    # BrickStepper#stop is called. The velocity, acceleration and deacceleration as
    # set by BrickStepper#set_max_velocity and BrickStepper#set_speed_ramping will be used.
    def drive_forward
      check_validity

      send_request FUNCTION_DRIVE_FORWARD, [], '', 8, ''
    end

    # Drives the stepper motor backward until BrickStepper#drive_forward or
    # BrickStepper#stop is triggered. The velocity, acceleration and deacceleration as
    # set by BrickStepper#set_max_velocity and BrickStepper#set_speed_ramping will be used.
    def drive_backward
      check_validity

      send_request FUNCTION_DRIVE_BACKWARD, [], '', 8, ''
    end

    # Stops the stepper motor with the deacceleration as set by
    # BrickStepper#set_speed_ramping.
    def stop
      check_validity

      send_request FUNCTION_STOP, [], '', 8, ''
    end

    # Returns the stack input voltage. The stack input voltage is the
    # voltage that is supplied via the stack, i.e. it is given by a
    # Step-Down or Step-Up Power Supply.
    def get_stack_input_voltage
      check_validity

      send_request FUNCTION_GET_STACK_INPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the external input voltage. The external input voltage is
    # given via the black power input connector on the Stepper Brick.
    # 
    # If there is an external input voltage and a stack input voltage, the motor
    # will be driven by the external input voltage. If there is only a stack
    # voltage present, the motor will be driven by this voltage.
    # 
    # .. warning::
    #  This means, if you have a high stack voltage and a low external voltage,
    #  the motor will be driven with the low external voltage. If you then remove
    #  the external connection, it will immediately be driven by the high
    #  stack voltage
    def get_external_input_voltage
      check_validity

      send_request FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, [], '', 10, 'S'
    end

    # Returns the current consumption of the motor.
    def get_current_consumption
      check_validity

      send_request FUNCTION_GET_CURRENT_CONSUMPTION, [], '', 10, 'S'
    end

    # Sets the current with which the motor will be driven.
    # 
    # .. warning::
    #  Do not set this value above the specifications of your stepper motor.
    #  Otherwise it may damage your motor.
    def set_motor_current(current)
      check_validity

      send_request FUNCTION_SET_MOTOR_CURRENT, [current], 'S', 8, ''
    end

    # Returns the current as set by BrickStepper#set_motor_current.
    def get_motor_current
      check_validity

      send_request FUNCTION_GET_MOTOR_CURRENT, [], '', 10, 'S'
    end

    # Enables the driver chip. The driver parameters can be configured (maximum velocity,
    # acceleration, etc) before it is enabled.
    def enable
      check_validity

      send_request FUNCTION_ENABLE, [], '', 8, ''
    end

    # Disables the driver chip. The configurations are kept (maximum velocity,
    # acceleration, etc) but the motor is not driven until it is enabled again.
    # 
    # .. warning::
    #  Disabling the driver chip while the motor is still turning can damage the
    #  driver chip. The motor should be stopped calling BrickStepper#stop function
    #  before disabling the motor power. The BrickStepper#stop function will **not**
    #  wait until the motor is actually stopped. You have to explicitly wait for the
    #  appropriate time after calling the BrickStepper#stop function before calling
    #  the BrickStepper#disable function.
    def disable
      check_validity

      send_request FUNCTION_DISABLE, [], '', 8, ''
    end

    # Returns *true* if the driver chip is enabled, *false* otherwise.
    def is_enabled
      check_validity

      send_request FUNCTION_IS_ENABLED, [], '', 9, '?'
    end

    # Sets the decay mode of the stepper motor.
    # A value of 0 sets the fast decay mode, a value of
    # 65535 sets the slow decay mode and a value in between sets the mixed
    # decay mode.
    # 
    # Changing the decay mode is only possible if synchronous rectification
    # is enabled (see BrickStepper#set_sync_rect).
    # 
    # For a good explanation of the different decay modes see
    # `this <https://ebldc.com/?p=86/>`__ blog post by Avayan.
    # 
    # A good decay mode is unfortunately different for every motor. The best
    # way to work out a good decay mode for your stepper motor, if you can't
    # measure the current with an oscilloscope, is to listen to the sound of
    # the motor. If the value is too low, you often hear a high pitched
    # sound and if it is too high you can often hear a humming sound.
    # 
    # Generally, fast decay mode (small value) will be noisier but also
    # allow higher motor speeds.
    # 
    # .. note::
    #  There is unfortunately no formula to calculate a perfect decay
    #  mode for a given stepper motor. If you have problems with loud noises
    #  or the maximum motor speed is too slow, you should try to tinker with
    #  the decay value
    def set_decay(decay)
      check_validity

      send_request FUNCTION_SET_DECAY, [decay], 'S', 8, ''
    end

    # Returns the decay mode as set by BrickStepper#set_decay.
    def get_decay
      check_validity

      send_request FUNCTION_GET_DECAY, [], '', 10, 'S'
    end

    # Sets the minimum voltage, below which the CALLBACK_UNDER_VOLTAGE callback
    # is triggered. The minimum possible value that works with the Stepper Brick is 8V.
    # You can use this function to detect the discharge of a battery that is used
    # to drive the stepper motor. If you have a fixed power supply, you likely do
    # not need this functionality.
    def set_minimum_voltage(voltage)
      check_validity

      send_request FUNCTION_SET_MINIMUM_VOLTAGE, [voltage], 'S', 8, ''
    end

    # Returns the minimum voltage as set by BrickStepper#set_minimum_voltage.
    def get_minimum_voltage
      check_validity

      send_request FUNCTION_GET_MINIMUM_VOLTAGE, [], '', 10, 'S'
    end

    # Turns synchronous rectification on or off (*true* or *false*).
    # 
    # With synchronous rectification on, the decay can be changed
    # (see BrickStepper#set_decay). Without synchronous rectification fast
    # decay is used.
    # 
    # For an explanation of synchronous rectification see
    # `here <https://en.wikipedia.org/wiki/Active_rectification>`__.
    # 
    # .. warning::
    #  If you want to use high speeds (> 10000 steps/s) for a large
    #  stepper motor with a large inductivity we strongly
    #  suggest that you disable synchronous rectification. Otherwise the
    #  Brick may not be able to cope with the load and overheat.
    def set_sync_rect(sync_rect)
      check_validity

      send_request FUNCTION_SET_SYNC_RECT, [sync_rect], '?', 8, ''
    end

    # Returns *true* if synchronous rectification is enabled, *false* otherwise.
    def is_sync_rect
      check_validity

      send_request FUNCTION_IS_SYNC_RECT, [], '', 9, '?'
    end

    # Sets the time base of the velocity and the acceleration of the stepper brick.
    # 
    # For example, if you want to make one step every 1.5 seconds, you can set
    # the time base to 15 and the velocity to 10. Now the velocity is
    # 10steps/15s = 1steps/1.5s.
    def set_time_base(time_base)
      check_validity

      send_request FUNCTION_SET_TIME_BASE, [time_base], 'L', 8, ''
    end

    # Returns the time base as set by BrickStepper#set_time_base.
    def get_time_base
      check_validity

      send_request FUNCTION_GET_TIME_BASE, [], '', 12, 'L'
    end

    # Returns the following parameters: The current velocity,
    # the current position, the remaining steps, the stack voltage, the external
    # voltage and the current consumption of the stepper motor.
    # 
    # There is also a callback for this function, see CALLBACK_ALL_DATA callback.
    def get_all_data
      check_validity

      send_request FUNCTION_GET_ALL_DATA, [], '', 24, 'S l l S S S'
    end

    # Sets the period with which the CALLBACK_ALL_DATA callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_all_data_period(period)
      check_validity

      send_request FUNCTION_SET_ALL_DATA_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickStepper#set_all_data_period.
    def get_all_data_period
      check_validity

      send_request FUNCTION_GET_ALL_DATA_PERIOD, [], '', 12, 'L'
    end

    # The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    # enabled, the Brick will try to adapt the baudrate for the communication
    # between Bricks and Bricklets according to the amount of data that is transferred.
    # 
    # The baudrate will be increased exponentially if lots of data is sent/received and
    # decreased linearly if little data is sent/received.
    # 
    # This lowers the baudrate in applications where little data is transferred (e.g.
    # a weather station) and increases the robustness. If there is lots of data to transfer
    # (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    # 
    # In cases where some data has to transferred as fast as possible every few seconds
    # (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    # the dynamic baudrate off to get the highest possible performance.
    # 
    # The maximum value of the baudrate can be set per port with the function
    # BrickStepper#set_spitfp_baudrate. If the dynamic baudrate is disabled, the baudrate
    # as set by BrickStepper#set_spitfp_baudrate will be used statically.
    # 
    # .. versionadded:: 2.3.6$nbsp;(Firmware)
    def set_spitfp_baudrate_config(enable_dynamic_baudrate, minimum_dynamic_baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, [enable_dynamic_baudrate, minimum_dynamic_baudrate], '? L', 8, ''
    end

    # Returns the baudrate config, see BrickStepper#set_spitfp_baudrate_config.
    # 
    # .. versionadded:: 2.3.6$nbsp;(Firmware)
    def get_spitfp_baudrate_config
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, [], '', 13, '? L'
    end

    # Returns the timeout count for the different communication methods.
    # 
    # The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
    # 
    # This function is mostly used for debugging during development, in normal operation
    # the counters should nearly always stay at 0.
    # 
    # .. versionadded:: 2.3.4$nbsp;(Firmware)
    def get_send_timeout_count(communication_method)
      check_validity

      send_request FUNCTION_GET_SEND_TIMEOUT_COUNT, [communication_method], 'C', 12, 'L'
    end

    # Sets the baudrate for a specific Bricklet port.
    # 
    # If you want to increase the throughput of Bricklets you can increase
    # the baudrate. If you get a high error count because of high
    # interference (see BrickStepper#get_spitfp_error_count) you can decrease the
    # baudrate.
    # 
    # If the dynamic baudrate feature is enabled, the baudrate set by this
    # function corresponds to the maximum baudrate (see BrickStepper#set_spitfp_baudrate_config).
    # 
    # Regulatory testing is done with the default baudrate. If CE compatibility
    # or similar is necessary in you applications we recommend to not change
    # the baudrate.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def set_spitfp_baudrate(bricklet_port, baudrate)
      check_validity

      send_request FUNCTION_SET_SPITFP_BAUDRATE, [bricklet_port, baudrate], 'k L', 8, ''
    end

    # Returns the baudrate for a given Bricklet port, see BrickStepper#set_spitfp_baudrate.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def get_spitfp_baudrate(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_BAUDRATE, [bricklet_port], 'k', 12, 'L'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Brick side. All
    # Bricklets have a similar function that returns the errors on the Bricklet side.
    # 
    # .. versionadded:: 2.3.3$nbsp;(Firmware)
    def get_spitfp_error_count(bricklet_port)
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [bricklet_port], 'k', 24, 'L L L L'
    end

    # Enables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def enable_status_led
      check_validity

      send_request FUNCTION_ENABLE_STATUS_LED, [], '', 8, ''
    end

    # Disables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def disable_status_led
      check_validity

      send_request FUNCTION_DISABLE_STATUS_LED, [], '', 8, ''
    end

    # Returns *true* if the status LED is enabled, *false* otherwise.
    # 
    # .. versionadded:: 2.3.1$nbsp;(Firmware)
    def is_status_led_enabled
      check_validity

      send_request FUNCTION_IS_STATUS_LED_ENABLED, [], '', 9, '?'
    end

    # Returns the firmware and protocol version and the name of the Bricklet for a
    # given port.
    # 
    # This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
    # plugins.
    def get_protocol1_bricklet_name(port)
      check_validity

      send_request FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, [port], 'k', 52, 'C C3 Z40'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has an
    # accuracy of ±15%. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Brick. Calling this function
    # on a Brick inside of a stack will reset the whole stack.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes 32 bytes of firmware to the bricklet attached at the given port.
    # The bytes are written to the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_bricklet_plugin(port, offset, chunk)
      check_validity

      send_request FUNCTION_WRITE_BRICKLET_PLUGIN, [port, offset, chunk], 'k C C32', 8, ''
    end

    # Reads 32 bytes of firmware from the bricklet attached at the given port.
    # The bytes are read starting at the position offset * 32.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def read_bricklet_plugin(port, offset)
      check_validity

      send_request FUNCTION_READ_BRICKLET_PLUGIN, [port, offset], 'k C', 40, 'C32'
    end

    # Returns the UID, the UID where the Brick is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position is the position in the stack from '0' (bottom) to '8' (top).
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
