# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures air pressure and altitude changes
  class BrickletBarometer < Device
    DEVICE_IDENTIFIER = 221 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Barometer Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletBarometer#set_air_pressure_callback_period. The parameter is the air
    # pressure of the air pressure sensor.
    # 
    # The CALLBACK_AIR_PRESSURE callback is only triggered if the air pressure has
    # changed since the last triggering.
    CALLBACK_AIR_PRESSURE = 15

    # This callback is triggered periodically with the period that is set by
    # BrickletBarometer#set_altitude_callback_period. The parameter is the altitude of
    # the air pressure sensor.
    # 
    # The CALLBACK_ALTITUDE callback is only triggered if the altitude has changed since
    # the last triggering.
    CALLBACK_ALTITUDE = 16

    # This callback is triggered when the threshold as set by
    # BrickletBarometer#set_air_pressure_callback_threshold is reached.
    # The parameter is the air pressure of the air pressure sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletBarometer#set_debounce_period.
    CALLBACK_AIR_PRESSURE_REACHED = 17

    # This callback is triggered when the threshold as set by
    # BrickletBarometer#set_altitude_callback_threshold is reached.
    # The parameter is the altitude of the air pressure sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletBarometer#set_debounce_period.
    CALLBACK_ALTITUDE_REACHED = 18

    FUNCTION_GET_AIR_PRESSURE = 1 # :nodoc:
    FUNCTION_GET_ALTITUDE = 2 # :nodoc:
    FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:
    FUNCTION_SET_REFERENCE_AIR_PRESSURE = 13 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 14 # :nodoc:
    FUNCTION_GET_REFERENCE_AIR_PRESSURE = 19 # :nodoc:
    FUNCTION_SET_AVERAGING = 20 # :nodoc:
    FUNCTION_GET_AVERAGING = 21 # :nodoc:
    FUNCTION_SET_I2C_MODE = 22 # :nodoc:
    FUNCTION_GET_I2C_MODE = 23 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    I2C_MODE_FAST = 0 # :nodoc:
    I2C_MODE_SLOW = 1 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 2]

      @response_expected[FUNCTION_GET_AIR_PRESSURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_REFERENCE_AIR_PRESSURE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REFERENCE_AIR_PRESSURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AVERAGING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_AVERAGING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_I2C_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_I2C_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_AIR_PRESSURE] = [12, 'l']
      @callback_formats[CALLBACK_ALTITUDE] = [12, 'l']
      @callback_formats[CALLBACK_AIR_PRESSURE_REACHED] = [12, 'l']
      @callback_formats[CALLBACK_ALTITUDE_REACHED] = [12, 'l']

      @ipcon.add_device self
    end

    # Returns the air pressure of the air pressure sensor.
    # 
    # If you want to get the air pressure periodically, it is recommended to use the
    # CALLBACK_AIR_PRESSURE callback and set the period with
    # BrickletBarometer#set_air_pressure_callback_period.
    def get_air_pressure
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE, [], '', 12, 'l'
    end

    # Returns the relative altitude of the air pressure sensor. The value is
    # calculated based on the difference between the current air pressure
    # and the reference air pressure that can be set with BrickletBarometer#set_reference_air_pressure.
    # 
    # If you want to get the altitude periodically, it is recommended to use the
    # CALLBACK_ALTITUDE callback and set the period with
    # BrickletBarometer#set_altitude_callback_period.
    def get_altitude
      check_validity

      send_request FUNCTION_GET_ALTITUDE, [], '', 12, 'l'
    end

    # Sets the period with which the CALLBACK_AIR_PRESSURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_AIR_PRESSURE callback is only triggered if the air pressure has
    # changed since the last triggering.
    def set_air_pressure_callback_period(period)
      check_validity

      send_request FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletBarometer#set_air_pressure_callback_period.
    def get_air_pressure_callback_period
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ALTITUDE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ALTITUDE callback is only triggered if the altitude has changed since
    # the last triggering.
    def set_altitude_callback_period(period)
      check_validity

      send_request FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletBarometer#set_altitude_callback_period.
    def get_altitude_callback_period
      check_validity

      send_request FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the thresholds for the CALLBACK_AIR_PRESSURE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the air pressure is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the air pressure is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the air pressure is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the air pressure is greater than the min value (max is ignored)"
    def set_air_pressure_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 8, ''
    end

    # Returns the threshold as set by BrickletBarometer#set_air_pressure_callback_threshold.
    def get_air_pressure_callback_threshold
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD, [], '', 17, 'k l l'
    end

    # Sets the thresholds for the CALLBACK_ALTITUDE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the altitude is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the altitude is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the altitude is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the altitude is greater than the min value (max is ignored)"
    def set_altitude_callback_threshold(option, min, max)
      check_validity

      send_request FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 8, ''
    end

    # Returns the threshold as set by BrickletBarometer#set_altitude_callback_threshold.
    def get_altitude_callback_threshold
      check_validity

      send_request FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD, [], '', 17, 'k l l'
    end

    # Sets the period with which the threshold callbacks
    # 
    # * CALLBACK_AIR_PRESSURE_REACHED,
    # * CALLBACK_ALTITUDE_REACHED
    # 
    # are triggered, if the thresholds
    # 
    # * BrickletBarometer#set_air_pressure_callback_threshold,
    # * BrickletBarometer#set_altitude_callback_threshold
    # 
    # keep being reached.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletBarometer#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Sets the reference air pressure for the altitude calculation.
    # Setting the reference to the current air pressure results in a calculated
    # altitude of 0cm. Passing 0 is a shortcut for passing the current air pressure as
    # reference.
    # 
    # Well known reference values are the Q codes
    # `QNH <https://en.wikipedia.org/wiki/QNH>`__ and
    # `QFE <https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure>`__
    # used in aviation.
    def set_reference_air_pressure(air_pressure)
      check_validity

      send_request FUNCTION_SET_REFERENCE_AIR_PRESSURE, [air_pressure], 'l', 8, ''
    end

    # Returns the temperature of the air pressure sensor.
    # 
    # This temperature is used internally for temperature compensation of the air
    # pressure measurement. It is not as accurate as the temperature measured by the
    # :ref:`temperature_bricklet` or the :ref:`temperature_ir_bricklet`.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Returns the reference air pressure as set by BrickletBarometer#set_reference_air_pressure.
    def get_reference_air_pressure
      check_validity

      send_request FUNCTION_GET_REFERENCE_AIR_PRESSURE, [], '', 12, 'l'
    end

    # Sets the different averaging parameters. It is possible to set
    # the length of a normal averaging for the temperature and pressure,
    # as well as an additional length of a
    # `moving average <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the pressure. The moving average is calculated from the normal
    # averages.  There is no moving average for the temperature.
    # 
    # Setting the all three parameters to 0 will turn the averaging
    # completely off. If the averaging is off, there is lots of noise
    # on the data, but the data is without delay. Thus we recommend
    # to turn the averaging off if the Barometer Bricklet data is
    # to be used for sensor fusion with other sensors.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def set_averaging(moving_average_pressure, average_pressure, average_temperature)
      check_validity

      send_request FUNCTION_SET_AVERAGING, [moving_average_pressure, average_pressure, average_temperature], 'C C C', 8, ''
    end

    # Returns the averaging configuration as set by BrickletBarometer#set_averaging.
    # 
    # .. versionadded:: 2.0.1$nbsp;(Plugin)
    def get_averaging
      check_validity

      send_request FUNCTION_GET_AVERAGING, [], '', 11, 'C C C'
    end

    # Sets the I2C mode. Possible modes are:
    # 
    # * 0: Fast (400kHz)
    # * 1: Slow (100kHz)
    # 
    # If you have problems with obvious outliers in the
    # Barometer Bricklet measurements, they may be caused by EMI issues.
    # In this case it may be helpful to lower the I2C speed.
    # 
    # It is however not recommended to lower the I2C speed in applications where
    # a high throughput needs to be achieved.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def set_i2c_mode(mode)
      check_validity

      send_request FUNCTION_SET_I2C_MODE, [mode], 'C', 8, ''
    end

    # Returns the I2C mode as set by BrickletBarometer#set_i2c_mode.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_i2c_mode
      check_validity

      send_request FUNCTION_GET_I2C_MODE, [], '', 9, 'C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
