# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures CO2 concentration, temperature and humidity
  class BrickletCO2V2 < Device
    DEVICE_IDENTIFIER = 2147 # :nodoc:
    DEVICE_DISPLAY_NAME = 'CO2 Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletCO2V2#set_all_values_callback_configuration.
    # 
    # The parameters are the same as BrickletCO2V2#get_all_values.
    # 
    # .. note::
    #  The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    #  Exposing the Bricklet to higher temperatures might result in permanent damage.
    CALLBACK_ALL_VALUES = 8

    # This callback is triggered periodically according to the configuration set by
    # BrickletCO2V2#set_co2_concentration_callback_configuration.
    # 
    # The parameter is the same as BrickletCO2V2#get_co2_concentration.
    CALLBACK_CO2_CONCENTRATION = 12

    # This callback is triggered periodically according to the configuration set by
    # BrickletCO2V2#set_temperature_callback_configuration.
    # 
    # The parameter is the same as BrickletCO2V2#get_temperature.
    CALLBACK_TEMPERATURE = 16

    # This callback is triggered periodically according to the configuration set by
    # BrickletCO2V2#set_humidity_callback_configuration.
    # 
    # The parameter is the same as BrickletCO2V2#get_humidity.
    CALLBACK_HUMIDITY = 20

    FUNCTION_GET_ALL_VALUES = 1 # :nodoc:
    FUNCTION_SET_AIR_PRESSURE = 2 # :nodoc:
    FUNCTION_GET_AIR_PRESSURE = 3 # :nodoc:
    FUNCTION_SET_TEMPERATURE_OFFSET = 4 # :nodoc:
    FUNCTION_GET_TEMPERATURE_OFFSET = 5 # :nodoc:
    FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_GET_CO2_CONCENTRATION = 9 # :nodoc:
    FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION = 10 # :nodoc:
    FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION = 11 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 13 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = 14 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_HUMIDITY = 17 # :nodoc:
    FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION = 18 # :nodoc:
    FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION = 19 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_ALL_VALUES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_AIR_PRESSURE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_AIR_PRESSURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_OFFSET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_TEMPERATURE_OFFSET] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CO2_CONCENTRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_HUMIDITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ALL_VALUES] = [14, 'S s S']
      @callback_formats[CALLBACK_CO2_CONCENTRATION] = [10, 'S']
      @callback_formats[CALLBACK_TEMPERATURE] = [10, 's']
      @callback_formats[CALLBACK_HUMIDITY] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns all values measured by the CO2 Bricklet 2.0.
    # 
    # If you want to get the values periodically, it is recommended to use the
    # CALLBACK_ALL_VALUES callback. You can set the callback configuration
    # with BrickletCO2V2#set_all_values_callback_configuration.
    # 
    # .. note::
    #  The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    #  Exposing the Bricklet to higher temperatures might result in permanent damage.
    def get_all_values
      check_validity

      send_request FUNCTION_GET_ALL_VALUES, [], '', 14, 'S s S'
    end

    # The CO2 concentration depends (among other things) on the ambient air pressure.
    # 
    # To increase the accuracy of the CO2 Bricklet 2.0 you can set the current air pressure.
    # You use the :ref:`Barometer Bricklet 2.0 <barometer_v2_bricklet>` or the
    # :ref:`Air Quality Bricklet <air_quality_bricklet>` to get the current air pressure.
    # 
    # By default air pressure compensation is disabled. Once you set a value it
    # will be used for compensation. You can turn the compensation off again by
    # setting the value to 0.
    # 
    # It is sufficient to update the value every few minutes.
    def set_air_pressure(air_pressure)
      check_validity

      send_request FUNCTION_SET_AIR_PRESSURE, [air_pressure], 'S', 8, ''
    end

    # Returns the ambient air pressure as set by BrickletCO2V2#set_air_pressure.
    def get_air_pressure
      check_validity

      send_request FUNCTION_GET_AIR_PRESSURE, [], '', 10, 'S'
    end

    # Sets a temperature offset. A offset of 10 will decrease
    # the measured temperature by 0.1 °C.
    # 
    # If you install this Bricklet into an enclosure and you want to measure the ambient
    # temperature, you may have to decrease the measured temperature by some value to
    # compensate for the error because of the heating inside of the enclosure.
    # 
    # We recommend that you leave the parts in the enclosure running for at least
    # 24 hours such that a temperature equilibrium can be reached. After that you can measure
    # the temperature directly outside of enclosure and set the difference as offset.
    # 
    # This temperature offset is used to calculate the relative humidity and
    # CO2 concentration. In case the Bricklet is installed in an enclosure, we
    # recommend to measure and set the temperature offset to improve the accuracy of
    # the measurements.
    # 
    # It is sufficient to set the temperature offset once. The offset is saved in
    # non-volatile memory and is applied again after a power loss.
    def set_temperature_offset(offset)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_OFFSET, [offset], 'S', 8, ''
    end

    # Returns the temperature offset as set by
    # BrickletCO2V2#set_temperature_offset.
    def get_temperature_offset
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_OFFSET, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_ALL_VALUES
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after at least one of the values has changed. If the values didn't
    # change within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_all_values_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletCO2V2#set_all_values_callback_configuration.
    def get_all_values_callback_configuration
      check_validity

      send_request FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Returns CO2 concentration.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_CO2_CONCENTRATION callback. You can set the callback configuration
    # with BrickletCO2V2#set_co2_concentration_callback_configuration.
    def get_co2_concentration
      check_validity

      send_request FUNCTION_GET_CO2_CONCENTRATION, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_CO2_CONCENTRATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_CO2_CONCENTRATION callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_co2_concentration_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletCO2V2#set_co2_concentration_callback_configuration.
    def get_co2_concentration_callback_configuration
      check_validity

      send_request FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Returns temperature.
    # 
    # .. note::
    #  The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    #  Exposing the Bricklet to higher temperatures might result in permanent damage.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_TEMPERATURE callback. You can set the callback configuration
    # with BrickletCO2V2#set_temperature_callback_configuration.
    def get_temperature
      check_validity

      send_request FUNCTION_GET_TEMPERATURE, [], '', 10, 's'
    end

    # The period is the period with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_TEMPERATURE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_temperature_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k s s', 8, ''
    end

    # Returns the callback configuration as set by BrickletCO2V2#set_temperature_callback_configuration.
    def get_temperature_callback_configuration
      check_validity

      send_request FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k s s'
    end

    # Returns relative humidity.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_HUMIDITY callback. You can set the callback configuration
    # with BrickletCO2V2#set_humidity_callback_configuration.
    def get_humidity
      check_validity

      send_request FUNCTION_GET_HUMIDITY, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_HUMIDITY callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_HUMIDITY callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_humidity_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletCO2V2#set_humidity_callback_configuration.
    def get_humidity_callback_configuration
      check_validity

      send_request FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletCO2V2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletCO2V2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletCO2V2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletCO2V2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
