# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures color (RGB value), illuminance and color temperature
  class BrickletColorV2 < Device
    DEVICE_IDENTIFIER = 2128 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Color Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletColorV2#set_color_callback_configuration. The parameter is the color
    # of the sensor as RGBC.
    # 
    # The CALLBACK_COLOR callback is only triggered if the color has changed since the
    # last triggering.
    CALLBACK_COLOR = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletColorV2#set_illuminance_callback_configuration.
    # 
    # The parameter is the same as BrickletColorV2#get_illuminance.
    CALLBACK_ILLUMINANCE = 8

    # This callback is triggered periodically according to the configuration set by
    # BrickletColorV2#set_color_temperature_callback_configuration.
    # 
    # The parameter is the same as BrickletColorV2#get_color_temperature.
    CALLBACK_COLOR_TEMPERATURE = 12

    FUNCTION_GET_COLOR = 1 # :nodoc:
    FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_ILLUMINANCE = 5 # :nodoc:
    FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_GET_COLOR_TEMPERATURE = 9 # :nodoc:
    FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION = 10 # :nodoc:
    FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION = 11 # :nodoc:
    FUNCTION_SET_LIGHT = 13 # :nodoc:
    FUNCTION_GET_LIGHT = 14 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    GAIN_1X = 0 # :nodoc:
    GAIN_4X = 1 # :nodoc:
    GAIN_16X = 2 # :nodoc:
    GAIN_60X = 3 # :nodoc:
    INTEGRATION_TIME_2MS = 0 # :nodoc:
    INTEGRATION_TIME_24MS = 1 # :nodoc:
    INTEGRATION_TIME_101MS = 2 # :nodoc:
    INTEGRATION_TIME_154MS = 3 # :nodoc:
    INTEGRATION_TIME_700MS = 4 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_COLOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ILLUMINANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_COLOR_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_LIGHT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_LIGHT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_COLOR] = [16, 'S S S S']
      @callback_formats[CALLBACK_ILLUMINANCE] = [12, 'L']
      @callback_formats[CALLBACK_COLOR_TEMPERATURE] = [10, 'S']

      @ipcon.add_device self
    end

    # Returns the measured color of the sensor.
    # 
    # The red (r), green (g), blue (b) and clear (c) colors are measured
    # with four different photodiodes that are responsive at different
    # wavelengths:
    # 
    # .. image:: /Images/Bricklets/bricklet_color_wavelength_chart_600.jpg
    #    :scale: 100 %
    #    :alt: Chart Responsivity / Wavelength
    #    :align: center
    #    :target: ../../_images/Bricklets/bricklet_color_wavelength_chart_600.jpg
    # 
    # If you want to get the color periodically, it is recommended
    # to use the CALLBACK_COLOR callback and set the period with
    # BrickletColorV2#set_color_callback_configuration.
    def get_color
      check_validity

      send_request FUNCTION_GET_COLOR, [], '', 16, 'S S S S'
    end

    # The period is the period with which the CALLBACK_COLOR
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_color_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_COLOR_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletColorV2#set_color_callback_configuration.
    def get_color_callback_configuration
      check_validity

      send_request FUNCTION_GET_COLOR_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Returns the illuminance affected by the gain and integration time as
    # set by BrickletColorV2#set_configuration. To get the illuminance in Lux apply this formula::
    # 
    #  lux = illuminance * 700 / gain / integration_time
    # 
    # To get a correct illuminance measurement make sure that the color
    # values themselves are not saturated. The color value (R, G or B)
    # is saturated if it is equal to the maximum value of 65535.
    # In that case you have to reduce the gain, see BrickletColorV2#set_configuration.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_ILLUMINANCE callback. You can set the callback configuration
    # with BrickletColorV2#set_illuminance_callback_configuration.
    def get_illuminance
      check_validity

      send_request FUNCTION_GET_ILLUMINANCE, [], '', 12, 'L'
    end

    # The period is the period with which the CALLBACK_ILLUMINANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_ILLUMINANCE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_illuminance_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_ILLUMINANCE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k L L', 8, ''
    end

    # Returns the callback configuration as set by BrickletColorV2#set_illuminance_callback_configuration.
    def get_illuminance_callback_configuration
      check_validity

      send_request FUNCTION_GET_ILLUMINANCE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k L L'
    end

    # Returns the color temperature.
    # 
    # To get a correct color temperature measurement make sure that the color
    # values themselves are not saturated. The color value (R, G or B)
    # is saturated if it is equal to the maximum value of 65535.
    # In that case you have to reduce the gain, see BrickletColorV2#set_configuration.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_COLOR_TEMPERATURE callback. You can set the callback configuration
    # with BrickletColorV2#set_color_temperature_callback_configuration.
    def get_color_temperature
      check_validity

      send_request FUNCTION_GET_COLOR_TEMPERATURE, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_COLOR_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_COLOR_TEMPERATURE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_color_temperature_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletColorV2#set_color_temperature_callback_configuration.
    def get_color_temperature_callback_configuration
      check_validity

      send_request FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Turns the white LED on the Bricklet on/off.
    def set_light(enable)
      check_validity

      send_request FUNCTION_SET_LIGHT, [enable], '?', 8, ''
    end

    # Returns the value as set by BrickletColorV2#set_light.
    def get_light
      check_validity

      send_request FUNCTION_GET_LIGHT, [], '', 9, '?'
    end

    # Sets the configuration of the sensor. Gain and integration time
    # can be configured this way.
    # 
    # For configuring the gain:
    # 
    # * 0: 1x Gain
    # * 1: 4x Gain
    # * 2: 16x Gain
    # * 3: 60x Gain
    # 
    # For configuring the integration time:
    # 
    # * 0: 2.4ms
    # * 1: 24ms
    # * 2: 101ms
    # * 3: 154ms
    # * 4: 700ms
    # 
    # Increasing the gain enables the sensor to detect a
    # color from a higher distance.
    # 
    # The integration time provides a trade-off between conversion time
    # and accuracy. With a longer integration time the values read will
    # be more accurate but it will take longer to get the conversion
    # results.
    def set_configuration(gain, integration_time)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [gain, integration_time], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletColorV2#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 10, 'C C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletColorV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletColorV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletColorV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletColorV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
