# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures distance up to 150cm with infrared light
  class BrickletDistanceIRV2 < Device
    DEVICE_IDENTIFIER = 2125 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Distance IR Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletDistanceIRV2#set_distance_callback_configuration.
    # 
    # The parameter is the same as BrickletDistanceIRV2#get_distance.
    CALLBACK_DISTANCE = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletDistanceIRV2#set_analog_value_callback_configuration.
    # 
    # The parameter is the same as BrickletDistanceIRV2#get_analog_value.
    CALLBACK_ANALOG_VALUE = 8

    FUNCTION_GET_DISTANCE = 1 # :nodoc:
    FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE = 5 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = 10 # :nodoc:
    FUNCTION_SET_DISTANCE_LED_CONFIG = 11 # :nodoc:
    FUNCTION_GET_DISTANCE_LED_CONFIG = 12 # :nodoc:
    FUNCTION_SET_SENSOR_TYPE = 13 # :nodoc:
    FUNCTION_GET_SENSOR_TYPE = 14 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    DISTANCE_LED_CONFIG_OFF = 0 # :nodoc:
    DISTANCE_LED_CONFIG_ON = 1 # :nodoc:
    DISTANCE_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    DISTANCE_LED_CONFIG_SHOW_DISTANCE = 3 # :nodoc:
    SENSOR_TYPE_2Y0A41 = 0 # :nodoc:
    SENSOR_TYPE_2Y0A21 = 1 # :nodoc:
    SENSOR_TYPE_2Y0A02 = 2 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_DISTANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DISTANCE_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_TYPE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SENSOR_TYPE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_DISTANCE] = [10, 'S']
      @callback_formats[CALLBACK_ANALOG_VALUE] = [12, 'L']

      @ipcon.add_device self
    end

    # Returns the distance measured by the sensor. Possible
    # distance ranges are 40 to 300, 100 to 800 and 200 to 1500, depending on the
    # selected IR sensor.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_DISTANCE callback. You can set the callback configuration
    # with BrickletDistanceIRV2#set_distance_callback_configuration.
    def get_distance
      check_validity

      send_request FUNCTION_GET_DISTANCE, [], '', 10, 'S'
    end

    # The period is the period with which the CALLBACK_DISTANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_DISTANCE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_distance_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k S S', 8, ''
    end

    # Returns the callback configuration as set by BrickletDistanceIRV2#set_distance_callback_configuration.
    def get_distance_callback_configuration
      check_validity

      send_request FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION, [], '', 18, 'L ? k S S'
    end

    # Returns the analog value as read by a analog-to-digital converter.
    # 
    # This is unfiltered raw data. We made sure that the integration time
    # of the ADC is shorter then the measurement interval of the sensor
    # (10ms vs 16.5ms). So there is no information lost.
    # 
    # If you want to do your own calibration or create your own lookup table
    # you can use this value.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_ANALOG_VALUE callback. You can set the callback configuration
    # with BrickletDistanceIRV2#set_analog_value_callback_configuration.
    def get_analog_value
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE, [], '', 12, 'L'
    end

    # The period is the period with which the CALLBACK_ANALOG_VALUE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_ANALOG_VALUE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_analog_value_callback_configuration(period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION, [period, value_has_to_change, option, min, max], 'L ? k L L', 8, ''
    end

    # Returns the callback configuration as set by BrickletDistanceIRV2#set_analog_value_callback_configuration.
    def get_analog_value_callback_configuration
      check_validity

      send_request FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION, [], '', 22, 'L ? k L L'
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the distance.
    # 
    # Setting the length to 1 will turn the averaging off. With less averaging, there
    # is more noise on the data.
    # 
    # New data is gathered every ~10ms. With a moving average of length 1000 the
    # resulting averaging window has a length of approximately 10s. If you want to do
    # long term measurements the longest moving average will give the cleanest results.
    def set_moving_average_configuration(moving_average_length)
      check_validity

      send_request FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, [moving_average_length], 'S', 8, ''
    end

    # Returns the moving average configuration as set by BrickletDistanceIRV2#set_moving_average_configuration.
    def get_moving_average_configuration
      check_validity

      send_request FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, [], '', 10, 'S'
    end

    # Configures the distance LED to be either turned off, turned on, blink in
    # heartbeat mode or show the distance (brighter = object is nearer).
    def set_distance_led_config(config)
      check_validity

      send_request FUNCTION_SET_DISTANCE_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the LED configuration as set by BrickletDistanceIRV2#set_distance_led_config
    def get_distance_led_config
      check_validity

      send_request FUNCTION_GET_DISTANCE_LED_CONFIG, [], '', 9, 'C'
    end

    # Sets the sensor type.
    # 
    # The Bricklet comes configured with the correct sensor type
    # and the type is saved in flash (i.e. the Bricklet retains the information if
    # power is lost).
    # 
    # If you want to change the sensor you can set the type in Brick Viewer,
    # you will likely never need to call this function from your program.
    def set_sensor_type(sensor)
      check_validity

      send_request FUNCTION_SET_SENSOR_TYPE, [sensor], 'C', 8, ''
    end

    # Returns the sensor type as set by BrickletDistanceIRV2#set_sensor_type.
    def get_sensor_type
      check_validity

      send_request FUNCTION_GET_SENSOR_TYPE, [], '', 9, 'C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletDistanceIRV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletDistanceIRV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletDistanceIRV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletDistanceIRV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
