# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Determine position, velocity and altitude using GPS
  class BrickletGPSV2 < Device
    DEVICE_IDENTIFIER = 276 # :nodoc:
    DEVICE_DISPLAY_NAME = 'GPS Bricklet 2.0' # :nodoc:

    # This callback is triggered precisely once per second,
    # see `PPS <https://en.wikipedia.org/wiki/Pulse-per-second_signal>`__.
    # 
    # The precision of two subsequent pulses will be skewed because
    # of the latency in the USB/RS485/Ethernet connection. But in the
    # long run this will be very precise. For example a count of
    # 3600 pulses will take exactly 1 hour.
    CALLBACK_PULSE_PER_SECOND = 21

    # This callback is triggered periodically with the period that is set by
    # BrickletGPSV2#set_coordinates_callback_period. The parameters are the same
    # as for BrickletGPSV2#get_coordinates.
    # 
    # The CALLBACK_COORDINATES callback is only triggered if the coordinates changed
    # since the last triggering and if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    CALLBACK_COORDINATES = 22

    # This callback is triggered periodically with the period that is set by
    # BrickletGPSV2#set_status_callback_period. The parameters are the same
    # as for BrickletGPSV2#get_status.
    # 
    # The CALLBACK_STATUS callback is only triggered if the status changed since the
    # last triggering.
    CALLBACK_STATUS = 23

    # This callback is triggered periodically with the period that is set by
    # BrickletGPSV2#set_altitude_callback_period. The parameters are the same
    # as for BrickletGPSV2#get_altitude.
    # 
    # The CALLBACK_ALTITUDE callback is only triggered if the altitude changed since the
    # last triggering and if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    CALLBACK_ALTITUDE = 24

    # This callback is triggered periodically with the period that is set by
    # BrickletGPSV2#set_motion_callback_period. The parameters are the same
    # as for BrickletGPSV2#get_motion.
    # 
    # The CALLBACK_MOTION callback is only triggered if the motion changed since the
    # last triggering and if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    CALLBACK_MOTION = 25

    # This callback is triggered periodically with the period that is set by
    # BrickletGPSV2#set_date_time_callback_period. The parameters are the same
    # as for BrickletGPSV2#get_date_time.
    # 
    # The CALLBACK_DATE_TIME callback is only triggered if the date or time changed
    # since the last triggering.
    CALLBACK_DATE_TIME = 26

    FUNCTION_GET_COORDINATES = 1 # :nodoc:
    FUNCTION_GET_STATUS = 2 # :nodoc:
    FUNCTION_GET_ALTITUDE = 3 # :nodoc:
    FUNCTION_GET_MOTION = 4 # :nodoc:
    FUNCTION_GET_DATE_TIME = 5 # :nodoc:
    FUNCTION_RESTART = 6 # :nodoc:
    FUNCTION_GET_SATELLITE_SYSTEM_STATUS_LOW_LEVEL = 7 # :nodoc:
    FUNCTION_GET_SATELLITE_STATUS = 8 # :nodoc:
    FUNCTION_SET_FIX_LED_CONFIG = 9 # :nodoc:
    FUNCTION_GET_FIX_LED_CONFIG = 10 # :nodoc:
    FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = 11 # :nodoc:
    FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = 12 # :nodoc:
    FUNCTION_SET_STATUS_CALLBACK_PERIOD = 13 # :nodoc:
    FUNCTION_GET_STATUS_CALLBACK_PERIOD = 14 # :nodoc:
    FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = 15 # :nodoc:
    FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = 16 # :nodoc:
    FUNCTION_SET_MOTION_CALLBACK_PERIOD = 17 # :nodoc:
    FUNCTION_GET_MOTION_CALLBACK_PERIOD = 18 # :nodoc:
    FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD = 19 # :nodoc:
    FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD = 20 # :nodoc:
    FUNCTION_SET_SBAS_CONFIG = 27 # :nodoc:
    FUNCTION_GET_SBAS_CONFIG = 28 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    RESTART_TYPE_HOT_START = 0 # :nodoc:
    RESTART_TYPE_WARM_START = 1 # :nodoc:
    RESTART_TYPE_COLD_START = 2 # :nodoc:
    RESTART_TYPE_FACTORY_RESET = 3 # :nodoc:
    SATELLITE_SYSTEM_GPS = 0 # :nodoc:
    SATELLITE_SYSTEM_GLONASS = 1 # :nodoc:
    SATELLITE_SYSTEM_GALILEO = 2 # :nodoc:
    FIX_NO_FIX = 1 # :nodoc:
    FIX_2D_FIX = 2 # :nodoc:
    FIX_3D_FIX = 3 # :nodoc:
    FIX_LED_CONFIG_OFF = 0 # :nodoc:
    FIX_LED_CONFIG_ON = 1 # :nodoc:
    FIX_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    FIX_LED_CONFIG_SHOW_FIX = 3 # :nodoc:
    FIX_LED_CONFIG_SHOW_PPS = 4 # :nodoc:
    SBAS_ENABLED = 0 # :nodoc:
    SBAS_DISABLED = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_COORDINATES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_MOTION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_DATE_TIME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESTART] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SATELLITE_SYSTEM_STATUS_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SATELLITE_STATUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FIX_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_FIX_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COORDINATES_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_COORDINATES_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STATUS_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOTION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MOTION_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SBAS_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SBAS_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_PULSE_PER_SECOND] = [8, '']
      @callback_formats[CALLBACK_COORDINATES] = [18, 'L k L k']
      @callback_formats[CALLBACK_STATUS] = [10, '? C']
      @callback_formats[CALLBACK_ALTITUDE] = [16, 'l l']
      @callback_formats[CALLBACK_MOTION] = [16, 'L L']
      @callback_formats[CALLBACK_DATE_TIME] = [16, 'L L']

      @ipcon.add_device self
    end

    # Returns the GPS coordinates. Latitude and longitude are given in the
    # ``DD.dddddd°`` format, the value 57123468 means 57.123468°.
    # The parameter ``ns`` and ``ew`` are the cardinal directions for
    # latitude and longitude. Possible values for ``ns`` and ``ew`` are 'N', 'S', 'E'
    # and 'W' (north, south, east and west).
    # 
    # This data is only valid if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    def get_coordinates
      check_validity

      send_request FUNCTION_GET_COORDINATES, [], '', 18, 'L k L k'
    end

    # Returns if a fix is currently available as well as the, the number of
    # satellites that are in view.
    # 
    # There is also a :ref:`green LED <gps_v2_bricklet_fix_led>` on the Bricklet that
    # indicates the fix status.
    def get_status
      check_validity

      send_request FUNCTION_GET_STATUS, [], '', 10, '? C'
    end

    # Returns the current altitude and corresponding geoidal separation.
    # 
    # This data is only valid if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    def get_altitude
      check_validity

      send_request FUNCTION_GET_ALTITUDE, [], '', 16, 'l l'
    end

    # Returns the current course and speed. A course of 0° means the Bricklet is
    # traveling north bound and 90° means it is traveling east bound.
    # 
    # Please note that this only returns useful values if an actual movement
    # is present.
    # 
    # This data is only valid if there is currently a fix as indicated by
    # BrickletGPSV2#get_status.
    def get_motion
      check_validity

      send_request FUNCTION_GET_MOTION, [], '', 16, 'L L'
    end

    # Returns the current date and time. The date is
    # given in the format ``ddmmyy`` and the time is given
    # in the format ``hhmmss.sss``. For example, 140713 means
    # 14.07.13 as date and 195923568 means 19:59:23.568 as time.
    def get_date_time
      check_validity

      send_request FUNCTION_GET_DATE_TIME, [], '', 16, 'L L'
    end

    # Restarts the GPS Bricklet, the following restart types are available:
    # 
    #  "Value", "Description"
    # 
    #  "0", "Hot start (use all available data in the NV store)"
    #  "1", "Warm start (don't use ephemeris at restart)"
    #  "2", "Cold start (don't use time, position, almanacs and ephemeris at restart)"
    #  "3", "Factory reset (clear all system/user configurations at restart)"
    def restart(restart_type)
      check_validity

      send_request FUNCTION_RESTART, [restart_type], 'C', 8, ''
    end

    # Returns the
    # 
    # * satellite numbers list (up to 12 items)
    # * fix value,
    # * PDOP value,
    # * HDOP value and
    # * VDOP value
    # 
    # for a given satellite system. Currently GPS and GLONASS are supported, Galileo
    # is not yet supported.
    # 
    # The GPS and GLONASS satellites have unique numbers and the satellite list gives
    # the numbers of the satellites that are currently utilized. The number 0 is not
    # a valid satellite number and can be ignored in the list.
    def get_satellite_system_status_low_level(satellite_system)
      check_validity

      send_request FUNCTION_GET_SATELLITE_SYSTEM_STATUS_LOW_LEVEL, [satellite_system], 'C', 28, 'C C12 C S S S'
    end

    # Returns the current elevation, azimuth and SNR
    # for a given satellite and satellite system.
    # 
    # The satellite number here always goes from 1 to 32. For GLONASS it corresponds to
    # the satellites 65-96.
    # 
    # Galileo is not yet supported.
    def get_satellite_status(satellite_system, satellite_number)
      check_validity

      send_request FUNCTION_GET_SATELLITE_STATUS, [satellite_system, satellite_number], 'C C', 14, 's s s'
    end

    # Sets the fix LED configuration. By default the LED shows if
    # the Bricklet got a GPS fix yet. If a fix is established the LED turns on.
    # If there is no fix then the LED is turned off.
    # 
    # You can also turn the LED permanently on/off, show a heartbeat or let it blink
    # in sync with the PPS (pulse per second) output of the GPS module.
    # 
    # If the Bricklet is in bootloader mode, the LED is off.
    def set_fix_led_config(config)
      check_validity

      send_request FUNCTION_SET_FIX_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletGPSV2#set_fix_led_config
    def get_fix_led_config
      check_validity

      send_request FUNCTION_GET_FIX_LED_CONFIG, [], '', 9, 'C'
    end

    # Sets the period with which the CALLBACK_COORDINATES callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_COORDINATES callback is only triggered if the coordinates changed
    # since the last triggering.
    def set_coordinates_callback_period(period)
      check_validity

      send_request FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletGPSV2#set_coordinates_callback_period.
    def get_coordinates_callback_period
      check_validity

      send_request FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_STATUS callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_STATUS callback is only triggered if the status changed since the
    # last triggering.
    def set_status_callback_period(period)
      check_validity

      send_request FUNCTION_SET_STATUS_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletGPSV2#set_status_callback_period.
    def get_status_callback_period
      check_validity

      send_request FUNCTION_GET_STATUS_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_ALTITUDE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_ALTITUDE callback is only triggered if the altitude changed since the
    # last triggering.
    def set_altitude_callback_period(period)
      check_validity

      send_request FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletGPSV2#set_altitude_callback_period.
    def get_altitude_callback_period
      check_validity

      send_request FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_MOTION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_MOTION callback is only triggered if the motion changed since the
    # last triggering.
    def set_motion_callback_period(period)
      check_validity

      send_request FUNCTION_SET_MOTION_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletGPSV2#set_motion_callback_period.
    def get_motion_callback_period
      check_validity

      send_request FUNCTION_GET_MOTION_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # Sets the period with which the CALLBACK_DATE_TIME callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_DATE_TIME callback is only triggered if the date or time changed
    # since the last triggering.
    def set_date_time_callback_period(period)
      check_validity

      send_request FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletGPSV2#set_date_time_callback_period.
    def get_date_time_callback_period
      check_validity

      send_request FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD, [], '', 12, 'L'
    end

    # If `SBAS <https://en.wikipedia.org/wiki/GNSS_augmentation#Satellite-based_augmentation_system>`__ is enabled,
    # the position accuracy increases (if SBAS satellites are in view),
    # but the update rate is limited to 5Hz. With SBAS disabled the update rate is increased to 10Hz.
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def set_sbas_config(sbas_config)
      check_validity

      send_request FUNCTION_SET_SBAS_CONFIG, [sbas_config], 'C', 8, ''
    end

    # Returns the SBAS configuration as set by BrickletGPSV2#set_sbas_config
    # 
    # .. versionadded:: 2.0.2$nbsp;(Plugin)
    def get_sbas_config
      check_validity

      send_request FUNCTION_GET_SBAS_CONFIG, [], '', 9, 'C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletGPSV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletGPSV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletGPSV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletGPSV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Returns the
    # 
    # * satellite numbers list (up to 12 items)
    # * fix value,
    # * PDOP value,
    # * HDOP value and
    # * VDOP value
    # 
    # for a given satellite system. Currently GPS and GLONASS are supported, Galileo
    # is not yet supported.
    # 
    # The GPS and GLONASS satellites have unique numbers and the satellite list gives
    # the numbers of the satellites that are currently utilized. The number 0 is not
    # a valid satellite number and can be ignored in the list.
    def get_satellite_system_status(satellite_system)
      ret = get_satellite_system_status_low_level satellite_system

      [ret[1][0, ret[0]], ret[2], ret[3], ret[4], ret[5]]
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
