# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA
  class BrickletIndustrialAnalogOutV2 < Device
    DEVICE_IDENTIFIER = 2116 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Industrial Analog Out Bricklet 2.0' # :nodoc:

    FUNCTION_SET_ENABLED = 1 # :nodoc:
    FUNCTION_GET_ENABLED = 2 # :nodoc:
    FUNCTION_SET_VOLTAGE = 3 # :nodoc:
    FUNCTION_GET_VOLTAGE = 4 # :nodoc:
    FUNCTION_SET_CURRENT = 5 # :nodoc:
    FUNCTION_GET_CURRENT = 6 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 7 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 8 # :nodoc:
    FUNCTION_SET_OUT_LED_CONFIG = 9 # :nodoc:
    FUNCTION_GET_OUT_LED_CONFIG = 10 # :nodoc:
    FUNCTION_SET_OUT_LED_STATUS_CONFIG = 11 # :nodoc:
    FUNCTION_GET_OUT_LED_STATUS_CONFIG = 12 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    VOLTAGE_RANGE_0_TO_5V = 0 # :nodoc:
    VOLTAGE_RANGE_0_TO_10V = 1 # :nodoc:
    CURRENT_RANGE_4_TO_20MA = 0 # :nodoc:
    CURRENT_RANGE_0_TO_20MA = 1 # :nodoc:
    CURRENT_RANGE_0_TO_24MA = 2 # :nodoc:
    OUT_LED_CONFIG_OFF = 0 # :nodoc:
    OUT_LED_CONFIG_ON = 1 # :nodoc:
    OUT_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    OUT_LED_CONFIG_SHOW_OUT_STATUS = 3 # :nodoc:
    OUT_LED_STATUS_CONFIG_THRESHOLD = 0 # :nodoc:
    OUT_LED_STATUS_CONFIG_INTENSITY = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_ENABLED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_OUT_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_OUT_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_OUT_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_OUT_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


      @ipcon.add_device self
    end

    # Enables/disables the output of voltage and current.
    def set_enabled(enabled)
      check_validity

      send_request FUNCTION_SET_ENABLED, [enabled], '?', 8, ''
    end

    # Returns *true* if output of voltage and current is enabled, *false* otherwise.
    def get_enabled
      check_validity

      send_request FUNCTION_GET_ENABLED, [], '', 9, '?'
    end

    # Sets the output voltage.
    # 
    # The output voltage and output current are linked. Changing the output voltage
    # also changes the output current.
    def set_voltage(voltage)
      check_validity

      send_request FUNCTION_SET_VOLTAGE, [voltage], 'S', 8, ''
    end

    # Returns the voltage as set by BrickletIndustrialAnalogOutV2#set_voltage.
    def get_voltage
      check_validity

      send_request FUNCTION_GET_VOLTAGE, [], '', 10, 'S'
    end

    # Sets the output current.
    # 
    # The output current and output voltage are linked. Changing the output current
    # also changes the output voltage.
    def set_current(current)
      check_validity

      send_request FUNCTION_SET_CURRENT, [current], 'S', 8, ''
    end

    # Returns the current as set by BrickletIndustrialAnalogOutV2#set_current.
    def get_current
      check_validity

      send_request FUNCTION_GET_CURRENT, [], '', 10, 'S'
    end

    # Configures the voltage and current range.
    # 
    # Possible voltage ranges are:
    # 
    # * 0V to 5V
    # * 0V to 10V
    # 
    # Possible current ranges are:
    # 
    # * 4mA to 20mA
    # * 0mA to 20mA
    # * 0mA to 24mA
    # 
    # The resolution will always be 12 bit. This means, that the
    # precision is higher with a smaller range.
    def set_configuration(voltage_range, current_range)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [voltage_range, current_range], 'C C', 8, ''
    end

    # Returns the configuration as set by BrickletIndustrialAnalogOutV2#set_configuration.
    def get_configuration
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [], '', 10, 'C C'
    end

    # You can turn the Out LED off, on or show a
    # heartbeat. You can also set the LED to "Out Status". In this mode the
    # LED can either be turned on with a pre-defined threshold or the intensity
    # of the LED can change with the output value (voltage or current).
    # 
    # You can configure the channel status behavior with BrickletIndustrialAnalogOutV2#set_out_led_status_config.
    def set_out_led_config(config)
      check_validity

      send_request FUNCTION_SET_OUT_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the Out LED configuration as set by BrickletIndustrialAnalogOutV2#set_out_led_config
    def get_out_led_config
      check_validity

      send_request FUNCTION_GET_OUT_LED_CONFIG, [], '', 9, 'C'
    end

    # Sets the Out LED status config. This config is used if the Out LED is
    # configured as "Out Status", see BrickletIndustrialAnalogOutV2#set_out_led_config.
    # 
    # For each channel you can choose between threshold and intensity mode.
    # 
    # In threshold mode you can define a positive or a negative threshold.
    # For a positive threshold set the "min" parameter to the threshold value in mV or
    # µA above which the LED should turn on and set the "max" parameter to 0. Example:
    # If you set a positive threshold of 5V, the LED will turn on as soon as the
    # output value exceeds 5V and turn off again if it goes below 5V.
    # For a negative threshold set the "max" parameter to the threshold value in mV or
    # µA below which the LED should turn on and set the "min" parameter to 0. Example:
    # If you set a negative threshold of 5V, the LED will turn on as soon as the
    # output value goes below 5V and the LED will turn off when the output value
    # exceeds 5V.
    # 
    # In intensity mode you can define a range mV or µA that is used to scale the brightness
    # of the LED. Example with min=2V, max=8V: The LED is off at 2V and below, on at
    # 8V and above and the brightness is linearly scaled between the values 2V and 8V.
    # If the min value is greater than the max value, the LED brightness is scaled the
    # other way around.
    def set_out_led_status_config(min, max, config)
      check_validity

      send_request FUNCTION_SET_OUT_LED_STATUS_CONFIG, [min, max, config], 'S S C', 8, ''
    end

    # Returns the Out LED status configuration as set by BrickletIndustrialAnalogOutV2#set_out_led_status_config.
    def get_out_led_status_config
      check_validity

      send_request FUNCTION_GET_OUT_LED_STATUS_CONFIG, [], '', 13, 'S S C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletIndustrialAnalogOutV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletIndustrialAnalogOutV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIndustrialAnalogOutV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletIndustrialAnalogOutV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

  end
end
