# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures two DC currents between 0mA and 20mA (IEC 60381-1)
  class BrickletIndustrialDual020mAV2 < Device
    DEVICE_IDENTIFIER = 2120 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Industrial Dual 0-20mA Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletIndustrialDual020mAV2#set_current_callback_configuration.
    # 
    # The parameter is the same as BrickletIndustrialDual020mAV2#get_current.
    CALLBACK_CURRENT = 4

    FUNCTION_GET_CURRENT = 1 # :nodoc:
    FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_SET_SAMPLE_RATE = 5 # :nodoc:
    FUNCTION_GET_SAMPLE_RATE = 6 # :nodoc:
    FUNCTION_SET_GAIN = 7 # :nodoc:
    FUNCTION_GET_GAIN = 8 # :nodoc:
    FUNCTION_SET_CHANNEL_LED_CONFIG = 9 # :nodoc:
    FUNCTION_GET_CHANNEL_LED_CONFIG = 10 # :nodoc:
    FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG = 11 # :nodoc:
    FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG = 12 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    SAMPLE_RATE_240_SPS = 0 # :nodoc:
    SAMPLE_RATE_60_SPS = 1 # :nodoc:
    SAMPLE_RATE_15_SPS = 2 # :nodoc:
    SAMPLE_RATE_4_SPS = 3 # :nodoc:
    GAIN_1X = 0 # :nodoc:
    GAIN_2X = 1 # :nodoc:
    GAIN_4X = 2 # :nodoc:
    GAIN_8X = 3 # :nodoc:
    CHANNEL_LED_CONFIG_OFF = 0 # :nodoc:
    CHANNEL_LED_CONFIG_ON = 1 # :nodoc:
    CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3 # :nodoc:
    CHANNEL_LED_STATUS_CONFIG_THRESHOLD = 0 # :nodoc:
    CHANNEL_LED_STATUS_CONFIG_INTENSITY = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_CURRENT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SAMPLE_RATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SAMPLE_RATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GAIN] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_GAIN] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_CURRENT] = [13, 'C l']

      @ipcon.add_device self
    end

    # Returns the current of the specified channel.
    # 
    # It is possible to detect if an IEC 60381-1 compatible sensor is connected
    # and if it works probably.
    # 
    # If the returned current is below 4mA, there is likely no sensor connected
    # or the connected sensor is defective. If the returned current is over 20mA,
    # there might be a short circuit or the sensor is defective.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_CURRENT callback. You can set the callback configuration
    # with BrickletIndustrialDual020mAV2#set_current_callback_configuration.
    def get_current(channel)
      check_validity

      send_request FUNCTION_GET_CURRENT, [channel], 'C', 12, 'l'
    end

    # The period is the period with which the CALLBACK_CURRENT callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_CURRENT callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_current_callback_configuration(channel, period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION, [channel, period, value_has_to_change, option, min, max], 'C L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletIndustrialDual020mAV2#set_current_callback_configuration.
    def get_current_callback_configuration(channel)
      check_validity

      send_request FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION, [channel], 'C', 22, 'L ? k l l'
    end

    # Sets the sample rate to either 240, 60, 15 or 4 samples per second.
    # The resolution for the rates is 12, 14, 16 and 18 bit respectively.
    # 
    #  "Value", "Description"
    # 
    #  "0",    "240 samples per second, 12 bit resolution"
    #  "1",    "60 samples per second, 14 bit resolution"
    #  "2",    "15 samples per second, 16 bit resolution"
    #  "3",    "4 samples per second, 18 bit resolution"
    def set_sample_rate(rate)
      check_validity

      send_request FUNCTION_SET_SAMPLE_RATE, [rate], 'C', 8, ''
    end

    # Returns the gain as set by BrickletIndustrialDual020mAV2#set_sample_rate.
    def get_sample_rate
      check_validity

      send_request FUNCTION_GET_SAMPLE_RATE, [], '', 9, 'C'
    end

    # Sets a gain between 1x and 8x. If you want to measure a very small current,
    # you can increase the gain to get some more resolution.
    # 
    # Example: If you measure 0.5mA with a gain of 8x the return value will be
    # 4mA.
    def set_gain(gain)
      check_validity

      send_request FUNCTION_SET_GAIN, [gain], 'C', 8, ''
    end

    # Returns the gain as set by BrickletIndustrialDual020mAV2#set_gain.
    def get_gain
      check_validity

      send_request FUNCTION_GET_GAIN, [], '', 9, 'C'
    end

    # Each channel has a corresponding LED. You can turn the LED off, on or show a
    # heartbeat. You can also set the LED to "Channel Status". In this mode the
    # LED can either be turned on with a pre-defined threshold or the intensity
    # of the LED can change with the measured value.
    # 
    # You can configure the channel status behavior with BrickletIndustrialDual020mAV2#set_channel_led_status_config.
    def set_channel_led_config(channel, config)
      check_validity

      send_request FUNCTION_SET_CHANNEL_LED_CONFIG, [channel, config], 'C C', 8, ''
    end

    # Returns the channel LED configuration as set by BrickletIndustrialDual020mAV2#set_channel_led_config
    def get_channel_led_config(channel)
      check_validity

      send_request FUNCTION_GET_CHANNEL_LED_CONFIG, [channel], 'C', 9, 'C'
    end

    # Sets the channel LED status config. This config is used if the channel LED is
    # configured as "Channel Status", see BrickletIndustrialDual020mAV2#set_channel_led_config.
    # 
    # For each channel you can choose between threshold and intensity mode.
    # 
    # In threshold mode you can define a positive or a negative threshold.
    # For a positive threshold set the "min" parameter to the threshold value in nA
    # above which the LED should turn on and set the "max" parameter to 0. Example:
    # If you set a positive threshold of 10mA, the LED will turn on as soon as the
    # current exceeds 10mA and turn off again if it goes below 10mA.
    # For a negative threshold set the "max" parameter to the threshold value in nA
    # below which the LED should turn on and set the "min" parameter to 0. Example:
    # If you set a negative threshold of 10mA, the LED will turn on as soon as the
    # current goes below 10mA and the LED will turn off when the current exceeds 10mA.
    # 
    # In intensity mode you can define a range in nA that is used to scale the brightness
    # of the LED. Example with min=4mA and max=20mA: The LED is off at 4mA and below,
    # on at 20mA and above and the brightness is linearly scaled between the values
    # 4mA and 20mA. If the min value is greater than the max value, the LED brightness
    # is scaled the other way around.
    def set_channel_led_status_config(channel, min, max, config)
      check_validity

      send_request FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG, [channel, min, max, config], 'C l l C', 8, ''
    end

    # Returns the channel LED status configuration as set by
    # BrickletIndustrialDual020mAV2#set_channel_led_status_config.
    def get_channel_led_status_config(channel)
      check_validity

      send_request FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG, [channel], 'C', 17, 'l l C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletIndustrialDual020mAV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletIndustrialDual020mAV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIndustrialDual020mAV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletIndustrialDual020mAV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
