# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Measures two DC voltages between -35V and +35V with 24bit resolution each
  class BrickletIndustrialDualAnalogInV2 < Device
    DEVICE_IDENTIFIER = 2121 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Industrial Dual Analog In Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletIndustrialDualAnalogInV2#set_voltage_callback_configuration.
    # 
    # The parameter is the same as BrickletIndustrialDualAnalogInV2#get_voltage.
    CALLBACK_VOLTAGE = 4

    # This callback is triggered periodically according to the configuration set by
    # BrickletIndustrialDualAnalogInV2#set_all_voltages_callback_configuration.
    # 
    # The parameters are the same as BrickletIndustrialDualAnalogInV2#get_all_voltages.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    CALLBACK_ALL_VOLTAGES = 17

    FUNCTION_GET_VOLTAGE = 1 # :nodoc:
    FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION = 2 # :nodoc:
    FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION = 3 # :nodoc:
    FUNCTION_SET_SAMPLE_RATE = 5 # :nodoc:
    FUNCTION_GET_SAMPLE_RATE = 6 # :nodoc:
    FUNCTION_SET_CALIBRATION = 7 # :nodoc:
    FUNCTION_GET_CALIBRATION = 8 # :nodoc:
    FUNCTION_GET_ADC_VALUES = 9 # :nodoc:
    FUNCTION_SET_CHANNEL_LED_CONFIG = 10 # :nodoc:
    FUNCTION_GET_CHANNEL_LED_CONFIG = 11 # :nodoc:
    FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG = 12 # :nodoc:
    FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG = 13 # :nodoc:
    FUNCTION_GET_ALL_VOLTAGES = 14 # :nodoc:
    FUNCTION_SET_ALL_VOLTAGES_CALLBACK_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_ALL_VOLTAGES_CALLBACK_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    SAMPLE_RATE_976_SPS = 0 # :nodoc:
    SAMPLE_RATE_488_SPS = 1 # :nodoc:
    SAMPLE_RATE_244_SPS = 2 # :nodoc:
    SAMPLE_RATE_122_SPS = 3 # :nodoc:
    SAMPLE_RATE_61_SPS = 4 # :nodoc:
    SAMPLE_RATE_4_SPS = 5 # :nodoc:
    SAMPLE_RATE_2_SPS = 6 # :nodoc:
    SAMPLE_RATE_1_SPS = 7 # :nodoc:
    CHANNEL_LED_CONFIG_OFF = 0 # :nodoc:
    CHANNEL_LED_CONFIG_ON = 1 # :nodoc:
    CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3 # :nodoc:
    CHANNEL_LED_STATUS_CONFIG_THRESHOLD = 0 # :nodoc:
    CHANNEL_LED_STATUS_CONFIG_INTENSITY = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SAMPLE_RATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SAMPLE_RATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CALIBRATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ADC_VALUES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_VOLTAGES] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_VOLTAGES_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_VOLTAGES_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_VOLTAGE] = [13, 'C l']
      @callback_formats[CALLBACK_ALL_VOLTAGES] = [16, 'l2']

      @ipcon.add_device self
    end

    # Returns the voltage for the given channel.
    # 
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_VOLTAGE callback. You can set the callback configuration
    # with BrickletIndustrialDualAnalogInV2#set_voltage_callback_configuration.
    def get_voltage(channel)
      check_validity

      send_request FUNCTION_GET_VOLTAGE, [channel], 'C', 12, 'l'
    end

    # The period is the period with which the CALLBACK_VOLTAGE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change
    # within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # It is furthermore possible to constrain the callback with thresholds.
    # 
    # The `option`-parameter together with min/max sets a threshold for the CALLBACK_VOLTAGE callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Threshold is turned off"
    #  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    #  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    #  "'<'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    #  "'>'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    # 
    # If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    def set_voltage_callback_configuration(channel, period, value_has_to_change, option, min, max)
      check_validity

      send_request FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION, [channel, period, value_has_to_change, option, min, max], 'C L ? k l l', 8, ''
    end

    # Returns the callback configuration as set by BrickletIndustrialDualAnalogInV2#set_voltage_callback_configuration.
    def get_voltage_callback_configuration(channel)
      check_validity

      send_request FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION, [channel], 'C', 22, 'L ? k l l'
    end

    # Sets the sample rate. The sample rate can be between 1 sample per second
    # and 976 samples per second. Decreasing the sample rate will also decrease the
    # noise on the data.
    def set_sample_rate(rate)
      check_validity

      send_request FUNCTION_SET_SAMPLE_RATE, [rate], 'C', 8, ''
    end

    # Returns the sample rate as set by BrickletIndustrialDualAnalogInV2#set_sample_rate.
    def get_sample_rate
      check_validity

      send_request FUNCTION_GET_SAMPLE_RATE, [], '', 9, 'C'
    end

    # Sets offset and gain of MCP3911 internal calibration registers.
    # 
    # See MCP3911 datasheet 7.7 and 7.8. The Industrial Dual Analog In Bricklet 2.0
    # is already factory calibrated by Tinkerforge. It should not be necessary
    # for you to use this function
    def set_calibration(offset, gain)
      check_validity

      send_request FUNCTION_SET_CALIBRATION, [offset, gain], 'l2 l2', 8, ''
    end

    # Returns the calibration as set by BrickletIndustrialDualAnalogInV2#set_calibration.
    def get_calibration
      check_validity

      send_request FUNCTION_GET_CALIBRATION, [], '', 24, 'l2 l2'
    end

    # Returns the ADC values as given by the MCP3911 IC. This function
    # is needed for proper calibration, see BrickletIndustrialDualAnalogInV2#set_calibration.
    def get_adc_values
      check_validity

      send_request FUNCTION_GET_ADC_VALUES, [], '', 16, 'l2'
    end

    # Each channel has a corresponding LED. You can turn the LED off, on or show a
    # heartbeat. You can also set the LED to "Channel Status". In this mode the
    # LED can either be turned on with a pre-defined threshold or the intensity
    # of the LED can change with the measured value.
    # 
    # You can configure the channel status behavior with BrickletIndustrialDualAnalogInV2#set_channel_led_status_config.
    # 
    # By default all channel LEDs are configured as "Channel Status".
    def set_channel_led_config(channel, config)
      check_validity

      send_request FUNCTION_SET_CHANNEL_LED_CONFIG, [channel, config], 'C C', 8, ''
    end

    # Returns the channel LED configuration as set by BrickletIndustrialDualAnalogInV2#set_channel_led_config
    def get_channel_led_config(channel)
      check_validity

      send_request FUNCTION_GET_CHANNEL_LED_CONFIG, [channel], 'C', 9, 'C'
    end

    # Sets the channel LED status config. This config is used if the channel LED is
    # configured as "Channel Status", see BrickletIndustrialDualAnalogInV2#set_channel_led_config.
    # 
    # For each channel you can choose between threshold and intensity mode.
    # 
    # In threshold mode you can define a positive or a negative threshold.
    # For a positive threshold set the "min" parameter to the threshold value in mV
    # above which the LED should turn on and set the "max" parameter to 0. Example:
    # If you set a positive threshold of 10V, the LED will turn on as soon as the
    # voltage exceeds 10V and turn off again if it goes below 10V.
    # For a negative threshold set the "max" parameter to the threshold value in mV
    # below which the LED should turn on and set the "min" parameter to 0. Example:
    # If you set a negative threshold of 10V, the LED will turn on as soon as the
    # voltage goes below 10V and the LED will turn off when the voltage exceeds 10V.
    # 
    # In intensity mode you can define a range in mV that is used to scale the brightness
    # of the LED. Example with min=4V, max=20V: The LED is off at 4V, on at 20V
    # and the brightness is linearly scaled between the values 4V and 20V. If the
    # min value is greater than the max value, the LED brightness is scaled the other
    # way around.
    def set_channel_led_status_config(channel, min, max, config)
      check_validity

      send_request FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG, [channel, min, max, config], 'C l l C', 8, ''
    end

    # Returns the channel LED status configuration as set by
    # BrickletIndustrialDualAnalogInV2#set_channel_led_status_config.
    def get_channel_led_status_config(channel)
      check_validity

      send_request FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG, [channel], 'C', 17, 'l l C'
    end

    # Returns the voltages for all channels.
    # 
    # If you want to get the value periodically, it is recommended to use the
    # CALLBACK_ALL_VOLTAGES callback. You can set the callback configuration
    # with BrickletIndustrialDualAnalogInV2#set_all_voltages_callback_configuration.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def get_all_voltages
      check_validity

      send_request FUNCTION_GET_ALL_VOLTAGES, [], '', 16, 'l2'
    end

    # The period is the period with which the CALLBACK_ALL_VOLTAGES
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after at least one of the values has changed. If the values didn't
    # change within the period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def set_all_voltages_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ALL_VOLTAGES_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletIndustrialDualAnalogInV2#set_all_voltages_callback_configuration.
    # 
    # .. versionadded:: 2.0.6$nbsp;(Plugin)
    def get_all_voltages_callback_configuration
      check_validity

      send_request FUNCTION_GET_ALL_VOLTAGES_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletIndustrialDualAnalogInV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletIndustrialDualAnalogInV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIndustrialDualAnalogInV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletIndustrialDualAnalogInV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
