# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # 16-channel digital input/output
  class BrickletIO16 < Device
    DEVICE_IDENTIFIER = 28 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IO-16 Bricklet' # :nodoc:

    # This callback is triggered whenever a change of the voltage level is detected
    # on pins where the interrupt was activated with BrickletIO16#set_port_interrupt.
    # 
    # The values are the port, a bitmask that specifies which interrupts occurred
    # and the current value bitmask of the port.
    # 
    # For example:
    # 
    # * ('a', 1, 1) or ('a', 0b00000001, 0b00000001) means that on port A an
    #   interrupt on pin 0 occurred and currently pin 0 is high and pins 1-7 are low.
    # * ('b', 129, 254) or ('b', 0b10000001, 0b11111110) means that on port B
    #   interrupts on pins 0 and 7 occurred and currently pin 0 is low and pins 1-7
    #   are high.
    CALLBACK_INTERRUPT = 9

    # This callback is triggered whenever a monoflop timer reaches 0. The
    # parameters contain the port, the involved pins and the current value of
    # the pins (the value after the monoflop).
    CALLBACK_MONOFLOP_DONE = 12

    FUNCTION_SET_PORT = 1 # :nodoc:
    FUNCTION_GET_PORT = 2 # :nodoc:
    FUNCTION_SET_PORT_CONFIGURATION = 3 # :nodoc:
    FUNCTION_GET_PORT_CONFIGURATION = 4 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 5 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 6 # :nodoc:
    FUNCTION_SET_PORT_INTERRUPT = 7 # :nodoc:
    FUNCTION_GET_PORT_INTERRUPT = 8 # :nodoc:
    FUNCTION_SET_PORT_MONOFLOP = 10 # :nodoc:
    FUNCTION_GET_PORT_MONOFLOP = 11 # :nodoc:
    FUNCTION_SET_SELECTED_VALUES = 13 # :nodoc:
    FUNCTION_GET_EDGE_COUNT = 14 # :nodoc:
    FUNCTION_SET_EDGE_COUNT_CONFIG = 15 # :nodoc:
    FUNCTION_GET_EDGE_COUNT_CONFIG = 16 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    DIRECTION_IN = 'i' # :nodoc:
    DIRECTION_OUT = 'o' # :nodoc:
    EDGE_TYPE_RISING = 0 # :nodoc:
    EDGE_TYPE_FALLING = 1 # :nodoc:
    EDGE_TYPE_BOTH = 2 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_SET_PORT] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PORT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PORT_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PORT_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PORT_INTERRUPT] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_PORT_INTERRUPT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PORT_MONOFLOP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PORT_MONOFLOP] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SELECTED_VALUES] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_EDGE_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_EDGE_COUNT_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_EDGE_COUNT_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_INTERRUPT] = [11, 'k C C']
      @callback_formats[CALLBACK_MONOFLOP_DONE] = [11, 'k C C']

      @ipcon.add_device self
    end

    # Sets the output value (high or low) for a port ("a" or "b") with a bitmask
    # (8bit). A 1 in the bitmask means high and a 0 in the bitmask means low.
    # 
    # For example: The value 15 or 0b00001111 will turn the pins 0-3 high and the
    # pins 4-7 low for the specified port.
    # 
    # All running monoflop timers of the given port will be aborted if this function
    # is called.
    # 
    # .. note::
    #  This function does nothing for pins that are configured as input.
    #  Pull-up resistors can be switched on with BrickletIO16#set_port_configuration.
    def set_port(port, value_mask)
      check_validity

      send_request FUNCTION_SET_PORT, [port, value_mask], 'k C', 8, ''
    end

    # Returns a bitmask of the values that are currently measured on the
    # specified port. This function works if the pin is configured to input
    # as well as if it is configured to output.
    def get_port(port)
      check_validity

      send_request FUNCTION_GET_PORT, [port], 'k', 9, 'C'
    end

    # Configures the value and direction of a specified port. Possible directions
    # are 'i' and 'o' for input and output.
    # 
    # If the direction is configured as output, the value is either high or low
    # (set as *true* or *false*).
    # 
    # If the direction is configured as input, the value is either pull-up or
    # default (set as *true* or *false*).
    # 
    # For example:
    # 
    # * ('a', 255, 'i', true) or ('a', 0b11111111, 'i', true) will set all pins of port A as input pull-up.
    # * ('a', 128, 'i', false) or ('a', 0b10000000, 'i', false) will set pin 7 of port A as input default (floating if nothing is connected).
    # * ('b', 3, 'o', false) or ('b', 0b00000011, 'o', false) will set pins 0 and 1 of port B as output low.
    # * ('b', 4, 'o', true) or ('b', 0b00000100, 'o', true) will set pin 2 of port B as output high.
    # 
    # Running monoflop timers for the selected pins will be aborted if this
    # function is called.
    def set_port_configuration(port, selection_mask, direction, value)
      check_validity

      send_request FUNCTION_SET_PORT_CONFIGURATION, [port, selection_mask, direction, value], 'k C k ?', 8, ''
    end

    # Returns a direction bitmask and a value bitmask for the specified port. A 1 in
    # the direction bitmask means input and a 0 in the bitmask means output.
    # 
    # For example: A return value of (15, 51) or (0b00001111, 0b00110011) for
    # direction and value means that:
    # 
    # * pins 0 and 1 are configured as input pull-up,
    # * pins 2 and 3 are configured as input default,
    # * pins 4 and 5 are configured as output high
    # * and pins 6 and 7 are configured as output low.
    def get_port_configuration(port)
      check_validity

      send_request FUNCTION_GET_PORT_CONFIGURATION, [port], 'k', 10, 'C C'
    end

    # Sets the debounce period of the CALLBACK_INTERRUPT callback.
    # 
    # For example: If you set this value to 100, you will get the interrupt
    # maximal every 100ms. This is necessary if something that bounces is
    # connected to the IO-16 Bricklet, such as a button.
    def set_debounce_period(debounce)
      check_validity

      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 8, ''
    end

    # Returns the debounce period as set by BrickletIO16#set_debounce_period.
    def get_debounce_period
      check_validity

      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 12, 'L'
    end

    # Sets the pins on which an interrupt is activated with a bitmask.
    # Interrupts are triggered on changes of the voltage level of the pin,
    # i.e. changes from high to low and low to high.
    # 
    # For example: ('a', 129) or ('a', 0b10000001) will enable the interrupt for
    # pins 0 and 7 of port a.
    # 
    # The interrupt is delivered with the CALLBACK_INTERRUPT callback.
    def set_port_interrupt(port, interrupt_mask)
      check_validity

      send_request FUNCTION_SET_PORT_INTERRUPT, [port, interrupt_mask], 'k C', 8, ''
    end

    # Returns the interrupt bitmask for the specified port as set by
    # BrickletIO16#set_port_interrupt.
    def get_port_interrupt(port)
      check_validity

      send_request FUNCTION_GET_PORT_INTERRUPT, [port], 'k', 9, 'C'
    end

    # Configures a monoflop of the pins specified by the second parameter as 8 bit
    # long bitmask. The specified pins must be configured for output. Non-output
    # pins will be ignored.
    # 
    # The third parameter is a bitmask with the desired value of the specified
    # output pins. A 1 in the bitmask means high and a 0 in the bitmask means low.
    # 
    # The forth parameter indicates the time that the pins should hold
    # the value.
    # 
    # If this function is called with the parameters ('a', 9, 1, 1500) or
    # ('a', 0b00001001, 0b00000001, 1500): Pin 0 will get high and pin 3 will get
    # low on port 'a'. In 1.5s pin 0 will get low and pin 3 will get high again.
    # 
    # A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
    # have a RS485 bus and an IO-16 Bricklet connected to one of the slave
    # stacks. You can now call this function every second, with a time parameter
    # of two seconds and pin 0 set to high. Pin 0 will be high all the time. If now
    # the RS485 connection is lost, then pin 0 will get low in at most two seconds.
    def set_port_monoflop(port, selection_mask, value_mask, time)
      check_validity

      send_request FUNCTION_SET_PORT_MONOFLOP, [port, selection_mask, value_mask, time], 'k C C L', 8, ''
    end

    # Returns (for the given pin) the current value and the time as set by
    # BrickletIO16#set_port_monoflop as well as the remaining time until the value flips.
    # 
    # If the timer is not running currently, the remaining time will be returned
    # as 0.
    def get_port_monoflop(port, pin)
      check_validity

      send_request FUNCTION_GET_PORT_MONOFLOP, [port, pin], 'k C', 17, 'C L L'
    end

    # Sets the output value (high or low) for a port ("a" or "b" with a bitmask,
    # according to the selection mask. The bitmask is 8 bit long and a 1 in the
    # bitmask means high and a 0 in the bitmask means low.
    # 
    # For example: The parameters ('a', 192, 128) or ('a', 0b11000000, 0b10000000)
    # will turn pin 7 high and pin 6 low on port A, pins 0-6 will remain untouched.
    # 
    # Running monoflop timers for the selected pins will be aborted if this
    # function is called.
    # 
    # .. note::
    #  This function does nothing for pins that are configured as input.
    #  Pull-up resistors can be switched on with BrickletIO16#set_port_configuration.
    def set_selected_values(port, selection_mask, value_mask)
      check_validity

      send_request FUNCTION_SET_SELECTED_VALUES, [port, selection_mask, value_mask], 'k C C', 8, ''
    end

    # Returns the current value of the edge counter for the selected pin on port A.
    # You can configure the edges that are counted with BrickletIO16#set_edge_count_config.
    # 
    # If you set the reset counter to *true*, the count is set back to 0
    # directly after it is read.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_edge_count(pin, reset_counter)
      check_validity

      send_request FUNCTION_GET_EDGE_COUNT, [pin, reset_counter], 'C ?', 12, 'L'
    end

    # Configures the edge counter for the selected pin of port A. Pins 0 and 1
    # are available for edge counting.
    # 
    # The edge type parameter configures if rising edges, falling edges or
    # both are counted if the pin is configured for input. Possible edge types are:
    # 
    # * 0 = rising
    # * 1 = falling
    # * 2 = both
    # 
    # Configuring an edge counter resets its value to 0.
    # 
    # If you don't know what any of this means, just leave it at default. The
    # default configuration is very likely OK for you.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def set_edge_count_config(pin, edge_type, debounce)
      check_validity

      send_request FUNCTION_SET_EDGE_COUNT_CONFIG, [pin, edge_type, debounce], 'C C C', 8, ''
    end

    # Returns the edge type and debounce time for the selected pin of port A as set by
    # BrickletIO16#set_edge_count_config.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_edge_count_config(pin)
      check_validity

      send_request FUNCTION_GET_EDGE_COUNT_CONFIG, [pin], 'C', 10, 'C C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
