# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # 4-channel digital input/output
  class BrickletIO4V2 < Device
    DEVICE_IDENTIFIER = 2111 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IO-4 Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically according to the configuration set by
    # BrickletIO4V2#set_input_value_callback_configuration.
    # 
    # The parameters are the channel, a value-changed indicator and the actual value
    # for the channel. The `changed` parameter is true if the value has changed since
    # the last callback.
    CALLBACK_INPUT_VALUE = 17

    # This callback is triggered periodically according to the configuration set by
    # BrickletIO4V2#set_all_input_value_callback_configuration.
    # 
    # The parameters are the same as BrickletIO4V2#get_value. Additional the
    # `changed` parameter is true if the value has changed since
    # the last callback.
    CALLBACK_ALL_INPUT_VALUE = 18

    # This callback is triggered whenever a monoflop timer reaches 0. The
    # parameters contain the channel and the current value of the channel
    # (the value after the monoflop).
    CALLBACK_MONOFLOP_DONE = 19

    FUNCTION_SET_VALUE = 1 # :nodoc:
    FUNCTION_GET_VALUE = 2 # :nodoc:
    FUNCTION_SET_SELECTED_VALUE = 3 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 4 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 5 # :nodoc:
    FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = 8 # :nodoc:
    FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = 9 # :nodoc:
    FUNCTION_SET_MONOFLOP = 10 # :nodoc:
    FUNCTION_GET_MONOFLOP = 11 # :nodoc:
    FUNCTION_GET_EDGE_COUNT = 12 # :nodoc:
    FUNCTION_SET_EDGE_COUNT_CONFIGURATION = 13 # :nodoc:
    FUNCTION_GET_EDGE_COUNT_CONFIGURATION = 14 # :nodoc:
    FUNCTION_SET_PWM_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_PWM_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    DIRECTION_IN = 'i' # :nodoc:
    DIRECTION_OUT = 'o' # :nodoc:
    EDGE_TYPE_RISING = 0 # :nodoc:
    EDGE_TYPE_FALLING = 1 # :nodoc:
    EDGE_TYPE_BOTH = 2 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_VALUE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SELECTED_VALUE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MONOFLOP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MONOFLOP] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_EDGE_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_EDGE_COUNT_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_EDGE_COUNT_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_PWM_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_PWM_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_INPUT_VALUE] = [11, 'C ? ?']
      @callback_formats[CALLBACK_ALL_INPUT_VALUE] = [10, '?4 ?4']
      @callback_formats[CALLBACK_MONOFLOP_DONE] = [10, 'C ?']

      @ipcon.add_device self
    end

    # Sets the output value of all four channels. A value of *true* or *false* outputs
    # logic 1 or logic 0 respectively on the corresponding channel.
    # 
    # Use BrickletIO4V2#set_selected_value to change only one output channel state.
    # 
    # For example: (True, True, False, False) will turn the channels 0-1 high and the
    # channels 2-3 low.
    # 
    # All running monoflop timers and PWMs will be aborted if this function is called.
    # 
    # .. note::
    #  This function does nothing for channels that are configured as input. Pull-up
    #  resistors can be switched on with BrickletIO4V2#set_configuration.
    def set_value(value)
      check_validity

      send_request FUNCTION_SET_VALUE, [value], '?4', 8, ''
    end

    # Returns the logic levels that are currently measured on the channels.
    # This function works if the channel is configured as input as well as if it is
    # configured as output.
    def get_value
      check_validity

      send_request FUNCTION_GET_VALUE, [], '', 9, '?4'
    end

    # Sets the output value of a specific channel without affecting the other channels.
    # 
    # A running monoflop timer or PWM for the specific channel will be aborted if this
    # function is called.
    # 
    # .. note::
    #  This function does nothing for channels that are configured as input. Pull-up
    #  resistors can be switched on with BrickletIO4V2#set_configuration.
    def set_selected_value(channel, value)
      check_validity

      send_request FUNCTION_SET_SELECTED_VALUE, [channel, value], 'C ?', 8, ''
    end

    # Configures the value and direction of a specific channel. Possible directions
    # are 'i' and 'o' for input and output.
    # 
    # If the direction is configured as output, the value is either high or low
    # (set as *true* or *false*).
    # 
    # If the direction is configured as input, the value is either pull-up or
    # default (set as *true* or *false*).
    # 
    # For example:
    # 
    # * (0, 'i', true) will set channel 0 as input pull-up.
    # * (1, 'i', false) will set channel 1 as input default (floating if nothing is connected).
    # * (2, 'o', true) will set channel 2 as output high.
    # * (3, 'o', false) will set channel 3 as output low.
    # 
    # A running monoflop timer or PWM for the specific channel will be aborted if this
    # function is called.
    def set_configuration(channel, direction, value)
      check_validity

      send_request FUNCTION_SET_CONFIGURATION, [channel, direction, value], 'C k ?', 8, ''
    end

    # Returns the channel configuration as set by BrickletIO4V2#set_configuration.
    def get_configuration(channel)
      check_validity

      send_request FUNCTION_GET_CONFIGURATION, [channel], 'C', 10, 'k ?'
    end

    # This callback can be configured per channel.
    # 
    # The period is the period with which the CALLBACK_INPUT_VALUE
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_input_value_callback_configuration(channel, period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION, [channel, period, value_has_to_change], 'C L ?', 8, ''
    end

    # Returns the callback configuration for the given channel as set by
    # BrickletIO4V2#set_input_value_callback_configuration.
    def get_input_value_callback_configuration(channel)
      check_validity

      send_request FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION, [channel], 'C', 13, 'L ?'
    end

    # The period is the period with which the CALLBACK_ALL_INPUT_VALUE
    # callback is triggered periodically. A value of 0 turns the callback off.
    # 
    # If the `value has to change`-parameter is set to true, the callback is only
    # triggered after the value has changed. If the value didn't change within the
    # period, the callback is triggered immediately on change.
    # 
    # If it is set to false, the callback is continuously triggered with the period,
    # independent of the value.
    def set_all_input_value_callback_configuration(period, value_has_to_change)
      check_validity

      send_request FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, [period, value_has_to_change], 'L ?', 8, ''
    end

    # Returns the callback configuration as set by
    # BrickletIO4V2#set_all_input_value_callback_configuration.
    def get_all_input_value_callback_configuration
      check_validity

      send_request FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, [], '', 13, 'L ?'
    end

    # The first parameter is the desired state of the channel (*true* means output *high*
    # and *false* means output *low*). The second parameter indicates the time that
    # the channel should hold the state.
    # 
    # If this function is called with the parameters (true, 1500):
    # The channel will turn on and in 1.5s it will turn off again.
    # 
    # A PWM for the selected channel will be aborted if this function is called.
    # 
    # A monoflop can be used as a failsafe mechanism. For example: Lets assume you
    # have a RS485 bus and a IO-4 Bricklet 2.0 is connected to one of the slave
    # stacks. You can now call this function every second, with a time parameter
    # of two seconds. The channel will be *high* all the time. If now the RS485
    # connection is lost, the channel will turn *low* in at most two seconds.
    def set_monoflop(channel, value, time)
      check_validity

      send_request FUNCTION_SET_MONOFLOP, [channel, value, time], 'C ? L', 8, ''
    end

    # Returns (for the given channel) the current value and the time as set by
    # BrickletIO4V2#set_monoflop as well as the remaining time until the value flips.
    # 
    # If the timer is not running currently, the remaining time will be returned
    # as 0.
    def get_monoflop(channel)
      check_validity

      send_request FUNCTION_GET_MONOFLOP, [channel], 'C', 17, '? L L'
    end

    # Returns the current value of the edge counter for the selected channel. You can
    # configure the edges that are counted with BrickletIO4V2#set_edge_count_configuration.
    # 
    # If you set the reset counter to *true*, the count is set back to 0
    # directly after it is read.
    # 
    # .. note::
    #  Calling this function is only allowed for channels configured as input.
    def get_edge_count(channel, reset_counter)
      check_validity

      send_request FUNCTION_GET_EDGE_COUNT, [channel, reset_counter], 'C ?', 12, 'L'
    end

    # Configures the edge counter for a specific channel.
    # 
    # The edge type parameter configures if rising edges, falling edges or
    # both are counted if the channel is configured for input. Possible edge types are:
    # 
    # * 0 = rising
    # * 1 = falling
    # * 2 = both
    # 
    # Configuring an edge counter resets its value to 0.
    # 
    # If you don't know what any of this means, just leave it at default. The
    # default configuration is very likely OK for you.
    # 
    # .. note::
    #  Calling this function is only allowed for channels configured as input.
    def set_edge_count_configuration(channel, edge_type, debounce)
      check_validity

      send_request FUNCTION_SET_EDGE_COUNT_CONFIGURATION, [channel, edge_type, debounce], 'C C C', 8, ''
    end

    # Returns the edge type and debounce time for the selected channel as set by
    # BrickletIO4V2#set_edge_count_configuration.
    # 
    # .. note::
    #  Calling this function is only allowed for channels configured as input.
    def get_edge_count_configuration(channel)
      check_validity

      send_request FUNCTION_GET_EDGE_COUNT_CONFIGURATION, [channel], 'C', 10, 'C C'
    end

    # Activates a PWM for the given channel.
    # 
    # You need to set the channel to output before you call this function, otherwise it will
    # report an invalid parameter error. To turn the PWM off again, you can set the frequency to 0 or any other
    # function that changes a value of the channel (e.g. BrickletIO4V2#set_selected_value).
    # 
    # A running monoflop timer for the given channel will be aborted if this function
    # is called.
    def set_pwm_configuration(channel, frequency, duty_cycle)
      check_validity

      send_request FUNCTION_SET_PWM_CONFIGURATION, [channel, frequency, duty_cycle], 'C L S', 8, ''
    end

    # Returns the PWM configuration as set by BrickletIO4V2#set_pwm_configuration.
    def get_pwm_configuration(channel)
      check_validity

      send_request FUNCTION_GET_PWM_CONFIGURATION, [channel], 'C', 14, 'L S'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletIO4V2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletIO4V2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletIO4V2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletIO4V2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
