# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Controls up to 2048 RGB(W) LEDs
  class BrickletLEDStripV2 < Device
    DEVICE_IDENTIFIER = 2103 # :nodoc:
    DEVICE_DISPLAY_NAME = 'LED Strip Bricklet 2.0' # :nodoc:

    # This callback is triggered directly after a new frame render is started.
    # The parameter is the number of LEDs in that frame.
    # 
    # You should send the data for the next frame directly after this callback
    # was triggered.
    # 
    # For an explanation of the general approach see BrickletLEDStripV2#set_led_values.
    CALLBACK_FRAME_STARTED = 6

    FUNCTION_SET_LED_VALUES_LOW_LEVEL = 1 # :nodoc:
    FUNCTION_GET_LED_VALUES_LOW_LEVEL = 2 # :nodoc:
    FUNCTION_SET_FRAME_DURATION = 3 # :nodoc:
    FUNCTION_GET_FRAME_DURATION = 4 # :nodoc:
    FUNCTION_GET_SUPPLY_VOLTAGE = 5 # :nodoc:
    FUNCTION_SET_CLOCK_FREQUENCY = 7 # :nodoc:
    FUNCTION_GET_CLOCK_FREQUENCY = 8 # :nodoc:
    FUNCTION_SET_CHIP_TYPE = 9 # :nodoc:
    FUNCTION_GET_CHIP_TYPE = 10 # :nodoc:
    FUNCTION_SET_CHANNEL_MAPPING = 11 # :nodoc:
    FUNCTION_GET_CHANNEL_MAPPING = 12 # :nodoc:
    FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION = 13 # :nodoc:
    FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION = 14 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    CHIP_TYPE_WS2801 = 2801 # :nodoc:
    CHIP_TYPE_WS2811 = 2811 # :nodoc:
    CHIP_TYPE_WS2812 = 2812 # :nodoc:
    CHIP_TYPE_LPD8806 = 8806 # :nodoc:
    CHIP_TYPE_APA102 = 102 # :nodoc:
    CHANNEL_MAPPING_RGB = 6 # :nodoc:
    CHANNEL_MAPPING_RBG = 9 # :nodoc:
    CHANNEL_MAPPING_BRG = 33 # :nodoc:
    CHANNEL_MAPPING_BGR = 36 # :nodoc:
    CHANNEL_MAPPING_GRB = 18 # :nodoc:
    CHANNEL_MAPPING_GBR = 24 # :nodoc:
    CHANNEL_MAPPING_RGBW = 27 # :nodoc:
    CHANNEL_MAPPING_RGWB = 30 # :nodoc:
    CHANNEL_MAPPING_RBGW = 39 # :nodoc:
    CHANNEL_MAPPING_RBWG = 45 # :nodoc:
    CHANNEL_MAPPING_RWGB = 54 # :nodoc:
    CHANNEL_MAPPING_RWBG = 57 # :nodoc:
    CHANNEL_MAPPING_GRWB = 78 # :nodoc:
    CHANNEL_MAPPING_GRBW = 75 # :nodoc:
    CHANNEL_MAPPING_GBWR = 108 # :nodoc:
    CHANNEL_MAPPING_GBRW = 99 # :nodoc:
    CHANNEL_MAPPING_GWBR = 120 # :nodoc:
    CHANNEL_MAPPING_GWRB = 114 # :nodoc:
    CHANNEL_MAPPING_BRGW = 135 # :nodoc:
    CHANNEL_MAPPING_BRWG = 141 # :nodoc:
    CHANNEL_MAPPING_BGRW = 147 # :nodoc:
    CHANNEL_MAPPING_BGWR = 156 # :nodoc:
    CHANNEL_MAPPING_BWRG = 177 # :nodoc:
    CHANNEL_MAPPING_BWGR = 180 # :nodoc:
    CHANNEL_MAPPING_WRBG = 201 # :nodoc:
    CHANNEL_MAPPING_WRGB = 198 # :nodoc:
    CHANNEL_MAPPING_WGBR = 216 # :nodoc:
    CHANNEL_MAPPING_WGRB = 210 # :nodoc:
    CHANNEL_MAPPING_WBGR = 228 # :nodoc:
    CHANNEL_MAPPING_WBRG = 225 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_LED_VALUES_LOW_LEVEL] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_LED_VALUES_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FRAME_DURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_FRAME_DURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SUPPLY_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CLOCK_FREQUENCY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CLOCK_FREQUENCY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHIP_TYPE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHIP_TYPE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CHANNEL_MAPPING] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CHANNEL_MAPPING] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_FRAME_STARTED] = [10, 'S']

      @ipcon.add_device self
    end

    # Sets the RGB(W) values for the LEDs starting from *index*.
    # You can set at most 2048 RGB values or 1536 RGBW values (6144 byte each).
    # 
    # To make the colors show correctly you need to configure the chip type
    # (see BrickletLEDStripV2#set_chip_type) and a channel mapping (see BrickletLEDStripV2#set_channel_mapping)
    # according to the connected LEDs.
    # 
    # If the channel mapping has 3 colors, you need to give the data in the sequence
    # RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
    # sequence RGBWRGBWRGBW...
    # 
    # The data is double buffered and the colors will be transfered to the
    # LEDs when the next frame duration ends (see BrickletLEDStripV2#set_frame_duration).
    # 
    # Generic approach:
    # 
    # * Set the frame duration to a value that represents the number of frames per
    #   second you want to achieve.
    # * Set all of the LED colors for one frame.
    # * Wait for the CALLBACK_FRAME_STARTED callback.
    # * Set all of the LED colors for next frame.
    # * Wait for the CALLBACK_FRAME_STARTED callback.
    # * And so on.
    # 
    # This approach ensures that you can change the LED colors with a fixed frame rate.
    def set_led_values_low_level(index, value_length, value_chunk_offset, value_chunk_data)
      check_validity

      send_request FUNCTION_SET_LED_VALUES_LOW_LEVEL, [index, value_length, value_chunk_offset, value_chunk_data], 'S S S C58', 8, ''
    end

    # Returns *length* RGB(W) values starting from the
    # given *index*.
    # 
    # If the channel mapping has 3 colors, you will get the data in the sequence
    # RGBRGBRGB... if the channel mapping has 4 colors you will get the data in the
    # sequence RGBWRGBWRGBW...
    # (assuming you start at an index divisible by 3 (RGB) or 4 (RGBW)).
    def get_led_values_low_level(index, length)
      check_validity

      send_request FUNCTION_GET_LED_VALUES_LOW_LEVEL, [index, length], 'S S', 72, 'S S C60'
    end

    # Sets the frame duration.
    # 
    # Example: If you want to achieve 20 frames per second, you should
    # set the frame duration to 50ms (50ms * 20 = 1 second).
    # 
    # For an explanation of the general approach see BrickletLEDStripV2#set_led_values.
    # 
    # Default value: 100ms (10 frames per second).
    def set_frame_duration(duration)
      check_validity

      send_request FUNCTION_SET_FRAME_DURATION, [duration], 'S', 8, ''
    end

    # Returns the frame duration as set by BrickletLEDStripV2#set_frame_duration.
    def get_frame_duration
      check_validity

      send_request FUNCTION_GET_FRAME_DURATION, [], '', 10, 'S'
    end

    # Returns the current supply voltage of the LEDs.
    def get_supply_voltage
      check_validity

      send_request FUNCTION_GET_SUPPLY_VOLTAGE, [], '', 10, 'S'
    end

    # Sets the frequency of the clock.
    # 
    # The Bricklet will choose the nearest achievable frequency, which may
    # be off by a few Hz. You can get the exact frequency that is used by
    # calling BrickletLEDStripV2#get_clock_frequency.
    # 
    # If you have problems with flickering LEDs, they may be bits flipping. You
    # can fix this by either making the connection between the LEDs and the
    # Bricklet shorter or by reducing the frequency.
    # 
    # With a decreasing frequency your maximum frames per second will decrease
    # too.
    def set_clock_frequency(frequency)
      check_validity

      send_request FUNCTION_SET_CLOCK_FREQUENCY, [frequency], 'L', 8, ''
    end

    # Returns the currently used clock frequency as set by BrickletLEDStripV2#set_clock_frequency.
    def get_clock_frequency
      check_validity

      send_request FUNCTION_GET_CLOCK_FREQUENCY, [], '', 12, 'L'
    end

    # Sets the type of the LED driver chip. We currently support the chips
    # 
    # * WS2801,
    # * WS2811,
    # * WS2812 / SK6812 / NeoPixel RGB,
    # * SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812),
    # * WS2813 / WS2815 (Chip Type = WS2812)
    # * LPD8806 and
    # * APA102 / DotStar.
    def set_chip_type(chip)
      check_validity

      send_request FUNCTION_SET_CHIP_TYPE, [chip], 'S', 8, ''
    end

    # Returns the currently used chip type as set by BrickletLEDStripV2#set_chip_type.
    def get_chip_type
      check_validity

      send_request FUNCTION_GET_CHIP_TYPE, [], '', 10, 'S'
    end

    # Sets the channel mapping for the connected LEDs.
    # 
    # If the mapping has 4 colors, the function BrickletLEDStripV2#set_led_values expects 4
    # values per pixel and if the mapping has 3 colors it expects 3 values per pixel.
    # 
    # The function always expects the order RGB(W). The connected LED driver chips
    # might have their 3 or 4 channels in a different order. For example, the WS2801
    # chips typically use BGR order, then WS2812 chips typically use GRB order and
    # the APA102 chips typically use WBGR order.
    # 
    # The APA102 chips are special. They have three 8-bit channels for RGB
    # and an additional 5-bit channel for the overall brightness of the RGB LED
    # making them 4-channel chips. Internally the brightness channel is the first
    # channel, therefore one of the Wxyz channel mappings should be used. Then
    # the W channel controls the brightness.
    def set_channel_mapping(mapping)
      check_validity

      send_request FUNCTION_SET_CHANNEL_MAPPING, [mapping], 'C', 8, ''
    end

    # Returns the currently used channel mapping as set by BrickletLEDStripV2#set_channel_mapping.
    def get_channel_mapping
      check_validity

      send_request FUNCTION_GET_CHANNEL_MAPPING, [], '', 9, 'C'
    end

    # Enables/disables the CALLBACK_FRAME_STARTED callback.
    def set_frame_started_callback_configuration(enable)
      check_validity

      send_request FUNCTION_SET_FRAME_STARTED_CALLBACK_CONFIGURATION, [enable], '?', 8, ''
    end

    # Returns the configuration as set by
    # BrickletLEDStripV2#set_frame_started_callback_configuration.
    def get_frame_started_callback_configuration
      check_validity

      send_request FUNCTION_GET_FRAME_STARTED_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletLEDStripV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletLEDStripV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletLEDStripV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletLEDStripV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Sets the RGB(W) values for the LEDs starting from *index*.
    # You can set at most 2048 RGB values or 1536 RGBW values (6144 byte each).
    # 
    # To make the colors show correctly you need to configure the chip type
    # (see BrickletLEDStripV2#set_chip_type) and a channel mapping (see BrickletLEDStripV2#set_channel_mapping)
    # according to the connected LEDs.
    # 
    # If the channel mapping has 3 colors, you need to give the data in the sequence
    # RGBRGBRGB... if the channel mapping has 4 colors you need to give data in the
    # sequence RGBWRGBWRGBW...
    # 
    # The data is double buffered and the colors will be transfered to the
    # LEDs when the next frame duration ends (see BrickletLEDStripV2#set_frame_duration).
    # 
    # Generic approach:
    # 
    # * Set the frame duration to a value that represents the number of frames per
    #   second you want to achieve.
    # * Set all of the LED colors for one frame.
    # * Wait for the CALLBACK_FRAME_STARTED callback.
    # * Set all of the LED colors for next frame.
    # * Wait for the CALLBACK_FRAME_STARTED callback.
    # * And so on.
    # 
    # This approach ensures that you can change the LED colors with a fixed frame rate.
    def set_led_values(index, value)
      if value.length > 65535
        raise ArgumentError, 'Value can be at most 65535 items long'
      end

      value_length = value.length
      value_chunk_offset = 0

      if value_length == 0
        value_chunk_data = [0] * 58
        ret = set_led_values_low_level index, value_length, value_chunk_offset, value_chunk_data
      else
        ret = nil # assigned in block

        @stream_mutex.synchronize {
          while value_chunk_offset < value_length
            value_chunk_data = value[value_chunk_offset, 58]

            if value_chunk_data.length < 58
              value_chunk_data += [0] * (58 - value_chunk_data.length)
            end

            ret = set_led_values_low_level index, value_length, value_chunk_offset, value_chunk_data
            value_chunk_offset += 58
          end
        }
      end

      ret
    end

    # Returns *length* RGB(W) values starting from the
    # given *index*.
    # 
    # If the channel mapping has 3 colors, you will get the data in the sequence
    # RGBRGBRGB... if the channel mapping has 4 colors you will get the data in the
    # sequence RGBWRGBWRGBW...
    # (assuming you start at an index divisible by 3 (RGB) or 4 (RGBW)).
    def get_led_values(index, length)
      value_length = nil # assigned in block
      value_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = get_led_values_low_level index, length
        value_length = ret[0]
        value_chunk_offset = ret[1]
        value_out_of_sync = value_chunk_offset != 0
        value_data = ret[2]

        while not value_out_of_sync and value_data.length < value_length
          ret = get_led_values_low_level index, length
          value_length = ret[0]
          value_chunk_offset = ret[1]
          value_out_of_sync = value_chunk_offset != value_data.length
          value_data += ret[2]
        end

        if value_out_of_sync # discard remaining stream to bring it back in-sync
          while value_chunk_offset + 60 < value_length
            ret = get_led_values_low_level index, length
            value_length = ret[0]
            value_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Value stream is out-of-sync'
        end
      }

      value_data[0, value_length]
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
