# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Communicates with up 64 1-Wire devices
  class BrickletOneWire < Device
    DEVICE_IDENTIFIER = 2123 # :nodoc:
    DEVICE_DISPLAY_NAME = 'One Wire Bricklet' # :nodoc:

    FUNCTION_SEARCH_BUS_LOW_LEVEL = 1 # :nodoc:
    FUNCTION_RESET_BUS = 2 # :nodoc:
    FUNCTION_WRITE = 3 # :nodoc:
    FUNCTION_READ = 4 # :nodoc:
    FUNCTION_WRITE_COMMAND = 5 # :nodoc:
    FUNCTION_SET_COMMUNICATION_LED_CONFIG = 6 # :nodoc:
    FUNCTION_GET_COMMUNICATION_LED_CONFIG = 7 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    STATUS_OK = 0 # :nodoc:
    STATUS_BUSY = 1 # :nodoc:
    STATUS_NO_PRESENCE = 2 # :nodoc:
    STATUS_TIMEOUT = 3 # :nodoc:
    STATUS_ERROR = 4 # :nodoc:
    COMMUNICATION_LED_CONFIG_OFF = 0 # :nodoc:
    COMMUNICATION_LED_CONFIG_ON = 1 # :nodoc:
    COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SEARCH_BUS_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET_BUS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_WRITE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_READ] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_WRITE_COMMAND] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_COMMUNICATION_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_COMMUNICATION_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


      @ipcon.add_device self
    end

    # Returns a list of up to 64 identifiers of the connected 1-Wire devices.
    # Each identifier is 64-bit and consists of 8-bit family code, 48-bit ID and
    # 8-bit CRC.
    # 
    # To get these identifiers the Bricklet runs the
    # `SEARCH ROM algorithm <https://www.maximintegrated.com/en/app-notes/index.mvp/id/187>`__,
    # as defined by Maxim.
    def search_bus_low_level
      check_validity

      send_request FUNCTION_SEARCH_BUS_LOW_LEVEL, [], '', 69, 'S S Q7 C'
    end

    # Resets the bus with the 1-Wire reset operation.
    def reset_bus
      check_validity

      send_request FUNCTION_RESET_BUS, [], '', 9, 'C'
    end

    # Writes a byte of data to the 1-Wire bus.
    def write(data)
      check_validity

      send_request FUNCTION_WRITE, [data], 'C', 9, 'C'
    end

    # Reads a byte of data from the 1-Wire bus.
    def read
      check_validity

      send_request FUNCTION_READ, [], '', 10, 'C C'
    end

    # Writes a command to the 1-Wire device with the given identifier. You can obtain
    # the identifier by calling BrickletOneWire#search_bus. The MATCH ROM operation is used to
    # write the command.
    # 
    # If you only have one device connected or want to broadcast to all devices
    # you can set the identifier to 0. In this case the SKIP ROM operation is used to
    # write the command.
    def write_command(identifier, command)
      check_validity

      send_request FUNCTION_WRITE_COMMAND, [identifier, command], 'Q C', 9, 'C'
    end

    # Sets the communication LED configuration. By default the LED shows 1-wire
    # communication traffic by flickering.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is off.
    def set_communication_led_config(config)
      check_validity

      send_request FUNCTION_SET_COMMUNICATION_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletOneWire#set_communication_led_config
    def get_communication_led_config
      check_validity

      send_request FUNCTION_GET_COMMUNICATION_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletOneWire#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletOneWire#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletOneWire#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletOneWire#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Returns a list of up to 64 identifiers of the connected 1-Wire devices.
    # Each identifier is 64-bit and consists of 8-bit family code, 48-bit ID and
    # 8-bit CRC.
    # 
    # To get these identifiers the Bricklet runs the
    # `SEARCH ROM algorithm <https://www.maximintegrated.com/en/app-notes/index.mvp/id/187>`__,
    # as defined by Maxim.
    def search_bus
      ret = nil # assigned in block
      identifier_length = nil # assigned in block
      identifier_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = search_bus_low_level
        identifier_length = ret[0]
        identifier_chunk_offset = ret[1]
        identifier_out_of_sync = identifier_chunk_offset != 0
        identifier_data = ret[2]

        while not identifier_out_of_sync and identifier_data.length < identifier_length
          ret = search_bus_low_level
          identifier_length = ret[0]
          identifier_chunk_offset = ret[1]
          identifier_out_of_sync = identifier_chunk_offset != identifier_data.length
          identifier_data += ret[2]
        end

        if identifier_out_of_sync # discard remaining stream to bring it back in-sync
          while identifier_chunk_offset + 7 < identifier_length
            ret = search_bus_low_level
            identifier_length = ret[0]
            identifier_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Identifier stream is out-of-sync'
        end
      }

      [identifier_data[0, identifier_length], ret[3]]
    end

  end
end
