# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # 433MHz receiver for outdoor weather station
  class BrickletOutdoorWeather < Device
    DEVICE_IDENTIFIER = 288 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Outdoor Weather Bricklet' # :nodoc:

    # Reports the station data every time a new data packet is received.
    # See BrickletOutdoorWeather#get_station_data for information about the data.
    # 
    # For each station the callback will be triggered about every 45 seconds.
    # 
    # Turn the callback on/off with BrickletOutdoorWeather#set_station_callback_configuration
    # (by default it is turned off).
    CALLBACK_STATION_DATA = 9

    # Reports the sensor data every time a new data packet is received.
    # See BrickletOutdoorWeather#get_sensor_data for information about the data.
    # 
    # For each sensor the callback will be called about every 45 seconds.
    # 
    # Turn the callback on/off with BrickletOutdoorWeather#set_sensor_callback_configuration
    # (by default it is turned off).
    CALLBACK_SENSOR_DATA = 10

    FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL = 1 # :nodoc:
    FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL = 2 # :nodoc:
    FUNCTION_GET_STATION_DATA = 3 # :nodoc:
    FUNCTION_GET_SENSOR_DATA = 4 # :nodoc:
    FUNCTION_SET_STATION_CALLBACK_CONFIGURATION = 5 # :nodoc:
    FUNCTION_GET_STATION_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION = 8 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    WIND_DIRECTION_N = 0 # :nodoc:
    WIND_DIRECTION_NNE = 1 # :nodoc:
    WIND_DIRECTION_NE = 2 # :nodoc:
    WIND_DIRECTION_ENE = 3 # :nodoc:
    WIND_DIRECTION_E = 4 # :nodoc:
    WIND_DIRECTION_ESE = 5 # :nodoc:
    WIND_DIRECTION_SE = 6 # :nodoc:
    WIND_DIRECTION_SSE = 7 # :nodoc:
    WIND_DIRECTION_S = 8 # :nodoc:
    WIND_DIRECTION_SSW = 9 # :nodoc:
    WIND_DIRECTION_SW = 10 # :nodoc:
    WIND_DIRECTION_WSW = 11 # :nodoc:
    WIND_DIRECTION_W = 12 # :nodoc:
    WIND_DIRECTION_WNW = 13 # :nodoc:
    WIND_DIRECTION_NW = 14 # :nodoc:
    WIND_DIRECTION_NNW = 15 # :nodoc:
    WIND_DIRECTION_ERROR = 255 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_STATION_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SENSOR_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_STATION_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_STATION_DATA] = [26, 'C s C L L L C ?']
      @callback_formats[CALLBACK_SENSOR_DATA] = [12, 'C s C']

      @ipcon.add_device self
    end

    # Returns the identifiers (number between 0 and 255) of all `stations
    # <https://www.tinkerforge.com/en/shop/accessories/sensors/outdoor-weather-station-ws-6147.html>`__
    # that have been seen since the startup of the Bricklet.
    # 
    # Each station gives itself a random identifier on first startup.
    # 
    # Since firmware version 2.0.2 a station is removed from the list if no data was received for
    # 12 hours.
    def get_station_identifiers_low_level
      check_validity

      send_request FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL, [], '', 72, 'S S C60'
    end

    # Returns the identifiers (number between 0 and 255) of all `sensors
    # <https://www.tinkerforge.com/en/shop/accessories/sensors/temperature-humidity-sensor-th-6148.html>`__
    # that have been seen since the startup of the Bricklet.
    # 
    # Each sensor gives itself a random identifier on first startup.
    # 
    # Since firmware version 2.0.2 a sensor is removed from the list if no data was received for
    # 12 hours.
    def get_sensor_identifiers_low_level
      check_validity

      send_request FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL, [], '', 72, 'S S C60'
    end

    # Returns the last received data for a station with the given identifier.
    # Call BrickletOutdoorWeather#get_station_identifiers for a list of all available identifiers.
    # 
    # The return values are:
    # 
    # * Temperature,
    # * Humidity,
    # * Wind Speed,
    # * Gust Speed,
    # * Rain Fall,
    # * Wind Direction,
    # * Battery Low (true if battery is low) and
    # * Last Change (seconds since the reception of this data).
    def get_station_data(identifier)
      check_validity

      send_request FUNCTION_GET_STATION_DATA, [identifier], 'C', 27, 's C L L L C ? S'
    end

    # Returns the last measured data for a sensor with the given identifier.
    # Call BrickletOutdoorWeather#get_sensor_identifiers for a list of all available identifiers.
    # 
    # The return values are:
    # 
    # * Temperature,
    # * Humidity and
    # * Last Change (seconds since the last reception of data).
    def get_sensor_data(identifier)
      check_validity

      send_request FUNCTION_GET_SENSOR_DATA, [identifier], 'C', 13, 's C S'
    end

    # Turns callback for station data on or off.
    def set_station_callback_configuration(enable_callback)
      check_validity

      send_request FUNCTION_SET_STATION_CALLBACK_CONFIGURATION, [enable_callback], '?', 8, ''
    end

    # Returns the configuration as set by BrickletOutdoorWeather#set_station_callback_configuration.
    def get_station_callback_configuration
      check_validity

      send_request FUNCTION_GET_STATION_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Turns callback for sensor data on or off.
    def set_sensor_callback_configuration(enable_callback)
      check_validity

      send_request FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION, [enable_callback], '?', 8, ''
    end

    # Returns the configuration as set by BrickletOutdoorWeather#set_sensor_callback_configuration.
    def get_sensor_callback_configuration
      check_validity

      send_request FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION, [], '', 9, '?'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletOutdoorWeather#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletOutdoorWeather#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletOutdoorWeather#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletOutdoorWeather#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Returns the identifiers (number between 0 and 255) of all `stations
    # <https://www.tinkerforge.com/en/shop/accessories/sensors/outdoor-weather-station-ws-6147.html>`__
    # that have been seen since the startup of the Bricklet.
    # 
    # Each station gives itself a random identifier on first startup.
    # 
    # Since firmware version 2.0.2 a station is removed from the list if no data was received for
    # 12 hours.
    def get_station_identifiers
      identifiers_length = nil # assigned in block
      identifiers_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = get_station_identifiers_low_level
        identifiers_length = ret[0]
        identifiers_chunk_offset = ret[1]
        identifiers_out_of_sync = identifiers_chunk_offset != 0
        identifiers_data = ret[2]

        while not identifiers_out_of_sync and identifiers_data.length < identifiers_length
          ret = get_station_identifiers_low_level
          identifiers_length = ret[0]
          identifiers_chunk_offset = ret[1]
          identifiers_out_of_sync = identifiers_chunk_offset != identifiers_data.length
          identifiers_data += ret[2]
        end

        if identifiers_out_of_sync # discard remaining stream to bring it back in-sync
          while identifiers_chunk_offset + 60 < identifiers_length
            ret = get_station_identifiers_low_level
            identifiers_length = ret[0]
            identifiers_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Identifiers stream is out-of-sync'
        end
      }

      identifiers_data[0, identifiers_length]
    end

    # Returns the identifiers (number between 0 and 255) of all `sensors
    # <https://www.tinkerforge.com/en/shop/accessories/sensors/temperature-humidity-sensor-th-6148.html>`__
    # that have been seen since the startup of the Bricklet.
    # 
    # Each sensor gives itself a random identifier on first startup.
    # 
    # Since firmware version 2.0.2 a sensor is removed from the list if no data was received for
    # 12 hours.
    def get_sensor_identifiers
      identifiers_length = nil # assigned in block
      identifiers_data = nil # assigned in block

      @stream_mutex.synchronize {
        ret = get_sensor_identifiers_low_level
        identifiers_length = ret[0]
        identifiers_chunk_offset = ret[1]
        identifiers_out_of_sync = identifiers_chunk_offset != 0
        identifiers_data = ret[2]

        while not identifiers_out_of_sync and identifiers_data.length < identifiers_length
          ret = get_sensor_identifiers_low_level
          identifiers_length = ret[0]
          identifiers_chunk_offset = ret[1]
          identifiers_out_of_sync = identifiers_chunk_offset != identifiers_data.length
          identifiers_data += ret[2]
        end

        if identifiers_out_of_sync # discard remaining stream to bring it back in-sync
          while identifiers_chunk_offset + 60 < identifiers_length
            ret = get_sensor_identifiers_low_level
            identifiers_length = ret[0]
            identifiers_chunk_offset = ret[1]
          end

          raise StreamOutOfSyncException, 'Identifiers stream is out-of-sync'
        end
      }

      identifiers_data[0, identifiers_length]
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
