# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Creates beep and alarm with configurable volume and frequency
  class BrickletPiezoSpeakerV2 < Device
    DEVICE_IDENTIFIER = 2145 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Piezo Speaker Bricklet 2.0' # :nodoc:

    # This callback is triggered if a beep set by BrickletPiezoSpeakerV2#set_beep is finished
    CALLBACK_BEEP_FINISHED = 7

    # This callback is triggered if a alarm set by BrickletPiezoSpeakerV2#set_alarm is finished
    CALLBACK_ALARM_FINISHED = 8

    FUNCTION_SET_BEEP = 1 # :nodoc:
    FUNCTION_GET_BEEP = 2 # :nodoc:
    FUNCTION_SET_ALARM = 3 # :nodoc:
    FUNCTION_GET_ALARM = 4 # :nodoc:
    FUNCTION_UPDATE_VOLUME = 5 # :nodoc:
    FUNCTION_UPDATE_FREQUENCY = 6 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    BEEP_DURATION_OFF = 0 # :nodoc:
    BEEP_DURATION_INFINITE = 4294967295 # :nodoc:
    ALARM_DURATION_OFF = 0 # :nodoc:
    ALARM_DURATION_INFINITE = 4294967295 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_BEEP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_BEEP] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALARM] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_ALARM] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_UPDATE_VOLUME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_UPDATE_FREQUENCY] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_BEEP_FINISHED] = [8, '']
      @callback_formats[CALLBACK_ALARM_FINISHED] = [8, '']

      @ipcon.add_device self
    end

    # Beeps with the given frequency and volume for the duration.
    # 
    # A duration of 0 stops the current beep if any is ongoing.
    # A duration of 4294967295 results in an infinite beep.
    def set_beep(frequency, volume, duration)
      check_validity

      send_request FUNCTION_SET_BEEP, [frequency, volume, duration], 'S C L', 8, ''
    end

    # Returns the last beep settings as set by BrickletPiezoSpeakerV2#set_beep. If a beep is currently
    # running it also returns the remaining duration of the beep.
    # 
    # If the frequency or volume is updated during a beep (with BrickletPiezoSpeakerV2#update_frequency
    # or BrickletPiezoSpeakerV2#update_volume) this function returns the updated value.
    def get_beep
      check_validity

      send_request FUNCTION_GET_BEEP, [], '', 19, 'S C L L'
    end

    # Creates an alarm (a tone that goes back and force between two specified frequencies).
    # 
    # The following parameters can be set:
    # 
    # * Start Frequency: Start frequency of the alarm.
    # * End Frequency: End frequency of the alarm.
    # * Step Size: Size of one step of the sweep between the start/end frequencies.
    # * Step Delay: Delay between two steps (duration of time that one tone is used in a sweep).
    # * Duration: Duration of the alarm.
    # 
    # A duration of 0 stops the current alarm if any is ongoing.
    # A duration of 4294967295 results in an infinite alarm.
    # 
    # Below you can find two sets of example settings that you can try out. You can use
    # these as a starting point to find an alarm signal that suits your application.
    # 
    # Example 1: 10 seconds of loud annoying fast alarm
    # 
    # * Start Frequency = 800
    # * End Frequency = 2000
    # * Step Size = 10
    # * Step Delay = 1
    # * Volume = 10
    # * Duration = 10000
    # 
    # Example 2: 10 seconds of soft siren sound with slow build-up
    # 
    # * Start Frequency = 250
    # * End Frequency = 750
    # * Step Size = 1
    # * Step Delay = 5
    # * Volume = 0
    # * Duration = 10000
    # 
    # The following conditions must be met:
    # 
    # * Start Frequency: has to be smaller than end frequency
    # * End Frequency: has to be bigger than start frequency
    # * Step Size: has to be small enough to fit into the frequency range
    # * Step Delay: has to be small enough to fit into the duration
    def set_alarm(start_frequency, end_frequency, step_size, step_delay, volume, duration)
      check_validity

      send_request FUNCTION_SET_ALARM, [start_frequency, end_frequency, step_size, step_delay, volume, duration], 'S S S S C L', 8, ''
    end

    # Returns the last alarm settings as set by BrickletPiezoSpeakerV2#set_alarm. If an alarm is currently
    # running it also returns the remaining duration of the alarm as well as the
    # current frequency of the alarm.
    # 
    # If the volume is updated during an alarm (with BrickletPiezoSpeakerV2#update_volume)
    # this function returns the updated value.
    def get_alarm
      check_validity

      send_request FUNCTION_GET_ALARM, [], '', 27, 'S S S S C L L S'
    end

    # Updates the volume of an ongoing beep or alarm.
    def update_volume(volume)
      check_validity

      send_request FUNCTION_UPDATE_VOLUME, [volume], 'C', 8, ''
    end

    # Updates the frequency of an ongoing beep.
    def update_frequency(frequency)
      check_validity

      send_request FUNCTION_UPDATE_FREQUENCY, [frequency], 'S', 8, ''
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletPiezoSpeakerV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletPiezoSpeakerV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletPiezoSpeakerV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletPiezoSpeakerV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
