# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Battery-backed real-time clock
  class BrickletRealTimeClockV2 < Device
    DEVICE_IDENTIFIER = 2106 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Real-Time Clock Bricklet 2.0' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletRealTimeClockV2#set_date_time_callback_configuration. The parameters are the
    # same as for BrickletRealTimeClockV2#get_date_time.
    CALLBACK_DATE_TIME = 10

    # This callback is triggered every time the current date and time matches the
    # configured alarm (see BrickletRealTimeClockV2#set_alarm). The parameters are the same
    # as for BrickletRealTimeClockV2#get_date_time.
    CALLBACK_ALARM = 11

    FUNCTION_SET_DATE_TIME = 1 # :nodoc:
    FUNCTION_GET_DATE_TIME = 2 # :nodoc:
    FUNCTION_GET_TIMESTAMP = 3 # :nodoc:
    FUNCTION_SET_OFFSET = 4 # :nodoc:
    FUNCTION_GET_OFFSET = 5 # :nodoc:
    FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION = 6 # :nodoc:
    FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION = 7 # :nodoc:
    FUNCTION_SET_ALARM = 8 # :nodoc:
    FUNCTION_GET_ALARM = 9 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    WEEKDAY_MONDAY = 1 # :nodoc:
    WEEKDAY_TUESDAY = 2 # :nodoc:
    WEEKDAY_WEDNESDAY = 3 # :nodoc:
    WEEKDAY_THURSDAY = 4 # :nodoc:
    WEEKDAY_FRIDAY = 5 # :nodoc:
    WEEKDAY_SATURDAY = 6 # :nodoc:
    WEEKDAY_SUNDAY = 7 # :nodoc:
    ALARM_MATCH_DISABLED = -1 # :nodoc:
    ALARM_INTERVAL_DISABLED = -1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_DATE_TIME] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_DATE_TIME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TIMESTAMP] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_OFFSET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_OFFSET] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALARM] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALARM] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_DATE_TIME] = [25, 'S C C C C C C C q']
      @callback_formats[CALLBACK_ALARM] = [25, 'S C C C C C C C q']

      @ipcon.add_device self
    end

    # Sets the current date (including weekday) and the current time.
    # 
    # If the backup battery is installed then the real-time clock keeps date and
    # time even if the Bricklet is not powered by a Brick.
    # 
    # The real-time clock handles leap year and inserts the 29th of February
    # accordingly. But leap seconds, time zones and daylight saving time are not
    # handled.
    def set_date_time(year, month, day, hour, minute, second, centisecond, weekday)
      check_validity

      send_request FUNCTION_SET_DATE_TIME, [year, month, day, hour, minute, second, centisecond, weekday], 'S C C C C C C C', 8, ''
    end

    # Returns the current date (including weekday) and the current time of the
    # real-time.
    # 
    # The timestamp represents the current date and the the current time of the
    # real-time clock converted to milliseconds and is an offset to 2000-01-01 00:00:00.0000.
    def get_date_time
      check_validity

      send_request FUNCTION_GET_DATE_TIME, [], '', 25, 'S C C C C C C C q'
    end

    # Returns the current date and the time of the real-time clock converted to
    # milliseconds. The timestamp has an effective resolution of hundredths of a
    # second and is an offset to 2000-01-01 00:00:00.0000.
    def get_timestamp
      check_validity

      send_request FUNCTION_GET_TIMESTAMP, [], '', 16, 'q'
    end

    # Sets the offset the real-time clock should compensate for in 2.17 ppm steps
    # between -277.76 ppm (-128) and +275.59 ppm (127).
    # 
    # The real-time clock time can deviate from the actual time due to the frequency
    # deviation of its 32.768 kHz crystal. Even without compensation (factory
    # default) the resulting time deviation should be at most ±20 ppm (±52.6
    # seconds per month).
    # 
    # This deviation can be calculated by comparing the same duration measured by the
    # real-time clock (``rtc_duration``) an accurate reference clock
    # (``ref_duration``).
    # 
    # For best results the configured offset should be set to 0 ppm first and then a
    # duration of at least 6 hours should be measured.
    # 
    # The new offset (``new_offset``) can be calculated from the currently configured
    # offset (``current_offset``) and the measured durations as follow::
    # 
    #   new_offset = current_offset - round(1000000 * (rtc_duration - ref_duration) / rtc_duration / 2.17)
    # 
    # If you want to calculate the offset, then we recommend using the calibration
    # dialog in Brick Viewer, instead of doing it manually.
    # 
    # The offset is saved in the EEPROM of the Bricklet and only needs to be
    # configured once.
    def set_offset(offset)
      check_validity

      send_request FUNCTION_SET_OFFSET, [offset], 'c', 8, ''
    end

    # Returns the offset as set by BrickletRealTimeClockV2#set_offset.
    def get_offset
      check_validity

      send_request FUNCTION_GET_OFFSET, [], '', 9, 'c'
    end

    # Sets the period with which the CALLBACK_DATE_TIME callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_date_time_callback_configuration(period)
      check_validity

      send_request FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION, [period], 'L', 8, ''
    end

    # Returns the period as set by BrickletRealTimeClockV2#set_date_time_callback_configuration.
    def get_date_time_callback_configuration
      check_validity

      send_request FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION, [], '', 12, 'L'
    end

    # Configures a repeatable alarm. The CALLBACK_ALARM callback is triggered if the
    # current date and time matches the configured alarm.
    # 
    # Setting a parameter to -1 means that it should be disabled and doesn't take part
    # in the match. Setting all parameters to -1 disables the alarm completely.
    # 
    # For example, to make the alarm trigger every day at 7:30 AM it can be
    # configured as (-1, -1, 7, 30, -1, -1, -1). The hour is set to match 7 and the
    # minute is set to match 30. The alarm is triggered if all enabled parameters
    # match.
    # 
    # The interval has a special role. It allows to make the alarm reconfigure itself.
    # This is useful if you need a repeated alarm that cannot be expressed by matching
    # the current date and time. For example, to make the alarm trigger every 23
    # seconds it can be configured as (-1, -1, -1, -1, -1, -1, 23). Internally the
    # Bricklet will take the current date and time, add 23 seconds to it and set the
    # result as its alarm. The first alarm will be triggered 23 seconds after the
    # call. Because the interval is not -1, the Bricklet will do the same again
    # internally, take the current date and time, add 23 seconds to it and set that
    # as its alarm. This results in a repeated alarm that triggers every 23 seconds.
    # 
    # The interval can also be used in combination with the other parameters. For
    # example, configuring the alarm as (-1, -1, 7, 30, -1, -1, 300) results in an
    # alarm that triggers every day at 7:30 AM and is then repeated every 5 minutes.
    def set_alarm(month, day, hour, minute, second, weekday, interval)
      check_validity

      send_request FUNCTION_SET_ALARM, [month, day, hour, minute, second, weekday, interval], 'c c c c c c l', 8, ''
    end

    # Returns the alarm configuration as set by BrickletRealTimeClockV2#set_alarm.
    def get_alarm
      check_validity

      send_request FUNCTION_GET_ALARM, [], '', 18, 'c c c c c c l'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletRealTimeClockV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletRealTimeClockV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletRealTimeClockV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletRealTimeClockV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
