# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Controls remote mains switches and receives signals from remotes
  class BrickletRemoteSwitchV2 < Device
    DEVICE_IDENTIFIER = 289 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Remote Switch Bricklet 2.0' # :nodoc:

    # This callback is triggered whenever the switching state changes
    # from busy to ready, see BrickletRemoteSwitchV2#get_switching_state.
    CALLBACK_SWITCHING_DONE = 2

    # Returns the house code, receiver code, switch state (on/off) and number of repeats for
    # remote type A.
    # 
    # The repeats are the number of received identical data packets. The longer the button is pressed,
    # the higher the repeat number. The callback is triggered with every repeat.
    # 
    # You have to enable the callback with BrickletRemoteSwitchV2#set_remote_configuration. The number
    # of repeats that you can set in the configuration is the minimum number of repeats that have
    # to be seen before the callback is triggered for the first time.
    CALLBACK_REMOTE_STATUS_A = 14

    # Returns the address (unique per remote), unit (button number), switch state (on/off) and number of repeats for
    # remote type B.
    # 
    # If the remote supports dimming the dim value is used instead of the switch state.
    # 
    # The repeats are the number of received identical data packets. The longer the button is pressed,
    # the higher the repeat number. The callback is triggered with every repeat.
    # 
    # You have to enable the callback with BrickletRemoteSwitchV2#set_remote_configuration. The number
    # of repeats that you can set in the configuration is the minimum number of repeats that have
    # to be seen before the callback is triggered for the first time.
    CALLBACK_REMOTE_STATUS_B = 15

    # Returns the system code, device code, switch state (on/off) and number of repeats for
    # remote type C.
    # 
    # The repeats are the number of received identical data packets. The longer the button is pressed,
    # the higher the repeat number. The callback is triggered with every repeat.
    # 
    # You have to enable the callback with BrickletRemoteSwitchV2#set_remote_configuration. The number
    # of repeats that you can set in the configuration is the minimum number of repeats that have
    # to be seen before the callback is triggered for the first time.
    CALLBACK_REMOTE_STATUS_C = 16

    FUNCTION_GET_SWITCHING_STATE = 1 # :nodoc:
    FUNCTION_SET_REPEATS = 3 # :nodoc:
    FUNCTION_GET_REPEATS = 4 # :nodoc:
    FUNCTION_SWITCH_SOCKET_A = 5 # :nodoc:
    FUNCTION_SWITCH_SOCKET_B = 6 # :nodoc:
    FUNCTION_DIM_SOCKET_B = 7 # :nodoc:
    FUNCTION_SWITCH_SOCKET_C = 8 # :nodoc:
    FUNCTION_SET_REMOTE_CONFIGURATION = 9 # :nodoc:
    FUNCTION_GET_REMOTE_CONFIGURATION = 10 # :nodoc:
    FUNCTION_GET_REMOTE_STATUS_A = 11 # :nodoc:
    FUNCTION_GET_REMOTE_STATUS_B = 12 # :nodoc:
    FUNCTION_GET_REMOTE_STATUS_C = 13 # :nodoc:
    FUNCTION_GET_SPITFP_ERROR_COUNT = 234 # :nodoc:
    FUNCTION_SET_BOOTLOADER_MODE = 235 # :nodoc:
    FUNCTION_GET_BOOTLOADER_MODE = 236 # :nodoc:
    FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237 # :nodoc:
    FUNCTION_WRITE_FIRMWARE = 238 # :nodoc:
    FUNCTION_SET_STATUS_LED_CONFIG = 239 # :nodoc:
    FUNCTION_GET_STATUS_LED_CONFIG = 240 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_WRITE_UID = 248 # :nodoc:
    FUNCTION_READ_UID = 249 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    SWITCHING_STATE_READY = 0 # :nodoc:
    SWITCHING_STATE_BUSY = 1 # :nodoc:
    SWITCH_TO_OFF = 0 # :nodoc:
    SWITCH_TO_ON = 1 # :nodoc:
    REMOTE_TYPE_A = 0 # :nodoc:
    REMOTE_TYPE_B = 1 # :nodoc:
    REMOTE_TYPE_C = 2 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER = 0 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE = 1 # :nodoc:
    BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3 # :nodoc:
    BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4 # :nodoc:
    BOOTLOADER_STATUS_OK = 0 # :nodoc:
    BOOTLOADER_STATUS_INVALID_MODE = 1 # :nodoc:
    BOOTLOADER_STATUS_NO_CHANGE = 2 # :nodoc:
    BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3 # :nodoc:
    BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4 # :nodoc:
    BOOTLOADER_STATUS_CRC_MISMATCH = 5 # :nodoc:
    STATUS_LED_CONFIG_OFF = 0 # :nodoc:
    STATUS_LED_CONFIG_ON = 1 # :nodoc:
    STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2 # :nodoc:
    STATUS_LED_CONFIG_SHOW_STATUS = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_SWITCHING_STATE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_REPEATS] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_REPEATS] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SWITCH_SOCKET_A] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SWITCH_SOCKET_B] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DIM_SOCKET_B] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SWITCH_SOCKET_C] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_REMOTE_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_REMOTE_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REMOTE_STATUS_A] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REMOTE_STATUS_B] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_REMOTE_STATUS_C] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_SPITFP_ERROR_COUNT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_BOOTLOADER_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WRITE_FIRMWARE_POINTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_FIRMWARE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_STATUS_LED_CONFIG] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_WRITE_UID] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_READ_UID] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_SWITCHING_DONE] = [8, '']
      @callback_formats[CALLBACK_REMOTE_STATUS_A] = [13, 'C C C S']
      @callback_formats[CALLBACK_REMOTE_STATUS_B] = [17, 'L C C C S']
      @callback_formats[CALLBACK_REMOTE_STATUS_C] = [13, 'k C C S']

      @ipcon.add_device self
    end

    # Returns the current switching state. If the current state is busy, the
    # Bricklet is currently sending a code to switch a socket. It will not
    # accept any calls of switch socket functions until the state changes to ready.
    # 
    # How long the switching takes is dependent on the number of repeats, see
    # BrickletRemoteSwitchV2#set_repeats.
    def get_switching_state
      check_validity

      send_request FUNCTION_GET_SWITCHING_STATE, [], '', 9, 'C'
    end

    # Sets the number of times the code is sent when one of the Switch Socket
    # functions is called. The repeats basically correspond to the amount of time
    # that a button of the remote is pressed.
    # 
    # Some dimmers are controlled by the length of a button pressed,
    # this can be simulated by increasing the repeats.
    def set_repeats(repeats)
      check_validity

      send_request FUNCTION_SET_REPEATS, [repeats], 'C', 8, ''
    end

    # Returns the number of repeats as set by BrickletRemoteSwitchV2#set_repeats.
    def get_repeats
      check_validity

      send_request FUNCTION_GET_REPEATS, [], '', 9, 'C'
    end

    # To switch a type A socket you have to give the house code, receiver code and the
    # state (on or off) you want to switch to.
    # 
    # A detailed description on how you can figure out the house and receiver code
    # can be found :ref:`here <remote_switch_bricklet_type_a_house_and_receiver_code>`.
    def switch_socket_a(house_code, receiver_code, switch_to)
      check_validity

      send_request FUNCTION_SWITCH_SOCKET_A, [house_code, receiver_code, switch_to], 'C C C', 8, ''
    end

    # To switch a type B socket you have to give the address, unit and the state
    # (on or off) you want to switch to.
    # 
    # To switch all devices with the same address use 255 for the unit.
    # 
    # A detailed description on how you can teach a socket the address and unit can
    # be found :ref:`here <remote_switch_bricklet_type_b_address_and_unit>`.
    def switch_socket_b(address, unit, switch_to)
      check_validity

      send_request FUNCTION_SWITCH_SOCKET_B, [address, unit, switch_to], 'L C C', 8, ''
    end

    # To control a type B dimmer you have to give the address, unit and the
    # dim value you want to set the dimmer to.
    # 
    # A detailed description on how you can teach a dimmer the address and unit can
    # be found :ref:`here <remote_switch_bricklet_type_b_address_and_unit>`.
    def dim_socket_b(address, unit, dim_value)
      check_validity

      send_request FUNCTION_DIM_SOCKET_B, [address, unit, dim_value], 'L C C', 8, ''
    end

    # To switch a type C socket you have to give the system code, device code and the
    # state (on or off) you want to switch to.
    # 
    # A detailed description on how you can figure out the system and device code
    # can be found :ref:`here <remote_switch_bricklet_type_c_system_and_device_code>`.
    def switch_socket_c(system_code, device_code, switch_to)
      check_validity

      send_request FUNCTION_SWITCH_SOCKET_C, [system_code, device_code, switch_to], 'k C C', 8, ''
    end

    # Sets the configuration for **receiving** data from a remote of type A, B or C.
    # 
    # * Remote Type: A, B or C depending on the type of remote you want to receive.
    # * Minimum Repeats: The minimum number of repeated data packets until the callback
    #   is triggered (if enabled).
    # * Callback Enabled: Enable or disable callback (see CALLBACK_REMOTE_STATUS_A callback,
    #   CALLBACK_REMOTE_STATUS_B callback and CALLBACK_REMOTE_STATUS_C callback).
    def set_remote_configuration(remote_type, minimum_repeats, callback_enabled)
      check_validity

      send_request FUNCTION_SET_REMOTE_CONFIGURATION, [remote_type, minimum_repeats, callback_enabled], 'C S ?', 8, ''
    end

    # Returns the remote configuration as set by BrickletRemoteSwitchV2#set_remote_configuration
    def get_remote_configuration
      check_validity

      send_request FUNCTION_GET_REMOTE_CONFIGURATION, [], '', 12, 'C S ?'
    end

    # Returns the house code, receiver code, switch state (on/off) and number of
    # repeats for remote type A.
    # 
    # Repeats == 0 means there was no button press. Repeats >= 1 means there
    # was a button press with the specified house/receiver code. The repeats are the
    # number of received identical data packets. The longer the button is pressed,
    # the higher the repeat number.
    # 
    # Use the callback to get this data automatically when a button is pressed,
    # see BrickletRemoteSwitchV2#set_remote_configuration and CALLBACK_REMOTE_STATUS_A callback.
    def get_remote_status_a
      check_validity

      send_request FUNCTION_GET_REMOTE_STATUS_A, [], '', 13, 'C C C S'
    end

    # Returns the address (unique per remote), unit (button number), switch state
    # (on/off) and number of repeats for remote type B.
    # 
    # If the remote supports dimming the dim value is used instead of the switch state.
    # 
    # If repeats=0 there was no button press. If repeats >= 1 there
    # was a button press with the specified address/unit. The repeats are the number of received
    # identical data packets. The longer the button is pressed, the higher the repeat number.
    # 
    # Use the callback to get this data automatically when a button is pressed,
    # see BrickletRemoteSwitchV2#set_remote_configuration and CALLBACK_REMOTE_STATUS_B callback.
    def get_remote_status_b
      check_validity

      send_request FUNCTION_GET_REMOTE_STATUS_B, [], '', 17, 'L C C C S'
    end

    # Returns the system code, device code, switch state (on/off) and number of repeats for
    # remote type C.
    # 
    # If repeats=0 there was no button press. If repeats >= 1 there
    # was a button press with the specified system/device code. The repeats are the number of received
    # identical data packets. The longer the button is pressed, the higher the repeat number.
    # 
    # Use the callback to get this data automatically when a button is pressed,
    # see BrickletRemoteSwitchV2#set_remote_configuration and CALLBACK_REMOTE_STATUS_C callback.
    def get_remote_status_c
      check_validity

      send_request FUNCTION_GET_REMOTE_STATUS_C, [], '', 13, 'k C C S'
    end

    # Returns the error count for the communication between Brick and Bricklet.
    # 
    # The errors are divided into
    # 
    # * ACK checksum errors,
    # * message checksum errors,
    # * framing errors and
    # * overflow errors.
    # 
    # The errors counts are for errors that occur on the Bricklet side. All
    # Bricks have a similar function that returns the errors on the Brick side.
    def get_spitfp_error_count
      check_validity

      send_request FUNCTION_GET_SPITFP_ERROR_COUNT, [], '', 24, 'L L L L'
    end

    # Sets the bootloader mode and returns the status after the requested
    # mode change was instigated.
    # 
    # You can change from bootloader mode to firmware mode and vice versa. A change
    # from bootloader mode to firmware mode will only take place if the entry function,
    # device identifier and CRC are present and correct.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_bootloader_mode(mode)
      check_validity

      send_request FUNCTION_SET_BOOTLOADER_MODE, [mode], 'C', 9, 'C'
    end

    # Returns the current bootloader mode, see BrickletRemoteSwitchV2#set_bootloader_mode.
    def get_bootloader_mode
      check_validity

      send_request FUNCTION_GET_BOOTLOADER_MODE, [], '', 9, 'C'
    end

    # Sets the firmware pointer for BrickletRemoteSwitchV2#write_firmware. The pointer has
    # to be increased by chunks of size 64. The data is written to flash
    # every 4 chunks (which equals to one page of size 256).
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def set_write_firmware_pointer(pointer)
      check_validity

      send_request FUNCTION_SET_WRITE_FIRMWARE_POINTER, [pointer], 'L', 8, ''
    end

    # Writes 64 Bytes of firmware at the position as written by
    # BrickletRemoteSwitchV2#set_write_firmware_pointer before. The firmware is written
    # to flash every 4 chunks.
    # 
    # You can only write firmware in bootloader mode.
    # 
    # This function is used by Brick Viewer during flashing. It should not be
    # necessary to call it in a normal user program.
    def write_firmware(data)
      check_validity

      send_request FUNCTION_WRITE_FIRMWARE, [data], 'C64', 9, 'C'
    end

    # Sets the status LED configuration. By default the LED shows
    # communication traffic between Brick and Bricklet, it flickers once
    # for every 10 received data packets.
    # 
    # You can also turn the LED permanently on/off or show a heartbeat.
    # 
    # If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    def set_status_led_config(config)
      check_validity

      send_request FUNCTION_SET_STATUS_LED_CONFIG, [config], 'C', 8, ''
    end

    # Returns the configuration as set by BrickletRemoteSwitchV2#set_status_led_config
    def get_status_led_config
      check_validity

      send_request FUNCTION_GET_STATUS_LED_CONFIG, [], '', 9, 'C'
    end

    # Returns the temperature as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has bad
    # accuracy. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      check_validity

      send_request FUNCTION_GET_CHIP_TEMPERATURE, [], '', 10, 's'
    end

    # Calling this function will reset the Bricklet. All configurations
    # will be lost.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      check_validity

      send_request FUNCTION_RESET, [], '', 8, ''
    end

    # Writes a new UID into flash. If you want to set a new UID
    # you have to decode the Base58 encoded UID string into an
    # integer first.
    # 
    # We recommend that you use Brick Viewer to change the UID.
    def write_uid(uid)
      check_validity

      send_request FUNCTION_WRITE_UID, [uid], 'L', 8, ''
    end

    # Returns the current UID as an integer. Encode as
    # Base58 to get the usual string version.
    def read_uid
      check_validity

      send_request FUNCTION_READ_UID, [], '', 12, 'L'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
