# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2020-05-19.      #
#                                                           #
# Ruby Bindings Version 2.1.26                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

require_relative './ip_connection'

module Tinkerforge
  # Controls one RGB LED
  class BrickletRGBLED < Device
    DEVICE_IDENTIFIER = 271 # :nodoc:
    DEVICE_DISPLAY_NAME = 'RGB LED Bricklet' # :nodoc:

    FUNCTION_SET_RGB_VALUE = 1 # :nodoc:
    FUNCTION_GET_RGB_VALUE = 2 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:


    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_SET_RGB_VALUE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_RGB_VALUE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE


      @ipcon.add_device self
    end

    # Sets the *r*, *g* and *b* values for the LED.
    def set_rgb_value(r, g, b)
      check_validity

      send_request FUNCTION_SET_RGB_VALUE, [r, g, b], 'C C C', 8, ''
    end

    # Returns the *r*, *g* and *b* values of the LED as set by BrickletRGBLED#set_rgb_value.
    def get_rgb_value
      check_validity

      send_request FUNCTION_GET_RGB_VALUE, [], '', 11, 'C C C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    # The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    # connected to an :ref:`Isolator Bricklet <isolator_bricklet>` is always as
    # position 'z'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 33, 'Z8 Z8 k C3 C3 S'
    end

  end
end
